/*
* Handling game resize using transform.
*/
function GameResize(){
    
    this.doResize = function(){
        var windowWidth = window.innerWidth;
        var windowHeight = window.innerHeight;
        var scaleFactor;
        var viewGame = document.getElementById('gamePlayContainer');
        var viewHeader = document.getElementById('gameHeader');
        var viewFooter = document.getElementById('gameFooter');

        console.log("current window W : "+windowWidth + " : current window H : "+windowHeight);

        if((GAME_MAX_WIDTH/windowWidth) > (GAME_MAX_HEIGHT/windowHeight))
        {
            scaleFactor = (windowWidth / GAME_MAX_WIDTH);        
        }
        else 
        {
            scaleFactor = (windowHeight / GAME_MAX_HEIGHT);
        }    
        
        console.log("scaleFactor scaleFactor :: "+scaleFactor);
        viewGame.style.transform = "translate(-50%, -50%)"+"scale(" + scaleFactor + ")";  
        viewHeader.style.transform = "translate(-50%, -50%)"+"scale(" + scaleFactor + ")";
        viewFooter.style.transform = "translate(-50%, -50%)"+"scale(" + scaleFactor + ")";
        
        /* set footer at top of all device.
         * desc : jQuery('#gameHeader').offset().top  -> top gap size values in px
         *        (jQuery('#gameHeader').offset().top / windowHeight) -> Finding percentage value out of total inner height.
         *        ((jQuery('#gameHeader').offset().top / windowHeight) * 100) -> convert to percentage.
         *        50 - ((jQuery('#gameHeader').offset().top / windowHeight) * 100 -> reduce the percentage from transform value(50).
         * */        
        var _headerTop = ((jQuery('#gameHeader').offset().top / windowHeight) * 100);
        var _footerTop = ((jQuery('#gameFooter').offset().top / windowHeight) * 100);
        //var _gameTop = (((jQuery('#gamePlayContainer').offset().top - ((jQuery('#gameHeader').height()*scaleFactor))) / windowHeight) * 100);
        var _gameTop = ((jQuery('#gamePlayContainer').offset().top / windowHeight) * 100);
        
        viewHeader.style.top = (50 - _headerTop)+"%";                       
        viewFooter.style.top = (50 + _footerTop)+"%";
        viewGame.style.top = (50-_gameTop)+"%";
    };
}
var TEST_GAME_ALONE = false;//must set false when game go to relase

var GAME_MAX_WIDTH = 1920;
var GAME_MAX_HEIGHT = 1080;
var GAME_SCALE_FACTOR = 1;
var RESPONSE_TYPE_PLAYER = 'player';
var RESPONSE_TYPE_OPPONENT = 'opponent';
var RESPONSE_TYPE_COMMON = 'common';
var BET_TYPE_ANDAR = 'andar';
var BET_TYPE_BAHAR = 'bahar';
var USER_TOTAL_TIMER = 0;
var USER_WARNING_TIME = 0;
var USER_FREEZE_TIME = 0;
var TOTAL_SEAT = 5;

//enable following commented lines to run game alone
//var USER_SESSION_ID = "session:user:#2ZRZ1H4F4A6T1";
//var FOOTER_PLAYER_NAME = 'XXXXX';

var CURRENT_USER_SEAT_INDEX = 0;
var CURRENT_USER_ID = 0;
var ORIGINAL_SEAT_ORDER = [0,1,2,3,4];
var SHUFFLED_SEAT_ORDER = {};
var SEAT_INDEX = {};
var MIN_BET = 0;
var MAX_BET = 0;
var SERVER_URL; 
var OPPONENTS_SESSION_ID_LIST = {};
var PLAYERS_OBJ = {};
var IS_GAME_RUNING = false;
var IS_MY_TURN = false;
var IS_OPPONENT_PLAYER_SELECTED = false;
var OPPONENT_BET_USER_SESSIONID = null;
var IS_ENABLED_FEATURE_BET = false;
var IS_FUTUREBET_REQUEST_SENT = false;
var IS_PLAYER_WAIT_FOR_NEXT_ROUND = false;
var IS_PLAYER_CLICKED_LEAVE_TABLE = false;
var FORCED_GAME_TO_DISCONNECT = false;
var FEATURE_BET_SELECTED_SEAT_INDEX = -1;
var TABLE_ID = -1;//enable this while game release, set 10001 enable this to run game alone
var BET_TYPE = 1;
var GAME_TABLE_DETAILS = {};
var CURRENT_BET_OPTION_USER_SEATID = 1;
var CHAT_MSGS = ['Hello All','Welcome','I Won','Jaldi Khelo','Cool',
                 'Good Luck','Its your Day','Play Fast','You Lose'];
var START_ROUND_RESPONSE_OBJ = {};
var BUYIN_RESPONSE_OBJ = {};

/**
 * Server Response names
 */
var BUY_IN_RESPONSE = "BuyInResponse";
var INNER_LOBBY_RESPONSE = "InnerLobbyResponse";
var OPPONENT_PLAYERS_RESPONSE = "OpponentPlayersResponse";
var GAME_START_TIMER_RESPONSE = "GameStartTimerResponse";
var USER_TIMER_RESPONSE = "UserTimerResponse";
var REFRESH_RESPONSE = "RefreshResponse";
var BET_ACCEPT_RESPONSE = "BetAcceptResponse";
var FUTUREBET_ACCEPT_RESPONSE = "FutureBetAcceptResponse";
var GAME_CARD_PLAY_RESPONSE = "GameCardPlayResponse";
var START_ROUND_RESPONSE = "StartRoundResponse";
var LEAVE_GAME_RESPONSE = "LeaveGameResponse";
var CHAT_RESPONSE = "ChatResponse";
var BET_RETURN_RESPONSE = "BetReturnResponse";
var SKIP_TURN_RESPONSE = "SkipTurnResponse";
var BETS_INFO_RESPONSE ="BetsInfoResponse";
var WINNER_RESPONSE ="WinnerResponse";
var TIP_RESPONSE = "TipResponse";
var XP_RESPONSE = "xpResponse";
var DISCCONECT_RESPONSE = "DisconnectResponse";
var STORE_POPUP_RESPONSE = "ShowStorePopupResponse";
var DISCONNECT_TIMER_RESPONSE = "DisconnectTimerResponse";
var DIS_EXTRA_TIMER_RESPONSE = "DisconnectExtraTimerResponse";
//---bet logic keys for own---
var BALANCE = 0;
var TOTAL_ANDAR_BET = 0;
var TOTAL_BAHAR_BET = 0;
var TOTAL_BET = 0;
var TOTAL_OWN_ANDAR_BET = 0;
var TOTAL_OWN_BAHAR_BET = 0;
var TOTAL_OWN_BET = 0;
var CURRENT_SELECTED_CHIP = 0;

//---bet logic keys for opponent---
var OPPONENT_BET_BALANCE = 0;

//---bet request object---
var CURRENT_SELECTED_SEAT_ID = 2;//for current palyer center seat
var BET_REQUEST_OBJ = {};
var BET_REQUEST_OBJ_KEY_ARR = [0,1,3,4];
var SELECTED_OPPONENT_BET_VARIANTTYPE = 1;//default bahar

//user timer variables
var USER_TIMER = {};
var CARD_DEAL_TIMER = null;
var TIMER_COUNT = 0;
var IS_USER_TIMER_RUNNING = false;
var IS_USER_DISTIMER_RUNNING = false;
var DISTIMER_COUNT = 0;
var DISCONNECT_TIMER = null;
/*
 * Common methods
 */

/**
 * to findout the object length
 * @param {type} obj
 * @returns {undefined}
 */
var objectLength = function(currentObj){
    var len = 0;
    for (var s in currentObj) {
        len++;
    }
    return len;
}
/*
 * name : animateResultCount
 * desc : Number increment animation.
*/
function animateResultCount(needanim,number,target,elem,text) {
    if(Number(target) === 0){
        $(elem).text(target);
        return;
    }else if(Number(number) == Number(target)){
        $(elem).text(target);
        return;
    }
    
    if(needanim){
        $(elem).prop('Counter',number).animate({
            Counter: target
        }, {
            duration: 200,
            easing: 'swing',
            step: function (now) {
                if(text === undefined){
                    $(elem).text(Math.ceil(now));
                }else{
                    $(elem).text(text + Math.ceil(now));
                }
            }
        });
    }else{
        if(text === undefined){
            $(elem).text(target);
        }else{
            $(elem).text(text + target);
        }
    }    
};
function Localization(){
    'use strict';
    
    this.getText = {
        "txt_welcome" :"Welcome",
        "popup_title_alert":"Alert",
        "not_enough_balance":"Not enough balance. Please buy chips",
        "wait_your_turn":"Please wait for your turn",
        "opp_bet_notavail":"Opponent bet not available",
        "own_bet_fail":"Your own bet failure, required minimum bet",
        "own_bet_return":"Your own bet return",
        "select_opponent_avatar":"Select opponent avatar to opponent bet",
        "bet_on_bahar":"Please place bet on your Bahar holder",
        "bet_on_andar":"Please place bet on your Andar holder",
        "max_bet_limit":"Maximum bet limit reached",
        "own_require_minbet":"Own bet required minimum bet amount",
        "own_bet_returned_tobalance":"Your own bet failure, own bet amount returned to balance",
        "invalid_bet":"Invalid bet amount",
        "bet_closed_drawbegin":"Bets closed and draw begins now.",
        "wait_for_opponent":"Please wait for opponent player",
        "start_your_bet":"House card is drawn. Start your bets now.",
        "player_bet_return":"Own bets returns to players",
        "loss_chip_collect":"Dealer collecting player's ",
        "leave_game":"Are you sure want to exit game ?",
        "extra_timer":"Extra timer",
        "disconnected":"Disconnected",
        "connected":"Connected"
    };
}
(function (factory) {

    if ( typeof define === 'function' && define.amd ) {

        // AMD. Register as an anonymous module.
        define([], factory);

    } else if ( typeof exports === 'object' ) {

        // Node/CommonJS
        module.exports = factory();

    } else {

        // Browser globals
        window.noUiSlider = factory();
    }

}(function( ){

	'use strict';

	var VERSION = '9.2.0';


	// Creates a node, adds it to target, returns the new node.
	function addNodeTo ( target, className ) {
		var div = document.createElement('div');
		addClass(div, className);
		target.appendChild(div);
		return div;
	}

	// Removes duplicates from an array.
	function unique ( array ) {
		return array.filter(function(a){
			return !this[a] ? this[a] = true : false;
		}, {});
	}

	// Round a value to the closest 'to'.
	function closest ( value, to ) {
		return Math.round(value / to) * to;
	}

	// Current position of an element relative to the document.
	function offset ( elem, orientation ) {

	var rect = elem.getBoundingClientRect(),
		doc = elem.ownerDocument,
		docElem = doc.documentElement,
		pageOffset = getPageOffset();

		// getBoundingClientRect contains left scroll in Chrome on Android.
		// I haven't found a feature detection that proves this. Worst case
		// scenario on mis-match: the 'tap' feature on horizontal sliders breaks.
		if ( /webkit.*Chrome.*Mobile/i.test(navigator.userAgent) ) {
			pageOffset.x = 0;
		}

		return orientation ? (rect.top + pageOffset.y - docElem.clientTop) : (rect.left + pageOffset.x - docElem.clientLeft);
	}

	// Checks whether a value is numerical.
	function isNumeric ( a ) {
		return typeof a === 'number' && !isNaN( a ) && isFinite( a );
	}

	// Sets a class and removes it after [duration] ms.
	function addClassFor ( element, className, duration ) {
		if (duration > 0) {
		addClass(element, className);
			setTimeout(function(){
				removeClass(element, className);
			}, duration);
		}
	}

	// Limits a value to 0 - 100
	function limit ( a ) {
		return Math.max(Math.min(a, 100), 0);
	}

	// Wraps a variable as an array, if it isn't one yet.
	// Note that an input array is returned by reference!
	function asArray ( a ) {
		return Array.isArray(a) ? a : [a];
	}

	// Counts decimals
	function countDecimals ( numStr ) {
		numStr = String(numStr);
		var pieces = numStr.split(".");
		return pieces.length > 1 ? pieces[1].length : 0;
	}

	// http://youmightnotneedjquery.com/#add_class
	function addClass ( el, className ) {
		if ( el.classList ) {
			el.classList.add(className);
		} else {
			el.className += ' ' + className;
		}
	}

	// http://youmightnotneedjquery.com/#remove_class
	function removeClass ( el, className ) {
		if ( el.classList ) {
			el.classList.remove(className);
		} else {
			el.className = el.className.replace(new RegExp('(^|\\b)' + className.split(' ').join('|') + '(\\b|$)', 'gi'), ' ');
		}
	}

	// https://plainjs.com/javascript/attributes/adding-removing-and-testing-for-classes-9/
	function hasClass ( el, className ) {
		return el.classList ? el.classList.contains(className) : new RegExp('\\b' + className + '\\b').test(el.className);
	}

	// https://developer.mozilla.org/en-US/docs/Web/API/Window/scrollY#Notes
	function getPageOffset ( ) {

		var supportPageOffset = window.pageXOffset !== undefined,
			isCSS1Compat = ((document.compatMode || "") === "CSS1Compat"),
			x = supportPageOffset ? window.pageXOffset : isCSS1Compat ? document.documentElement.scrollLeft : document.body.scrollLeft,
			y = supportPageOffset ? window.pageYOffset : isCSS1Compat ? document.documentElement.scrollTop : document.body.scrollTop;

		return {
			x: x,
			y: y
		};
	}

	// we provide a function to compute constants instead
	// of accessing window.* as soon as the module needs it
	// so that we do not compute anything if not needed
	function getActions ( ) {

		// Determine the events to bind. IE11 implements pointerEvents without
		// a prefix, which breaks compatibility with the IE10 implementation.
		return window.navigator.pointerEnabled ? {
			start: 'pointerdown',
			move: 'pointermove',
			end: 'pointerup'
		} : window.navigator.msPointerEnabled ? {
			start: 'MSPointerDown',
			move: 'MSPointerMove',
			end: 'MSPointerUp'
		} : {
			start: 'mousedown touchstart',
			move: 'mousemove touchmove',
			end: 'mouseup touchend'
		};
	}


// Value calculation

	// Determine the size of a sub-range in relation to a full range.
	function subRangeRatio ( pa, pb ) {
		return (100 / (pb - pa));
	}

	// (percentage) How many percent is this value of this range?
	function fromPercentage ( range, value ) {
		return (value * 100) / ( range[1] - range[0] );
	}

	// (percentage) Where is this value on this range?
	function toPercentage ( range, value ) {
		return fromPercentage( range, range[0] < 0 ?
			value + Math.abs(range[0]) :
				value - range[0] );
	}

	// (value) How much is this percentage on this range?
	function isPercentage ( range, value ) {
		return ((value * ( range[1] - range[0] )) / 100) + range[0];
	}


// Range conversion

	function getJ ( value, arr ) {

		var j = 1;

		while ( value >= arr[j] ){
			j += 1;
		}

		return j;
	}

	// (percentage) Input a value, find where, on a scale of 0-100, it applies.
	function toStepping ( xVal, xPct, value ) {

		if ( value >= xVal.slice(-1)[0] ){
			return 100;
		}

		var j = getJ( value, xVal ), va, vb, pa, pb;

		va = xVal[j-1];
		vb = xVal[j];
		pa = xPct[j-1];
		pb = xPct[j];

		return pa + (toPercentage([va, vb], value) / subRangeRatio (pa, pb));
	}

	// (value) Input a percentage, find where it is on the specified range.
	function fromStepping ( xVal, xPct, value ) {

		// There is no range group that fits 100
		if ( value >= 100 ){
			return xVal.slice(-1)[0];
		}

		var j = getJ( value, xPct ), va, vb, pa, pb;

		va = xVal[j-1];
		vb = xVal[j];
		pa = xPct[j-1];
		pb = xPct[j];

		return isPercentage([va, vb], (value - pa) * subRangeRatio (pa, pb));
	}

	// (percentage) Get the step that applies at a certain value.
	function getStep ( xPct, xSteps, snap, value ) {

		if ( value === 100 ) {
			return value;
		}

		var j = getJ( value, xPct ), a, b;

		// If 'snap' is set, steps are used as fixed points on the slider.
		if ( snap ) {

			a = xPct[j-1];
			b = xPct[j];

			// Find the closest position, a or b.
			if ((value - a) > ((b-a)/2)){
				return b;
			}

			return a;
		}

		if ( !xSteps[j-1] ){
			return value;
		}

		return xPct[j-1] + closest(
			value - xPct[j-1],
			xSteps[j-1]
		);
	}


// Entry parsing

	function handleEntryPoint ( index, value, that ) {

		var percentage;

		// Wrap numerical input in an array.
		if ( typeof value === "number" ) {
			value = [value];
		}

		// Reject any invalid input, by testing whether value is an array.
		if ( Object.prototype.toString.call( value ) !== '[object Array]' ){
			throw new Error("noUiSlider (" + VERSION + "): 'range' contains invalid value.");
		}

		// Covert min/max syntax to 0 and 100.
		if ( index === 'min' ) {
			percentage = 0;
		} else if ( index === 'max' ) {
			percentage = 100;
		} else {
			percentage = parseFloat( index );
		}

		// Check for correct input.
		if ( !isNumeric( percentage ) || !isNumeric( value[0] ) ) {
			throw new Error("noUiSlider (" + VERSION + "): 'range' value isn't numeric.");
		}

		// Store values.
		that.xPct.push( percentage );
		that.xVal.push( value[0] );

		// NaN will evaluate to false too, but to keep
		// logging clear, set step explicitly. Make sure
		// not to override the 'step' setting with false.
		if ( !percentage ) {
			if ( !isNaN( value[1] ) ) {
				that.xSteps[0] = value[1];
			}
		} else {
			that.xSteps.push( isNaN(value[1]) ? false : value[1] );
		}

		that.xHighestCompleteStep.push(0);
	}

	function handleStepPoint ( i, n, that ) {

		// Ignore 'false' stepping.
		if ( !n ) {
			return true;
		}

		// Factor to range ratio
		that.xSteps[i] = fromPercentage([
			 that.xVal[i]
			,that.xVal[i+1]
		], n) / subRangeRatio (
			that.xPct[i],
			that.xPct[i+1] );

		var totalSteps = (that.xVal[i+1] - that.xVal[i]) / that.xNumSteps[i];
		var highestStep = Math.ceil(Number(totalSteps.toFixed(3)) - 1);
		var step = that.xVal[i] + (that.xNumSteps[i] * highestStep);

		that.xHighestCompleteStep[i] = step;
	}


// Interface

	// The interface to Spectrum handles all direction-based
	// conversions, so the above values are unaware.

	function Spectrum ( entry, snap, direction, singleStep ) {

		this.xPct = [];
		this.xVal = [];
		this.xSteps = [ singleStep || false ];
		this.xNumSteps = [ false ];
		this.xHighestCompleteStep = [];

		this.snap = snap;
		this.direction = direction;

		var index, ordered = [ /* [0, 'min'], [1, '50%'], [2, 'max'] */ ];

		// Map the object keys to an array.
		for ( index in entry ) {
			if ( entry.hasOwnProperty(index) ) {
				ordered.push([entry[index], index]);
			}
		}

		// Sort all entries by value (numeric sort).
		if ( ordered.length && typeof ordered[0][0] === "object" ) {
			ordered.sort(function(a, b) { return a[0][0] - b[0][0]; });
		} else {
			ordered.sort(function(a, b) { return a[0] - b[0]; });
		}


		// Convert all entries to subranges.
		for ( index = 0; index < ordered.length; index++ ) {
			handleEntryPoint(ordered[index][1], ordered[index][0], this);
		}

		// Store the actual step values.
		// xSteps is sorted in the same order as xPct and xVal.
		this.xNumSteps = this.xSteps.slice(0);

		// Convert all numeric steps to the percentage of the subrange they represent.
		for ( index = 0; index < this.xNumSteps.length; index++ ) {
			handleStepPoint(index, this.xNumSteps[index], this);
		}
	}

	Spectrum.prototype.getMargin = function ( value ) {

		var step = this.xNumSteps[0];

		if ( step && ((value / step) % 1) !== 0 ) {
			throw new Error("noUiSlider (" + VERSION + "): 'limit', 'margin' and 'padding' must be divisible by step.");
		}

		return this.xPct.length === 2 ? fromPercentage(this.xVal, value) : false;
	};

	Spectrum.prototype.toStepping = function ( value ) {

		value = toStepping( this.xVal, this.xPct, value );

		return value;
	};

	Spectrum.prototype.fromStepping = function ( value ) {

		return fromStepping( this.xVal, this.xPct, value );
	};

	Spectrum.prototype.getStep = function ( value ) {

		value = getStep(this.xPct, this.xSteps, this.snap, value );

		return value;
	};

	Spectrum.prototype.getNearbySteps = function ( value ) {

		var j = getJ(value, this.xPct);

		return {
			stepBefore: { startValue: this.xVal[j-2], step: this.xNumSteps[j-2], highestStep: this.xHighestCompleteStep[j-2] },
			thisStep: { startValue: this.xVal[j-1], step: this.xNumSteps[j-1], highestStep: this.xHighestCompleteStep[j-1] },
			stepAfter: { startValue: this.xVal[j-0], step: this.xNumSteps[j-0], highestStep: this.xHighestCompleteStep[j-0] }
		};
	};

	Spectrum.prototype.countStepDecimals = function () {
		var stepDecimals = this.xNumSteps.map(countDecimals);
		return Math.max.apply(null, stepDecimals);
 	};

	// Outside testing
	Spectrum.prototype.convert = function ( value ) {
		return this.getStep(this.toStepping(value));
	};

/*	Every input option is tested and parsed. This'll prevent
	endless validation in internal methods. These tests are
	structured with an item for every option available. An
	option can be marked as required by setting the 'r' flag.
	The testing function is provided with three arguments:
		- The provided value for the option;
		- A reference to the options object;
		- The name for the option;

	The testing function returns false when an error is detected,
	or true when everything is OK. It can also modify the option
	object, to make sure all values can be correctly looped elsewhere. */

	var defaultFormatter = { 'to': function( value ){
		return value !== undefined && value.toFixed(2);
	}, 'from': Number };

	function testStep ( parsed, entry ) {

		if ( !isNumeric( entry ) ) {
			throw new Error("noUiSlider (" + VERSION + "): 'step' is not numeric.");
		}

		// The step option can still be used to set stepping
		// for linear sliders. Overwritten if set in 'range'.
		parsed.singleStep = entry;
	}

	function testRange ( parsed, entry ) {

		// Filter incorrect input.
		if ( typeof entry !== 'object' || Array.isArray(entry) ) {
			throw new Error("noUiSlider (" + VERSION + "): 'range' is not an object.");
		}

		// Catch missing start or end.
		if ( entry.min === undefined || entry.max === undefined ) {
			throw new Error("noUiSlider (" + VERSION + "): Missing 'min' or 'max' in 'range'.");
		}

		// Catch equal start or end.
		if ( entry.min === entry.max ) {
			throw new Error("noUiSlider (" + VERSION + "): 'range' 'min' and 'max' cannot be equal.");
		}

		parsed.spectrum = new Spectrum(entry, parsed.snap, parsed.dir, parsed.singleStep);
	}

	function testStart ( parsed, entry ) {

		entry = asArray(entry);

		// Validate input. Values aren't tested, as the public .val method
		// will always provide a valid location.
		if ( !Array.isArray( entry ) || !entry.length ) {
			throw new Error("noUiSlider (" + VERSION + "): 'start' option is incorrect.");
		}

		// Store the number of handles.
		parsed.handles = entry.length;

		// When the slider is initialized, the .val method will
		// be called with the start options.
		parsed.start = entry;
	}

	function testSnap ( parsed, entry ) {

		// Enforce 100% stepping within subranges.
		parsed.snap = entry;

		if ( typeof entry !== 'boolean' ){
			throw new Error("noUiSlider (" + VERSION + "): 'snap' option must be a boolean.");
		}
	}

	function testAnimate ( parsed, entry ) {

		// Enforce 100% stepping within subranges.
		parsed.animate = entry;

		if ( typeof entry !== 'boolean' ){
			throw new Error("noUiSlider (" + VERSION + "): 'animate' option must be a boolean.");
		}
	}

	function testAnimationDuration ( parsed, entry ) {

		parsed.animationDuration = entry;

		if ( typeof entry !== 'number' ){
			throw new Error("noUiSlider (" + VERSION + "): 'animationDuration' option must be a number.");
		}
	}

	function testConnect ( parsed, entry ) {

		var connect = [false];
		var i;

		// Map legacy options
		if ( entry === 'lower' ) {
			entry = [true, false];
		}

		else if ( entry === 'upper' ) {
			entry = [false, true];
		}

		// Handle boolean options
		if ( entry === true || entry === false ) {

			for ( i = 1; i < parsed.handles; i++ ) {
				connect.push(entry);
			}

			connect.push(false);
		}

		// Reject invalid input
		else if ( !Array.isArray( entry ) || !entry.length || entry.length !== parsed.handles + 1 ) {
			throw new Error("noUiSlider (" + VERSION + "): 'connect' option doesn't match handle count.");
		}

		else {
			connect = entry;
		}

		parsed.connect = connect;
	}

	function testOrientation ( parsed, entry ) {

		// Set orientation to an a numerical value for easy
		// array selection.
		switch ( entry ){
		  case 'horizontal':
			parsed.ort = 0;
			break;
		  case 'vertical':
			parsed.ort = 1;
			break;
		  default:
			throw new Error("noUiSlider (" + VERSION + "): 'orientation' option is invalid.");
		}
	}

	function testMargin ( parsed, entry ) {

		if ( !isNumeric(entry) ){
			throw new Error("noUiSlider (" + VERSION + "): 'margin' option must be numeric.");
		}

		// Issue #582
		if ( entry === 0 ) {
			return;
		}

		parsed.margin = parsed.spectrum.getMargin(entry);

		if ( !parsed.margin ) {
			throw new Error("noUiSlider (" + VERSION + "): 'margin' option is only supported on linear sliders.");
		}
	}

	function testLimit ( parsed, entry ) {

		if ( !isNumeric(entry) ){
			throw new Error("noUiSlider (" + VERSION + "): 'limit' option must be numeric.");
		}

		parsed.limit = parsed.spectrum.getMargin(entry);

		if ( !parsed.limit || parsed.handles < 2 ) {
			throw new Error("noUiSlider (" + VERSION + "): 'limit' option is only supported on linear sliders with 2 or more handles.");
		}
	}

	function testPadding ( parsed, entry ) {

		if ( !isNumeric(entry) ){
			throw new Error("noUiSlider (" + VERSION + "): 'padding' option must be numeric.");
		}

		if ( entry === 0 ) {
			return;
		}

		parsed.padding = parsed.spectrum.getMargin(entry);

		if ( !parsed.padding ) {
			throw new Error("noUiSlider (" + VERSION + "): 'padding' option is only supported on linear sliders.");
		}

		if ( parsed.padding < 0 ) {
			throw new Error("noUiSlider (" + VERSION + "): 'padding' option must be a positive number.");
		}

		if ( parsed.padding >= 50 ) {
			throw new Error("noUiSlider (" + VERSION + "): 'padding' option must be less than half the range.");
		}
	}

	function testDirection ( parsed, entry ) {

		// Set direction as a numerical value for easy parsing.
		// Invert connection for RTL sliders, so that the proper
		// handles get the connect/background classes.
		switch ( entry ) {
		  case 'ltr':
			parsed.dir = 0;
			break;
		  case 'rtl':
			parsed.dir = 1;
			break;
		  default:
			throw new Error("noUiSlider (" + VERSION + "): 'direction' option was not recognized.");
		}
	}

	function testBehaviour ( parsed, entry ) {

		// Make sure the input is a string.
		if ( typeof entry !== 'string' ) {
			throw new Error("noUiSlider (" + VERSION + "): 'behaviour' must be a string containing options.");
		}

		// Check if the string contains any keywords.
		// None are required.
		var tap = entry.indexOf('tap') >= 0;
		var drag = entry.indexOf('drag') >= 0;
		var fixed = entry.indexOf('fixed') >= 0;
		var snap = entry.indexOf('snap') >= 0;
		var hover = entry.indexOf('hover') >= 0;

		if ( fixed ) {

			if ( parsed.handles !== 2 ) {
				throw new Error("noUiSlider (" + VERSION + "): 'fixed' behaviour must be used with 2 handles");
			}

			// Use margin to enforce fixed state
			testMargin(parsed, parsed.start[1] - parsed.start[0]);
		}

		parsed.events = {
			tap: tap || snap,
			drag: drag,
			fixed: fixed,
			snap: snap,
			hover: hover
		};
	}

	function testTooltips ( parsed, entry ) {

		if ( entry === false ) {
			return;
		}

		else if ( entry === true ) {

			parsed.tooltips = [];

			for ( var i = 0; i < parsed.handles; i++ ) {
				parsed.tooltips.push(true);
			}
		}

		else {

			parsed.tooltips = asArray(entry);

			if ( parsed.tooltips.length !== parsed.handles ) {
				throw new Error("noUiSlider (" + VERSION + "): must pass a formatter for all handles.");
			}

			parsed.tooltips.forEach(function(formatter){
				if ( typeof formatter !== 'boolean' && (typeof formatter !== 'object' || typeof formatter.to !== 'function') ) {
					throw new Error("noUiSlider (" + VERSION + "): 'tooltips' must be passed a formatter or 'false'.");
				}
			});
		}
	}

	function testFormat ( parsed, entry ) {

		parsed.format = entry;

		// Any object with a to and from method is supported.
		if ( typeof entry.to === 'function' && typeof entry.from === 'function' ) {
			return true;
		}

		throw new Error("noUiSlider (" + VERSION + "): 'format' requires 'to' and 'from' methods.");
	}

	function testCssPrefix ( parsed, entry ) {

		if ( entry !== undefined && typeof entry !== 'string' && entry !== false ) {
			throw new Error("noUiSlider (" + VERSION + "): 'cssPrefix' must be a string or `false`.");
		}

		parsed.cssPrefix = entry;
	}

	function testCssClasses ( parsed, entry ) {

		if ( entry !== undefined && typeof entry !== 'object' ) {
			throw new Error("noUiSlider (" + VERSION + "): 'cssClasses' must be an object.");
		}

		if ( typeof parsed.cssPrefix === 'string' ) {
			parsed.cssClasses = {};

			for ( var key in entry ) {
				if ( !entry.hasOwnProperty(key) ) { continue; }

				parsed.cssClasses[key] = parsed.cssPrefix + entry[key];
			}
		} else {
			parsed.cssClasses = entry;
		}
	}

	function testUseRaf ( parsed, entry ) {
		if ( entry === true || entry === false ) {
			parsed.useRequestAnimationFrame = entry;
		} else {
			throw new Error("noUiSlider (" + VERSION + "): 'useRequestAnimationFrame' option should be true (default) or false.");
		}
	}

	// Test all developer settings and parse to assumption-safe values.
	function testOptions ( options ) {

		// To prove a fix for #537, freeze options here.
		// If the object is modified, an error will be thrown.
		// Object.freeze(options);

		var parsed = {
			margin: 0,
			limit: 0,
			padding: 0,
			animate: true,
			animationDuration: 300,
			format: defaultFormatter
		};

		// Tests are executed in the order they are presented here.
		var tests = {
			'step': { r: false, t: testStep },
			'start': { r: true, t: testStart },
			'connect': { r: true, t: testConnect },
			'direction': { r: true, t: testDirection },
			'snap': { r: false, t: testSnap },
			'animate': { r: false, t: testAnimate },
			'animationDuration': { r: false, t: testAnimationDuration },
			'range': { r: true, t: testRange },
			'orientation': { r: false, t: testOrientation },
			'margin': { r: false, t: testMargin },
			'limit': { r: false, t: testLimit },
			'padding': { r: false, t: testPadding },
			'behaviour': { r: true, t: testBehaviour },
			'format': { r: false, t: testFormat },
			'tooltips': { r: false, t: testTooltips },
			'cssPrefix': { r: false, t: testCssPrefix },
			'cssClasses': { r: false, t: testCssClasses },
			'useRequestAnimationFrame': { r: false, t: testUseRaf }
		};

		var defaults = {
			'connect': false,
			'direction': 'ltr',
			'behaviour': 'tap',
			'orientation': 'horizontal',
			'cssPrefix' : 'noUi-',
			'cssClasses': {
				target: 'target',
				base: 'base',
				origin: 'origin',
				handle: 'handle',
				handleLower: 'handle-lower',
				handleUpper: 'handle-upper',
				horizontal: 'horizontal',
				vertical: 'vertical',
				background: 'background',
				connect: 'connect',
				ltr: 'ltr',
				rtl: 'rtl',
				draggable: 'draggable',
				drag: 'state-drag',
				tap: 'state-tap',
				active: 'active',
				tooltip: 'tooltip',
				pips: 'pips',
				pipsHorizontal: 'pips-horizontal',
				pipsVertical: 'pips-vertical',
				marker: 'marker',
				markerHorizontal: 'marker-horizontal',
				markerVertical: 'marker-vertical',
				markerNormal: 'marker-normal',
				markerLarge: 'marker-large',
				markerSub: 'marker-sub',
				value: 'value',
				valueHorizontal: 'value-horizontal',
				valueVertical: 'value-vertical',
				valueNormal: 'value-normal',
				valueLarge: 'value-large',
				valueSub: 'value-sub'
			},
			'useRequestAnimationFrame': true
		};

		// Run all options through a testing mechanism to ensure correct
		// input. It should be noted that options might get modified to
		// be handled properly. E.g. wrapping integers in arrays.
		Object.keys(tests).forEach(function( name ){

			// If the option isn't set, but it is required, throw an error.
			if ( options[name] === undefined && defaults[name] === undefined ) {

				if ( tests[name].r ) {
					throw new Error("noUiSlider (" + VERSION + "): '" + name + "' is required.");
				}

				return true;
			}

			tests[name].t( parsed, options[name] === undefined ? defaults[name] : options[name] );
		});

		// Forward pips options
		parsed.pips = options.pips;

		var styles = [['left', 'top'], ['right', 'bottom']];

		// Pre-define the styles.
		parsed.style = styles[parsed.dir][parsed.ort];
		parsed.styleOposite = styles[parsed.dir?0:1][parsed.ort];

		return parsed;
	}


function closure ( target, options, originalOptions ){

	var actions = getActions( );

	// All variables local to 'closure' are prefixed with 'scope_'
	var scope_Target = target;
	var scope_Locations = [];
	var scope_Base;
	var scope_Handles;
	var scope_HandleNumbers = [];
	var scope_ActiveHandle = false;
	var scope_Connects;
	var scope_Spectrum = options.spectrum;
	var scope_Values = [];
	var scope_Events = {};
	var scope_Self;


	// Append a origin to the base
	function addOrigin ( base, handleNumber ) {

		var origin = addNodeTo(base, options.cssClasses.origin);
		var handle = addNodeTo(origin, options.cssClasses.handle);

		handle.setAttribute('data-handle', handleNumber);

		if ( handleNumber === 0 ) {
			addClass(handle, options.cssClasses.handleLower);
		}

		else if ( handleNumber === options.handles - 1 ) {
			addClass(handle, options.cssClasses.handleUpper);
		}

		return origin;
	}

	// Insert nodes for connect elements
	function addConnect ( base, add ) {

		if ( !add ) {
			return false;
		}

		return addNodeTo(base, options.cssClasses.connect);
	}

	// Add handles to the slider base.
	function addElements ( connectOptions, base ) {

		scope_Handles = [];
		scope_Connects = [];

		scope_Connects.push(addConnect(base, connectOptions[0]));

		// [::::O====O====O====]
		// connectOptions = [0, 1, 1, 1]

		for ( var i = 0; i < options.handles; i++ ) {
			// Keep a list of all added handles.
			scope_Handles.push(addOrigin(base, i));
			scope_HandleNumbers[i] = i;
			scope_Connects.push(addConnect(base, connectOptions[i + 1]));
		}
	}

	// Initialize a single slider.
	function addSlider ( target ) {

		// Apply classes and data to the target.
		addClass(target, options.cssClasses.target);

		if ( options.dir === 0 ) {
			addClass(target, options.cssClasses.ltr);
		} else {
			addClass(target, options.cssClasses.rtl);
		}

		if ( options.ort === 0 ) {
			addClass(target, options.cssClasses.horizontal);
		} else {
			addClass(target, options.cssClasses.vertical);
		}

		scope_Base = addNodeTo(target, options.cssClasses.base);
	}


	function addTooltip ( handle, handleNumber ) {

		if ( !options.tooltips[handleNumber] ) {
			return false;
		}

		return addNodeTo(handle.firstChild, options.cssClasses.tooltip);
	}

	// The tooltips option is a shorthand for using the 'update' event.
	function tooltips ( ) {

		// Tooltips are added with options.tooltips in original order.
		var tips = scope_Handles.map(addTooltip);

		bindEvent('update', function(values, handleNumber, unencoded) {

			if ( !tips[handleNumber] ) {
				return;
			}

			var formattedValue = values[handleNumber];

			if ( options.tooltips[handleNumber] !== true ) {
				formattedValue = options.tooltips[handleNumber].to(unencoded[handleNumber]);
			}

			tips[handleNumber].innerHTML = formattedValue;
		});
	}


	function getGroup ( mode, values, stepped ) {

		// Use the range.
		if ( mode === 'range' || mode === 'steps' ) {
			return scope_Spectrum.xVal;
		}

		if ( mode === 'count' ) {

			if ( !values ) {
				throw new Error("noUiSlider (" + VERSION + "): 'values' required for mode 'count'.");
			}

			// Divide 0 - 100 in 'count' parts.
			var spread = ( 100 / (values - 1) );
			var v;
			var i = 0;

			values = [];

			// List these parts and have them handled as 'positions'.
			while ( (v = i++ * spread) <= 100 ) {
				values.push(v);
			}

			mode = 'positions';
		}

		if ( mode === 'positions' ) {

			// Map all percentages to on-range values.
			return values.map(function( value ){
				return scope_Spectrum.fromStepping( stepped ? scope_Spectrum.getStep( value ) : value );
			});
		}

		if ( mode === 'values' ) {

			// If the value must be stepped, it needs to be converted to a percentage first.
			if ( stepped ) {

				return values.map(function( value ){

					// Convert to percentage, apply step, return to value.
					return scope_Spectrum.fromStepping( scope_Spectrum.getStep( scope_Spectrum.toStepping( value ) ) );
				});

			}

			// Otherwise, we can simply use the values.
			return values;
		}
	}

	function generateSpread ( density, mode, group ) {

		function safeIncrement(value, increment) {
			// Avoid floating point variance by dropping the smallest decimal places.
			return (value + increment).toFixed(7) / 1;
		}

		var indexes = {};
		var firstInRange = scope_Spectrum.xVal[0];
		var lastInRange = scope_Spectrum.xVal[scope_Spectrum.xVal.length-1];
		var ignoreFirst = false;
		var ignoreLast = false;
		var prevPct = 0;

		// Create a copy of the group, sort it and filter away all duplicates.
		group = unique(group.slice().sort(function(a, b){ return a - b; }));

		// Make sure the range starts with the first element.
		if ( group[0] !== firstInRange ) {
			group.unshift(firstInRange);
			ignoreFirst = true;
		}

		// Likewise for the last one.
		if ( group[group.length - 1] !== lastInRange ) {
			group.push(lastInRange);
			ignoreLast = true;
		}

		group.forEach(function ( current, index ) {

			// Get the current step and the lower + upper positions.
			var step;
			var i;
			var q;
			var low = current;
			var high = group[index+1];
			var newPct;
			var pctDifference;
			var pctPos;
			var type;
			var steps;
			var realSteps;
			var stepsize;

			// When using 'steps' mode, use the provided steps.
			// Otherwise, we'll step on to the next subrange.
			if ( mode === 'steps' ) {
				step = scope_Spectrum.xNumSteps[ index ];
			}

			// Default to a 'full' step.
			if ( !step ) {
				step = high-low;
			}

			// Low can be 0, so test for false. If high is undefined,
			// we are at the last subrange. Index 0 is already handled.
			if ( low === false || high === undefined ) {
				return;
			}

			// Make sure step isn't 0, which would cause an infinite loop (#654)
			step = Math.max(step, 0.0000001);

			// Find all steps in the subrange.
			for ( i = low; i <= high; i = safeIncrement(i, step) ) {

				// Get the percentage value for the current step,
				// calculate the size for the subrange.
				newPct = scope_Spectrum.toStepping( i );
				pctDifference = newPct - prevPct;

				steps = pctDifference / density;
				realSteps = Math.round(steps);

				// This ratio represents the ammount of percentage-space a point indicates.
				// For a density 1 the points/percentage = 1. For density 2, that percentage needs to be re-devided.
				// Round the percentage offset to an even number, then divide by two
				// to spread the offset on both sides of the range.
				stepsize = pctDifference/realSteps;

				// Divide all points evenly, adding the correct number to this subrange.
				// Run up to <= so that 100% gets a point, event if ignoreLast is set.
				for ( q = 1; q <= realSteps; q += 1 ) {

					// The ratio between the rounded value and the actual size might be ~1% off.
					// Correct the percentage offset by the number of points
					// per subrange. density = 1 will result in 100 points on the
					// full range, 2 for 50, 4 for 25, etc.
					pctPos = prevPct + ( q * stepsize );
					indexes[pctPos.toFixed(5)] = ['x', 0];
				}

				// Determine the point type.
				type = (group.indexOf(i) > -1) ? 1 : ( mode === 'steps' ? 2 : 0 );

				// Enforce the 'ignoreFirst' option by overwriting the type for 0.
				if ( !index && ignoreFirst ) {
					type = 0;
				}

				if ( !(i === high && ignoreLast)) {
					// Mark the 'type' of this point. 0 = plain, 1 = real value, 2 = step value.
					indexes[newPct.toFixed(5)] = [i, type];
				}

				// Update the percentage count.
				prevPct = newPct;
			}
		});

		return indexes;
	}

	function addMarking ( spread, filterFunc, formatter ) {

		var element = document.createElement('div');
		var out = '';
		var valueSizeClasses = [
			options.cssClasses.valueNormal,
			options.cssClasses.valueLarge,
			options.cssClasses.valueSub
		];
		var markerSizeClasses = [
			options.cssClasses.markerNormal,
			options.cssClasses.markerLarge,
			options.cssClasses.markerSub
		];
		var valueOrientationClasses = [
			options.cssClasses.valueHorizontal,
			options.cssClasses.valueVertical
		];
		var markerOrientationClasses = [
			options.cssClasses.markerHorizontal,
			options.cssClasses.markerVertical
		];

		addClass(element, options.cssClasses.pips);
		addClass(element, options.ort === 0 ? options.cssClasses.pipsHorizontal : options.cssClasses.pipsVertical);

		function getClasses( type, source ){
			var a = source === options.cssClasses.value;
			var orientationClasses = a ? valueOrientationClasses : markerOrientationClasses;
			var sizeClasses = a ? valueSizeClasses : markerSizeClasses;

			return source + ' ' + orientationClasses[options.ort] + ' ' + sizeClasses[type];
		}

		function getTags( offset, source, values ) {
			return 'class="' + getClasses(values[1], source) + '" style="' + options.style + ': ' + offset + '%"';
		}

		function addSpread ( offset, values ){

			// Apply the filter function, if it is set.
			values[1] = (values[1] && filterFunc) ? filterFunc(values[0], values[1]) : values[1];

			// Add a marker for every point
			out += '<div ' + getTags(offset, options.cssClasses.marker, values) + '></div>';

			// Values are only appended for points marked '1' or '2'.
			if ( values[1] ) {
				out += '<div ' + getTags(offset, options.cssClasses.value, values) + '>' + formatter.to(values[0]) + '</div>';
			}
		}

		// Append all points.
		Object.keys(spread).forEach(function(a){
			addSpread(a, spread[a]);
		});

		element.innerHTML = out;

		return element;
	}

	function pips ( grid ) {

		var mode = grid.mode;
		var density = grid.density || 1;
		var filter = grid.filter || false;
		var values = grid.values || false;
		var stepped = grid.stepped || false;
		var group = getGroup( mode, values, stepped );
		var spread = generateSpread( density, mode, group );
		var format = grid.format || {
			to: Math.round
		};

		return scope_Target.appendChild(addMarking(
			spread,
			filter,
			format
		));
	}


	// Shorthand for base dimensions.
	function baseSize ( ) {
		var rect = scope_Base.getBoundingClientRect(), alt = 'offset' + ['Width', 'Height'][options.ort];
		return options.ort === 0 ? (rect.width||scope_Base[alt]) : (rect.height||scope_Base[alt]);
	}

	// Handler for attaching events trough a proxy.
	function attachEvent ( events, element, callback, data ) {

		// This function can be used to 'filter' events to the slider.
		// element is a node, not a nodeList

		var method = function ( e ){

			if ( scope_Target.hasAttribute('disabled') ) {
				return false;
			}

			// Stop if an active 'tap' transition is taking place.
			if ( hasClass(scope_Target, options.cssClasses.tap) ) {
				return false;
			}

			e = fixEvent(e, data.pageOffset);

			// Handle reject of multitouch
			if ( !e ) {
				return false;
			}

			// Ignore right or middle clicks on start #454
			if ( events === actions.start && e.buttons !== undefined && e.buttons > 1 ) {
				return false;
			}

			// Ignore right or middle clicks on start #454
			if ( data.hover && e.buttons ) {
				return false;
			}

			e.calcPoint = e.points[ options.ort ];

			// Call the event handler with the event [ and additional data ].
			callback ( e, data );
		};

		var methods = [];

		// Bind a closure on the target for every event type.
		events.split(' ').forEach(function( eventName ){
			element.addEventListener(eventName, method, false);
			methods.push([eventName, method]);
		});

		return methods;
	}

	// Provide a clean event with standardized offset values.
	function fixEvent ( e, pageOffset ) {

		// Prevent scrolling and panning on touch events, while
		// attempting to slide. The tap event also depends on this.
		e.preventDefault();

		// Filter the event to register the type, which can be
		// touch, mouse or pointer. Offset changes need to be
		// made on an event specific basis.
		var touch = e.type.indexOf('touch') === 0;
		var mouse = e.type.indexOf('mouse') === 0;
		var pointer = e.type.indexOf('pointer') === 0;
		var x;
		var y;

		// IE10 implemented pointer events with a prefix;
		if ( e.type.indexOf('MSPointer') === 0 ) {
			pointer = true;
		}

		if ( touch ) {

			// Fix bug when user touches with two or more fingers on mobile devices.
			// It's useful when you have two or more sliders on one page,
			// that can be touched simultaneously.
			// #649, #663, #668
			if ( e.touches.length > 1 ) {
				return false;
			}

			// noUiSlider supports one movement at a time,
			// so we can select the first 'changedTouch'.
			x = e.changedTouches[0].pageX;
			y = e.changedTouches[0].pageY;
		}

		pageOffset = pageOffset || getPageOffset();

		if ( mouse || pointer ) {
			x = e.clientX + pageOffset.x;
			y = e.clientY + pageOffset.y;
		}

		e.pageOffset = pageOffset;
		e.points = [x, y];
		e.cursor = mouse || pointer; // Fix #435

		return e;
	}

	// Translate a coordinate in the document to a percentage on the slider
	function calcPointToPercentage ( calcPoint ) {
		var location = calcPoint - offset(scope_Base, options.ort);
		var proposal = ( location * 100 ) / baseSize();
		return options.dir ? 100 - proposal : proposal;
	}

	// Find handle closest to a certain percentage on the slider
	function getClosestHandle ( proposal ) {

		var closest = 100;
		var handleNumber = false;

		scope_Handles.forEach(function(handle, index){

			// Disabled handles are ignored
			if ( handle.hasAttribute('disabled') ) {
				return;
			}

			var pos = Math.abs(scope_Locations[index] - proposal);

			if ( pos < closest ) {
				handleNumber = index;
				closest = pos;
			}
		});

		return handleNumber;
	}

	// Moves handle(s) by a percentage
	// (bool, % to move, [% where handle started, ...], [index in scope_Handles, ...])
	function moveHandles ( upward, proposal, locations, handleNumbers ) {

		var proposals = locations.slice();

		var b = [!upward, upward];
		var f = [upward, !upward];

		// Copy handleNumbers so we don't change the dataset
		handleNumbers = handleNumbers.slice();

		// Check to see which handle is 'leading'.
		// If that one can't move the second can't either.
		if ( upward ) {
			handleNumbers.reverse();
		}

		// Step 1: get the maximum percentage that any of the handles can move
		if ( handleNumbers.length > 1 ) {

			handleNumbers.forEach(function(handleNumber, o) {

				var to = checkHandlePosition(proposals, handleNumber, proposals[handleNumber] + proposal, b[o], f[o]);

				// Stop if one of the handles can't move.
				if ( to === false ) {
					proposal = 0;
				} else {
					proposal = to - proposals[handleNumber];
					proposals[handleNumber] = to;
				}
			});
		}

		// If using one handle, check backward AND forward
		else {
			b = f = [true];
		}

		var state = false;

		// Step 2: Try to set the handles with the found percentage
		handleNumbers.forEach(function(handleNumber, o) {
			state = setHandle(handleNumber, locations[handleNumber] + proposal, b[o], f[o]) || state;
		});

		// Step 3: If a handle moved, fire events
		if ( state ) {
			handleNumbers.forEach(function(handleNumber){
				fireEvent('update', handleNumber);
				fireEvent('slide', handleNumber);
			});
		}
	}

	// External event handling
	function fireEvent ( eventName, handleNumber, tap ) {

		Object.keys(scope_Events).forEach(function( targetEvent ) {

			var eventType = targetEvent.split('.')[0];

			if ( eventName === eventType ) {
				scope_Events[targetEvent].forEach(function( callback ) {

					callback.call(
						// Use the slider public API as the scope ('this')
						scope_Self,
						// Return values as array, so arg_1[arg_2] is always valid.
						scope_Values.map(options.format.to),
						// Handle index, 0 or 1
						handleNumber,
						// Unformatted slider values
						scope_Values.slice(),
						// Event is fired by tap, true or false
						tap || false,
						// Left offset of the handle, in relation to the slider
						scope_Locations.slice()
					);
				});
			}
		});
	}


	// Fire 'end' when a mouse or pen leaves the document.
	function documentLeave ( event, data ) {
		if ( event.type === "mouseout" && event.target.nodeName === "HTML" && event.relatedTarget === null ){
			eventEnd (event, data);
		}
	}

	// Handle movement on document for handle and range drag.
	function eventMove ( event, data ) {

		// Fix #498
		// Check value of .buttons in 'start' to work around a bug in IE10 mobile (data.buttonsProperty).
		// https://connect.microsoft.com/IE/feedback/details/927005/mobile-ie10-windows-phone-buttons-property-of-pointermove-event-always-zero
		// IE9 has .buttons and .which zero on mousemove.
		// Firefox breaks the spec MDN defines.
		if ( navigator.appVersion.indexOf("MSIE 9") === -1 && event.buttons === 0 && data.buttonsProperty !== 0 ) {
			return eventEnd(event, data);
		}

		// Check if we are moving up or down
		var movement = (options.dir ? -1 : 1) * (event.calcPoint - data.startCalcPoint);

		// Convert the movement into a percentage of the slider width/height
		var proposal = (movement * 100) / data.baseSize;

		moveHandles(movement > 0, proposal, data.locations, data.handleNumbers);
	}

	// Unbind move events on document, call callbacks.
	function eventEnd ( event, data ) {

		// The handle is no longer active, so remove the class.
		if ( scope_ActiveHandle ) {
			removeClass(scope_ActiveHandle, options.cssClasses.active);
			scope_ActiveHandle = false;
		}

		// Remove cursor styles and text-selection events bound to the body.
		if ( event.cursor ) {
			document.body.style.cursor = '';
			document.body.removeEventListener('selectstart', document.body.noUiListener);
		}

		// Unbind the move and end events, which are added on 'start'.
		document.documentElement.noUiListeners.forEach(function( c ) {
			document.documentElement.removeEventListener(c[0], c[1]);
		});

		// Remove dragging class.
		removeClass(scope_Target, options.cssClasses.drag);

		setZindex();

		data.handleNumbers.forEach(function(handleNumber){
			fireEvent('set', handleNumber);
			fireEvent('change', handleNumber);
			fireEvent('end', handleNumber);
		});
	}

	// Bind move events on document.
	function eventStart ( event, data ) {

		if ( data.handleNumbers.length === 1 ) {

			var handle = scope_Handles[data.handleNumbers[0]];

			// Ignore 'disabled' handles
			if ( handle.hasAttribute('disabled') ) {
				return false;
			}

			// Mark the handle as 'active' so it can be styled.
			scope_ActiveHandle = handle.children[0];
			addClass(scope_ActiveHandle, options.cssClasses.active);
		}

		// Fix #551, where a handle gets selected instead of dragged.
		event.preventDefault();

		// A drag should never propagate up to the 'tap' event.
		event.stopPropagation();

		// Attach the move and end events.
		var moveEvent = attachEvent(actions.move, document.documentElement, eventMove, {
			startCalcPoint: event.calcPoint,
			baseSize: baseSize(),
			pageOffset: event.pageOffset,
			handleNumbers: data.handleNumbers,
			buttonsProperty: event.buttons,
			locations: scope_Locations.slice()
		});

		var endEvent = attachEvent(actions.end, document.documentElement, eventEnd, {
			handleNumbers: data.handleNumbers
		});

		var outEvent = attachEvent("mouseout", document.documentElement, documentLeave, {
			handleNumbers: data.handleNumbers
		});

		document.documentElement.noUiListeners = moveEvent.concat(endEvent, outEvent);

		// Text selection isn't an issue on touch devices,
		// so adding cursor styles can be skipped.
		if ( event.cursor ) {

			// Prevent the 'I' cursor and extend the range-drag cursor.
			document.body.style.cursor = getComputedStyle(event.target).cursor;

			// Mark the target with a dragging state.
			if ( scope_Handles.length > 1 ) {
				addClass(scope_Target, options.cssClasses.drag);
			}

			var f = function(){
				return false;
			};

			document.body.noUiListener = f;

			// Prevent text selection when dragging the handles.
			document.body.addEventListener('selectstart', f, false);
		}

		data.handleNumbers.forEach(function(handleNumber){
			fireEvent('start', handleNumber);
		});
	}

	// Move closest handle to tapped location.
	function eventTap ( event ) {

		// The tap event shouldn't propagate up
		event.stopPropagation();

		var proposal = calcPointToPercentage(event.calcPoint);
		var handleNumber = getClosestHandle(proposal);

		// Tackle the case that all handles are 'disabled'.
		if ( handleNumber === false ) {
			return false;
		}

		// Flag the slider as it is now in a transitional state.
		// Transition takes a configurable amount of ms (default 300). Re-enable the slider after that.
		if ( !options.events.snap ) {
			addClassFor(scope_Target, options.cssClasses.tap, options.animationDuration);
		}

		setHandle(handleNumber, proposal, true, true);

		setZindex();

		fireEvent('slide', handleNumber, true);
		fireEvent('set', handleNumber, true);
		fireEvent('change', handleNumber, true);
		fireEvent('update', handleNumber, true);

		if ( options.events.snap ) {
			eventStart(event, { handleNumbers: [handleNumber] });
		}
	}

	// Fires a 'hover' event for a hovered mouse/pen position.
	function eventHover ( event ) {

		var proposal = calcPointToPercentage(event.calcPoint);

		var to = scope_Spectrum.getStep(proposal);
		var value = scope_Spectrum.fromStepping(to);

		Object.keys(scope_Events).forEach(function( targetEvent ) {
			if ( 'hover' === targetEvent.split('.')[0] ) {
				scope_Events[targetEvent].forEach(function( callback ) {
					callback.call( scope_Self, value );
				});
			}
		});
	}

	// Attach events to several slider parts.
	function bindSliderEvents ( behaviour ) {

		// Attach the standard drag event to the handles.
		if ( !behaviour.fixed ) {

			scope_Handles.forEach(function( handle, index ){

				// These events are only bound to the visual handle
				// element, not the 'real' origin element.
				attachEvent ( actions.start, handle.children[0], eventStart, {
					handleNumbers: [index]
				});
			});
		}

		// Attach the tap event to the slider base.
		if ( behaviour.tap ) {
			attachEvent (actions.start, scope_Base, eventTap, {});
		}

		// Fire hover events
		if ( behaviour.hover ) {
			attachEvent (actions.move, scope_Base, eventHover, { hover: true });
		}

		// Make the range draggable.
		if ( behaviour.drag ){

			scope_Connects.forEach(function( connect, index ){

				if ( connect === false || index === 0 || index === scope_Connects.length - 1 ) {
					return;
				}

				var handleBefore = scope_Handles[index - 1];
				var handleAfter = scope_Handles[index];
				var eventHolders = [connect];

				addClass(connect, options.cssClasses.draggable);

				// When the range is fixed, the entire range can
				// be dragged by the handles. The handle in the first
				// origin will propagate the start event upward,
				// but it needs to be bound manually on the other.
				if ( behaviour.fixed ) {
					eventHolders.push(handleBefore.children[0]);
					eventHolders.push(handleAfter.children[0]);
				}

				eventHolders.forEach(function( eventHolder ) {
					attachEvent ( actions.start, eventHolder, eventStart, {
						handles: [handleBefore, handleAfter],
						handleNumbers: [index - 1, index]
					});
				});
			});
		}
	}


	// Split out the handle positioning logic so the Move event can use it, too
	function checkHandlePosition ( reference, handleNumber, to, lookBackward, lookForward ) {

		// For sliders with multiple handles, limit movement to the other handle.
		// Apply the margin option by adding it to the handle positions.
		if ( scope_Handles.length > 1 ) {

			if ( lookBackward && handleNumber > 0 ) {
				to = Math.max(to, reference[handleNumber - 1] + options.margin);
			}

			if ( lookForward && handleNumber < scope_Handles.length - 1 ) {
				to = Math.min(to, reference[handleNumber + 1] - options.margin);
			}
		}

		// The limit option has the opposite effect, limiting handles to a
		// maximum distance from another. Limit must be > 0, as otherwise
		// handles would be unmoveable.
		if ( scope_Handles.length > 1 && options.limit ) {

			if ( lookBackward && handleNumber > 0 ) {
				to = Math.min(to, reference[handleNumber - 1] + options.limit);
			}

			if ( lookForward && handleNumber < scope_Handles.length - 1 ) {
				to = Math.max(to, reference[handleNumber + 1] - options.limit);
			}
		}

		// The padding option keeps the handles a certain distance from the
		// edges of the slider. Padding must be > 0.
		if ( options.padding ) {

			if ( handleNumber === 0 ) {
				to = Math.max(to, options.padding);
			}

			if ( handleNumber === scope_Handles.length - 1 ) {
				to = Math.min(to, 100 - options.padding);
			}
		}

		to = scope_Spectrum.getStep(to);

		// Limit percentage to the 0 - 100 range
		to = limit(to);

		// Return false if handle can't move
		if ( to === reference[handleNumber] ) {
			return false;
		}

		return to;
	}

	function toPct ( pct ) {
		return pct + '%';
	}

	// Updates scope_Locations and scope_Values, updates visual state
	function updateHandlePosition ( handleNumber, to ) {

		// Update locations.
		scope_Locations[handleNumber] = to;

		// Convert the value to the slider stepping/range.
		scope_Values[handleNumber] = scope_Spectrum.fromStepping(to);

		// Called synchronously or on the next animationFrame
		var stateUpdate = function() {
			scope_Handles[handleNumber].style[options.style] = toPct(to);
			updateConnect(handleNumber);
			updateConnect(handleNumber + 1);
		};

		// Set the handle to the new position.
		// Use requestAnimationFrame for efficient painting.
		// No significant effect in Chrome, Edge sees dramatic performace improvements.
		// Option to disable is useful for unit tests, and single-step debugging.
		if ( window.requestAnimationFrame && options.useRequestAnimationFrame ) {
			window.requestAnimationFrame(stateUpdate);
		} else {
			stateUpdate();
		}
	}

	function setZindex ( ) {

		scope_HandleNumbers.forEach(function(handleNumber){
			// Handles before the slider middle are stacked later = higher,
			// Handles after the middle later is lower
			// [[7] [8] .......... | .......... [5] [4]
			var dir = (scope_Locations[handleNumber] > 50 ? -1 : 1);
			var zIndex = 3 + (scope_Handles.length + (dir * handleNumber));
			scope_Handles[handleNumber].childNodes[0].style.zIndex = zIndex;
		});
	}

	// Test suggested values and apply margin, step.
	function setHandle ( handleNumber, to, lookBackward, lookForward ) {

		to = checkHandlePosition(scope_Locations, handleNumber, to, lookBackward, lookForward);

		if ( to === false ) {
			return false;
		}

		updateHandlePosition(handleNumber, to);

		return true;
	}

	// Updates style attribute for connect nodes
	function updateConnect ( index ) {

		// Skip connects set to false
		if ( !scope_Connects[index] ) {
			return;
		}

		var l = 0;
		var h = 100;

		if ( index !== 0 ) {
			l = scope_Locations[index - 1];
		}

		if ( index !== scope_Connects.length - 1 ) {
			h = scope_Locations[index];
		}

		scope_Connects[index].style[options.style] = toPct(l);
		scope_Connects[index].style[options.styleOposite] = toPct(100 - h);
	}

	// ...
	function setValue ( to, handleNumber ) {

		// Setting with null indicates an 'ignore'.
		// Inputting 'false' is invalid.
		if ( to === null || to === false ) {
			return;
		}

		// If a formatted number was passed, attemt to decode it.
		if ( typeof to === 'number' ) {
			to = String(to);
		}

		to = options.format.from(to);

		// Request an update for all links if the value was invalid.
		// Do so too if setting the handle fails.
		if ( to !== false && !isNaN(to) ) {
			setHandle(handleNumber, scope_Spectrum.toStepping(to), false, false);
		}
	}

	// Set the slider value.
	function valueSet ( input, fireSetEvent ) {

		var values = asArray(input);
		var isInit = scope_Locations[0] === undefined;

		// Event fires by default
		fireSetEvent = (fireSetEvent === undefined ? true : !!fireSetEvent);

		values.forEach(setValue);

		// Animation is optional.
		// Make sure the initial values were set before using animated placement.
		if ( options.animate && !isInit ) {
			addClassFor(scope_Target, options.cssClasses.tap, options.animationDuration);
		}

		// Now that all base values are set, apply constraints
		scope_HandleNumbers.forEach(function(handleNumber){
			setHandle(handleNumber, scope_Locations[handleNumber], true, false);
		});

		setZindex();

		scope_HandleNumbers.forEach(function(handleNumber){

			fireEvent('update', handleNumber);

			// Fire the event only for handles that received a new value, as per #579
			if ( values[handleNumber] !== null && fireSetEvent ) {
				fireEvent('set', handleNumber);
			}
		});
	}

	// Reset slider to initial values
	function valueReset ( fireSetEvent ) {
		valueSet(options.start, fireSetEvent);
	}

	// Get the slider value.
	function valueGet ( ) {

		var values = scope_Values.map(options.format.to);

		// If only one handle is used, return a single value.
		if ( values.length === 1 ){
			return values[0];
		}

		return values;
	}

	// Removes classes from the root and empties it.
	function destroy ( ) {

		for ( var key in options.cssClasses ) {
			if ( !options.cssClasses.hasOwnProperty(key) ) { continue; }
			removeClass(scope_Target, options.cssClasses[key]);
		}

		while (scope_Target.firstChild) {
			scope_Target.removeChild(scope_Target.firstChild);
		}

		delete scope_Target.noUiSlider;
	}

	// Get the current step size for the slider.
	function getCurrentStep ( ) {

		// Check all locations, map them to their stepping point.
		// Get the step point, then find it in the input list.
		return scope_Locations.map(function( location, index ){

			var nearbySteps = scope_Spectrum.getNearbySteps( location );
			var value = scope_Values[index];
			var increment = nearbySteps.thisStep.step;
			var decrement = null;

			// If the next value in this step moves into the next step,
			// the increment is the start of the next step - the current value
			if ( increment !== false ) {
				if ( value + increment > nearbySteps.stepAfter.startValue ) {
					increment = nearbySteps.stepAfter.startValue - value;
				}
			}


			// If the value is beyond the starting point
			if ( value > nearbySteps.thisStep.startValue ) {
				decrement = nearbySteps.thisStep.step;
			}

			else if ( nearbySteps.stepBefore.step === false ) {
				decrement = false;
			}

			// If a handle is at the start of a step, it always steps back into the previous step first
			else {
				decrement = value - nearbySteps.stepBefore.highestStep;
			}


			// Now, if at the slider edges, there is not in/decrement
			if ( location === 100 ) {
				increment = null;
			}

			else if ( location === 0 ) {
				decrement = null;
			}

			// As per #391, the comparison for the decrement step can have some rounding issues.
			var stepDecimals = scope_Spectrum.countStepDecimals();

			// Round per #391
			if ( increment !== null && increment !== false ) {
				increment = Number(increment.toFixed(stepDecimals));
			}

			if ( decrement !== null && decrement !== false ) {
				decrement = Number(decrement.toFixed(stepDecimals));
			}

			return [decrement, increment];
		});
	}

	// Attach an event to this slider, possibly including a namespace
	function bindEvent ( namespacedEvent, callback ) {
		scope_Events[namespacedEvent] = scope_Events[namespacedEvent] || [];
		scope_Events[namespacedEvent].push(callback);

		// If the event bound is 'update,' fire it immediately for all handles.
		if ( namespacedEvent.split('.')[0] === 'update' ) {
			scope_Handles.forEach(function(a, index){
				fireEvent('update', index);
			});
		}
	}

	// Undo attachment of event
	function removeEvent ( namespacedEvent ) {

		var event = namespacedEvent && namespacedEvent.split('.')[0];
		var namespace = event && namespacedEvent.substring(event.length);

		Object.keys(scope_Events).forEach(function( bind ){

			var tEvent = bind.split('.')[0],
				tNamespace = bind.substring(tEvent.length);

			if ( (!event || event === tEvent) && (!namespace || namespace === tNamespace) ) {
				delete scope_Events[bind];
			}
		});
	}

	// Updateable: margin, limit, padding, step, range, animate, snap
	function updateOptions ( optionsToUpdate, fireSetEvent ) {

		// Spectrum is created using the range, snap, direction and step options.
		// 'snap' and 'step' can be updated, 'direction' cannot, due to event binding.
		// If 'snap' and 'step' are not passed, they should remain unchanged.
		var v = valueGet();

		var updateAble = ['margin', 'limit', 'padding', 'range', 'animate', 'snap', 'step', 'format'];

		// Only change options that we're actually passed to update.
		updateAble.forEach(function(name){
			if ( optionsToUpdate[name] !== undefined ) {
				originalOptions[name] = optionsToUpdate[name];
			}
		});

		var newOptions = testOptions(originalOptions);

		// Load new options into the slider state
		updateAble.forEach(function(name){
			if ( optionsToUpdate[name] !== undefined ) {
				options[name] = newOptions[name];
			}
		});

		// Save current spectrum direction as testOptions in testRange call
		// doesn't rely on current direction
		newOptions.spectrum.direction = scope_Spectrum.direction;
		scope_Spectrum = newOptions.spectrum;

		// Limit, margin and padding depend on the spectrum but are stored outside of it. (#677)
		options.margin = newOptions.margin;
		options.limit = newOptions.limit;
		options.padding = newOptions.padding;

		// Invalidate the current positioning so valueSet forces an update.
		scope_Locations = [];
		valueSet(optionsToUpdate.start || v, fireSetEvent);
	}

	// Throw an error if the slider was already initialized.
	if ( scope_Target.noUiSlider ) {
		throw new Error("noUiSlider (" + VERSION + "): Slider was already initialized.");
	}

	// Create the base element, initialise HTML and set classes.
	// Add handles and connect elements.
	addSlider(scope_Target);
	addElements(options.connect, scope_Base);

	scope_Self = {
		destroy: destroy,
		steps: getCurrentStep,
		on: bindEvent,
		off: removeEvent,
		get: valueGet,
		set: valueSet,
		reset: valueReset,
		// Exposed for unit testing, don't use this in your application.
		__moveHandles: function(a, b, c) { moveHandles(a, b, scope_Locations, c); },
		options: originalOptions, // Issue #600, #678
		updateOptions: updateOptions,
		target: scope_Target, // Issue #597
		pips: pips // Issue #594
	};

	// Attach user events.
	bindSliderEvents(options.events);

	// Use the public value method to set the start values.
	valueSet(options.start);

	if ( options.pips ) {
		pips(options.pips);
	}

	if ( options.tooltips ) {
		tooltips();
	}

	return scope_Self;

}


	// Run the standard initializer
	function initialize ( target, originalOptions ) {

		if ( !target.nodeName ) {
			throw new Error("noUiSlider (" + VERSION + "): create requires a single element.");
		}

		// Test the options and create the slider environment;
		var options = testOptions( originalOptions, target );
		var api = closure( target, options, originalOptions );

		target.noUiSlider = api;

		return api;
	}

	// Use an object instead of a function for future expansibility;
	return {
		version: VERSION,
		create: initialize
	};

}));
/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
function GameResponseHandling(){
    'use strict';
    
    var playerResFns = {};
    var opponentResFns = {};
    var commonResFns = {};
    
    /**
     * Handling player own responses only
     */
    playerResFns = {
        [BUY_IN_RESPONSE]:function(obj){
             if(obj.error === 0){                
                if(TABLE_ID === obj.tableId){                    
                    _gamePage.init(obj);
                }else{
                    BUYIN_RESPONSE_OBJ = obj;
                    _tableScoketHandling.onTableFullSocCreation(TABLE_ID+SERVER_URL,obj.tableId);
                }
             }else{                 
                 if(_lobbyErrorPopup){
                     ALREADY_TABLE_SELECTED = false;
                     if(obj.errorCode === 107){
                        if(_buyChipPopup === null){
                            _buyChipPopup = new BuyChips();
                            _buyChipPopup.sendStoreViewRequest();
                        }
                        _buyChipPopup.onShowBuyChipPopup();
                     }else{
                        _lobbyErrorPopup.showErrorPopup(true,"Error",obj.message);
                     }                     
                 }else{
                     console.log("Error : ",obj.message);
                 }
             }
        },
        [USER_TIMER_RESPONSE]:function(obj){
            _gamePage.onPlayerTimerHandling(obj);
        },
        [BET_ACCEPT_RESPONSE]:function(obj){
            if(obj.error === 0){
                _gameFooter.onResetValuesToNextTimer(CURRENT_USER_SEAT_INDEX);
                _seatManager.onUpdateBetValuesFromSever(obj);
                _gameFooter.onClearUserTimer(obj.seatIndex);
                _seatManager.onShowHideTimer(obj.seatIndex,true);
                _seatManager.onUpdatePlayerGlow(obj.glowList);
            }else{
                if(obj.errorCode == 107){
                    //---insufficient fund error---
                    _betHandling.onResetOwnBetValues();
                    _betHandling.onUpdateUserBetOnSeat();
                    _seatManager.onUpdateUserBalance(obj.seatIndex,obj.tempBalance);
                }else{
                    _betHandling.onClearBetAndUpdateBalance(true);//true passed for clear bet because of bet error
                }
                _gameFooter.onEnaleConfirmBtn(true);
                _lobbyErrorPopup.showErrorPopup(true,"Warning",obj.message);
            }
        },
        [FUTUREBET_ACCEPT_RESPONSE]:function(obj){
            IS_FUTUREBET_REQUEST_SENT = false;
            //_gameFooter.enableBetDisabler(IS_FUTUREBET_REQUEST_SENT);
            if(obj.error == 1){
                _lobbyErrorPopup.showErrorPopup(true,"Failed",obj.message,null,3000);
            }
            console.log("---FUTUREBET_ACCEPT_RESPONSE---");  
        },
        [LEAVE_GAME_RESPONSE]:function(obj){
            if(!IS_PLAYER_CLICKED_LEAVE_TABLE){
                _lobbyErrorPopup.showOkCanPopup(false);
                _seatManager.onShowEmptySeat(obj.seatIndex);
                onExitGame();
            }
        },
        [SKIP_TURN_RESPONSE]:function(obj){
            _seatManager.onShowHideTimer(obj.seatIndex,true);
            //_gameFooter.enableBetDisabler(true);
            //_seatManager.onHideTimerSeatGlowBetHighlight(obj.seatIndex);
            _gameFooter.onClearUserTimer(obj.seatIndex);
        },
        [BETS_INFO_RESPONSE]:function(obj){
            if(obj.error == 1){
                _lobbyErrorPopup.showErrorPopup(true,"Failed",obj.message,null,3000);
                return;
            }
            _featureBet.onOpponentBetsUpdation(obj.betsInfo);
        },
        [XP_RESPONSE]:function(obj){
            console.log(obj);
            _seatAnimation.xpAnim(("+ "+obj.xpPoints),500);
        },
        [STORE_POPUP_RESPONSE]:function(obj){
            if(_buyChipPopup !== null){
                _buyChipPopup.onShowBuyChipPopup();
            }
        },
        [DISCONNECT_TIMER_RESPONSE]:function(obj){
            _seatManager.onShowDisconnection(obj.seatIndex,true,_localization.getText['disconnected'],obj.countTimer);
        },
        [DIS_EXTRA_TIMER_RESPONSE]:function(obj){
            _seatManager.onShowDisconnection(obj.seatIndex,true,_localization.getText['extra_timer'],obj.countTimer);
        },
        'default':function(){
            console.log("playerResFns does not contain valid function");
        }
    };
    /**
     * Handling opponents player responses only
     */
    opponentResFns = {
        [OPPONENT_PLAYERS_RESPONSE]:function(obj){            
            _seatManager.onShowPlayerSeat(obj.seatIndex,obj);
             _gameTable.onDealerMsgShow(true,_localization.getText['txt_welcome']+" "+obj.userName,5000);
        },
        [USER_TIMER_RESPONSE]:function(obj){
            _gamePage.onOpponentTimerHandling(obj);
        },
        [BET_ACCEPT_RESPONSE]:function(obj){
            if(obj.error === 0){
                _seatManager.onHideAllSeatBetHighlight();
                _seatManager.onUpdateBetValuesFromSever(obj);
                _gameFooter.onClearUserTimer(obj.seatIndex);
                _seatManager.onShowHideTimer(obj.seatIndex,true);
                _seatManager.onUpdatePlayerGlow(obj.glowList);
            }else{
                _lobbyErrorPopup.showErrorPopup(true,"Warning",obj.message);
            }
        },
        [LEAVE_GAME_RESPONSE]:function(obj){
            _lobbyErrorPopup.showOkCanPopup(false);
            if(obj.isReservedSeat != undefined && obj.isReservedSeat == false){
                _seatManager.onShowEmptySeat(obj.seatIndex);
            }
            if(obj.actionMessage !== undefined){
                _gameTable.onDealerCommonMsgShow(true,obj.actionMessage);
            }
        },
        [SKIP_TURN_RESPONSE]:function(obj){
            _seatManager.onShowHideTimer(obj.seatIndex,true);
            //_seatManager.onHideTimerSeatGlowBetHighlight(obj.seatIndex);
            clearInterval(USER_TIMER);
            IS_USER_TIMER_RUNNING = false;
        },
        [DISCCONECT_RESPONSE]:function(obj){
            if(obj.connect === 1){
                _seatManager.onShowDisconnection(obj.seatIndex,true,_localization.getText['disconnected']);
            }else{
                _seatManager.onShowDisconnection(obj.seatIndex,false,_localization.getText['connected']);
            }
        },
        [DISCONNECT_TIMER_RESPONSE]:function(obj){
            _seatManager.onShowDisconnection(obj.seatIndex,true,_localization.getText['disconnected'],obj.countTimer);
        },
        [DIS_EXTRA_TIMER_RESPONSE]:function(obj){
            _seatManager.onShowDisconnection(obj.seatIndex,true,_localization.getText['extra_timer'],obj.countTimer);
        },
        'default':function(){
            console.log("opponentResFns does not contain valid function");
        }
    };
    /**
     * Handling common responses only
     */
    commonResFns = {
        [GAME_START_TIMER_RESPONSE]:function(obj){
            _gameTable.onUpdateStartTimer(obj.gameStartCountTimer);
        },
        [GAME_CARD_PLAY_RESPONSE]:function(obj){
           /* _gameTable.onUpdateTableInfo(obj);
            if((obj.winnerSeatIndex !== undefined) && (obj.winFlag === 1 || obj.winFlag === 2)){
                for(var i=0;i<obj.winnerSeatIndex.length;i++){
                    _seatManager.onUpdateWinChip(obj.winnerSeatIndex[i],obj.winFlag);
                }
            }*/
            _gameTable.onDealCardDisplay(obj,obj.cardTypeId);
            _gameTable.onDealerCommonMsgShow(true,_localization.getText['bet_closed_drawbegin']);
        },
        [REFRESH_RESPONSE]:function(obj){            
            _gamePage.onGameResetBeforeStart(obj);
        },
        [START_ROUND_RESPONSE]:function(obj){
            _seatManager.onShowHideKickStarterIcon(obj.ksSeatIndex);
            _gameTable.onHouseCardShow(obj.houseCard,false);
            START_ROUND_RESPONSE_OBJ = obj;
            var _bootTimer = null;
            _bootTimer = setTimeout(function(){
                _seatManager.onUpdateStartRoundResponse();
                clearTimeout(_bootTimer);
            },1000);
            _gameTable.onDealerCommonMsgShow(true,_localization.getText['start_your_bet']);
        },
        [BET_RETURN_RESPONSE]:function(obj){
            _seatManager.onRemoveSeatClickEvents();
            _seatManager.onHideTimerSeatGlowBetHighlight(0);//0 passed to hide all seat timerhighlight
            _seatManager.onShowHideFutureBetIcon(0,false,true);
            
            var isMyBetReturn = false;
            
            if(obj.userLists !== undefined){
                var i=0;
                _gameTable.onDealerCommonMsgShow(true,_localization.getText['player_bet_return'],3500);
                for(i=0;i<obj.userLists.length;i++){
                    _seatManager.onUpdateUserBalance(obj.userLists[i].seatIndex,obj.userLists[i].tempBalance);
                    _seatManager.onUpdateAndarBaharAvailableBet(obj.userLists[i].seatIndex,0,3);//3 to hide both andar and bahar available bet area

                    if(obj.userLists[i].baharAmount >= 0){
                        _seatManager.onUpdateAndarBaharBet(obj.userLists[i].seatIndex,obj.userLists[i].baharAmount,1);
                        if(Number(obj.userLists[i].baharAmount) <= 0)
                            _seatManager.OnChangeAndarOrBaharBetBg(obj.userLists[i].seatIndex,"default",1);
                    }
                    if(obj.userLists[i].andarAmount >= 0){
                        _seatManager.onUpdateAndarBaharBet(obj.userLists[i].seatIndex,obj.userLists[i].andarAmount,2);
                        if(Number(obj.userLists[i].andarAmount) <= 0)
                            _seatManager.OnChangeAndarOrBaharBetBg(obj.userLists[i].seatIndex,"default",2);
                    }
                    
                    if(obj.userLists[i].returnAmount > 0){
                        _seatAnimation.chipAnim(SHUFFLED_SEAT_ORDER[obj.userLists[i].seatIndex],obj.userLists[i].returnAmount,("player_"+SHUFFLED_SEAT_ORDER[obj.userLists[i].seatIndex]),2000);
                    }
                    
                    if(obj.userLists[i].seatIndex === CURRENT_USER_SEAT_INDEX){
                        isMyBetReturn = true;
                        //_gameFooter.onUpdateOwnPlayerDetailsOnFooter(Number(obj.userLists[i].andarAmount),Number(obj.userLists[i].baharAmount));
                    }
                }
            }
            //---feature bet disable
            IS_ENABLED_FEATURE_BET = false;
            _gameFooter.onShowHideFooter(true,true);
            
            if(isMyBetReturn==false){
                //_gameFooter.onUpdateOwnPlayerDetailsOnFooter();
            }
        },
        [CHAT_RESPONSE]:function(obj){
            _seatManager.onUpdateChatMsg(obj.seatIndex,obj.chatMessage);
        },
        [WINNER_RESPONSE]:function(obj){
            _seatAnimation.chipAnim(SHUFFLED_SEAT_ORDER[obj.seatIndex],obj.winAmount,
                'player_'+SHUFFLED_SEAT_ORDER[obj.seatIndex],1000);
            _gameTable.onDealerCommonMsgShow(true,obj.actionMessage,5000);    
        },
        [TIP_RESPONSE]:function(obj){
            if(obj.error === 0){
                _seatManager.onUpdateUserBalance(obj.seatIndex,obj.tempBalance);
                _seatAnimation.chipAnim(SHUFFLED_SEAT_ORDER[obj.seatIndex],obj.tipAmount,'dealer',1000,function(){
                    _gameTable.onDealerMsgShow(true,obj.actionMessage,5000);
                });
            }
        },
        'default':function(){
            console.log("commonResFns does not contain valid function");
        }
    };
    /**
     * Split the response base on response type like palyer,opponent or common
     * @param {type} obj
     * @returns {undefined}
     */
    this.onSplitResponse = function(obj){
        switch(obj.responseType){
            case RESPONSE_TYPE_PLAYER:                
                (playerResFns[obj.action] || playerResFns['default'])(obj);
                break;
            case RESPONSE_TYPE_OPPONENT:                
                (opponentResFns[obj.action] || opponentResFns['default'])(obj);
                break;
            case RESPONSE_TYPE_COMMON:
                (commonResFns[obj.action] || commonResFns['default'])(obj);
                break;
        }
    };
}



function GameEnteringScreen(){
    var closeTimeOut = {};
    var enteringScreenArea = '   <div class="entering-screen-popup table_info_bg" id="enteringScreenPopup">  '  + 
 '       <div class="game-table-name" id="gameTableName"></div>  '  + 
 '       <div class="min-bet-holder">  '  + 
 '           <div class="game-table-minbet-txt" id="gameTableMinbetTxt">MINIMUM BET</div>  '  + 
 '           <div class="game-table-minbet" id="gameTableMinbet"></div>  '  + 
 '       </div>  '  + 
 '       <div class="max-bet-holder">  '  + 
 '           <div class="game-table-maxbet-txt" id="gameTableMaxbetTxt">MAXIMUM BET</div>  '  + 
 '           <div class="game-table-maxbet" id="gameTableMaxbet"></div>  '  + 
 '       </div>  '  + 
 '       <div class="forcebet-holder">   '  + 
 '           <div class="game-table-forcebet-txt" id="gameTableForcebetTxt">FORCED BET</div>  '  + 
 '           <div class="game-table-forcebet" id="gameTableForcebet"></div>  '  + 
 '       </div>  '  + 
 '       <div class="ok-btn ok_btn" id="okBtn" onclick="_gameEnteringScreen.onOkClick(true);">Ok</div>  '  + 
 '  </div>  ' ;   
    
    /*
     * intitiates the game entering screen.
     */
    this.init = function(){
        $('.bottom-layer').append(enteringScreenArea);
        $('.entering-screen-popup').hide();
        $('.popup-container-bg').hide();
        $('.popup-container').hide();  
    };
    /*
     * dislay the entering screen content
     */
    this.enteringScreenShow = function(obj){
        console.log(obj);
        if(BOTTOM_LAYER_POPUP !== ""){
            $(BOTTOM_LAYER_POPUP).hide();
        }
        $('.bottom-layer').show();
        $('.entering-screen-popup').show();
        $('.popup-container-bg').show();
        $('.popup-container').show();  
        $('.game-table-name').text(obj.tableName);
        $('.game-table-minbet').text(" - "+obj.minBet);
        $('.game-table-maxbet').text(" - "+obj.maxBet);
        $('.game-table-forcebet').text(" - "+obj.ante);
        BOTTOM_LAYER_POPUP = '.entering-screen-popup';
        closeTimeOut = setTimeout(
        function(){
            _gameEnteringScreen.onOkClick(false);
        }, 5000);
    };
    /*
     * okay button click handler
     */
    this.onOkClick = function(flag){
        if(flag){
            _sound.play('buttonSound');
        }
        clearTimeout(closeTimeOut);
        $('.bottom-layer').hide();
        $('.entering-screen-popup').hide();
        $('.popup-container-bg').hide();
        $('.popup-container').hide();
        BOTTOM_LAYER_POPUP = '';
        if(IS_PLAYER_WAIT_FOR_NEXT_ROUND){
            _gameFooter.onShowWaitingMsgHolder(true);
        }
    };
    this.init();
}
function BetsInfo(){
  var betsInfoArea = '   <div class="bets-info-popup">  '  + 
 '       <div class="bets-header">  '  + 
 '           <div class="own-bets selected-highlight" id="betsOnOpp" onclick="_betsInfo.onBetsTabClick(this.id);">OWN BETS & BETS ON OPPONENTS</div>  '  + 
 '           <div class="opponent-bets normal-highlight" id="oppBetsOnMe" onclick="_betsInfo.onBetsTabClick(this.id);">OPPONENTS BETS ON ME</div>  '  + 
 '           <div class="bets-info-close" id="betsInfoClose" onclick="_betsInfo.onCloseHandler();">X</div>  '  + 
 '       </div>  '  + 
 '       <div class="bets-table-header">  '  + 
 '           <div class="playername-static-txt">PLAYER NAME</div>  '  + 
 '           <div class="andar-static-txt">ANDAR</div>  '  + 
 '           <div class="bahar-static-txt">BAHAR</div>  '  + 
 '           <div class="total-head-static-txt">TOTAL</div>  '  + 
 '       </div>  '  + 
 '       <div class="bets-player-1">  '  + 
 '           <div class="player1-holder">  '  + 
 '               <div class="player1-ownbet-static-txt">OWN BET</div>  '  + 
 '               <div class="player1-name-txt" id="player1NameTxt">-</div>      '  + 
 '           </div>  '  + 
 '           <div class="player1-andar-value" id="player1AndarValue">-</div>  '  + 
 '           <div class="player1-bahar-value" id="player1BaharValue">-</div>  '  + 
 '           <div class="player1-total-value" id="player1TotalValue">-</div>  '  + 
 '       </div>  '  + 
 '       <div class="betsonopponent" id="betsOnOpponent">BETS ON OPPONENTS</div>  '  + 
 '       <div class="bets-player-2">  '  + 
 '           <div class="player2-name-txt" id="player2NameTxt">-</div>  '  + 
 '           <div class="player2-andar-value" id="player2AndarValue">-</div>  '  + 
 '           <div class="player2-bahar-value" id="player2BaharValue">-</div>  '  + 
 '           <div class="player2-total-value" id="player2TotalValue">-</div>  '  + 
 '       </div>  '  + 
 '       <div class="bets-player-3">  '  + 
 '           <div class="player3-name-txt" id="player3NameTxt">-</div>  '  + 
 '           <div class="player3-andar-value" id="player3AndarValue">-</div>  '  + 
 '           <div class="player3-bahar-value" id="player3BaharValue">-</div>  '  + 
 '           <div class="player3-total-value" id="player3TotalValue">-</div>  '  + 
 '       </div>  '  + 
 '       <div class="bets-player-4">  '  + 
 '           <div class="player4-name-txt" id="player4NameTxt">-</div>  '  + 
 '           <div class="player4-andar-value" id="player4AndarValue">-</div>  '  + 
 '           <div class="player4-bahar-value" id="player4BaharValue">-</div>  '  + 
 '           <div class="player4-total-value" id="player4TotalValue">-</div>  '  + 
 '       </div>  '  + 
 '       <div class="bets-player-5">  '  + 
 '           <div class="player5-name-txt" id="player5NameTxt">-</div>  '  + 
 '           <div class="player5-andar-value" id="player5AndarValue">-</div>  '  + 
 '           <div class="player5-bahar-value" id="player5BaharValue">-</div>  '  + 
 '           <div class="player5-total-value" id="player5TotalValue">-</div>  '  + 
 '       </div>  '  + 
 '        <div class="bets-footer">  '  + 
 '           <div class="total-static-txt" id="totalStaticTxt">TOTAL</div>  '  + 
 '           <div class="total-andar-value" id="totalAndarValue">ANDAR-TOTAL</div>  '  + 
 '           <div class="total-bahar-value" id="totalBaharValue">BAHAR-TOTAL</div>  '  + 
 '           <div class="total-overall-value" id="totalTotalValue">OVERALL-TOTAL</div>  '  + 
 '       </div>  '  + 
 '  </div>  ' ;      
    var selectedTab = '#betsOnOpp';
    var selectedTabHandler = {};
    var objBetsInfo = {};
    /*
     * init
     * initiates bets info assets.
     */
    this.init = function(){
       $('.bottom-layer').append(betsInfoArea);
       for(var i=2;i<=5;i++){
           $('.player'+i+'-name-txt').addClass('row-height-betsonopp');
           $('.player'+i+'-andar-value').addClass('row-height-betsonopp');
           $('.player'+i+'-bahar-value').addClass('row-height-betsonopp');
           $('.player'+i+'-total-value').addClass('row-height-betsonopp');
       }
    };
    this.betInfoShow = function(obj){
        console.log(obj);
        objBetsInfo = obj;
        if(BOTTOM_LAYER_POPUP !== ""){
            $(BOTTOM_LAYER_POPUP).hide();
        }
        $('.bottom-layer').show();
        $('.bets-info-popup').show();
        $('.popup-container-bg').show();
        $('.popup-container').show();
        $('#myBetsBtn').removeClass('autoskip_inactive');
        $('#myBetsBtn').addClass('autoskip_active');
        this.onBetsTabClick('betsOnOpp');
        BOTTOM_LAYER_POPUP = '.bets-info-popup';
    };
    selectedTabHandler = {
        'betsOnOpp':function(){
           $('.bets-player-1').show(); 
           $('.betsonopponent').show();
           for(var i=2;i<=5;i++){
                $('.player'+i+'-name-txt').removeClass('row-height-oppbetsonme');
                $('.player'+i+'-andar-value').removeClass('row-height-oppbetsonme');
                $('.player'+i+'-bahar-value').removeClass('row-height-oppbetsonme');
                $('.player'+i+'-total-value').removeClass('row-height-oppbetsonme');
                $('.player'+i+'-name-txt').addClass('row-height-betsonopp');
                $('.player'+i+'-andar-value').addClass('row-height-betsonopp');
                $('.player'+i+'-bahar-value').addClass('row-height-betsonopp');
                $('.player'+i+'-total-value').addClass('row-height-betsonopp');
           }
           _betsInfo.betsOnOppDetails();
        },
        'oppBetsOnMe':function(){
           $('.bets-player-1').hide(); 
           $('.betsonopponent').hide();
           for(var i=2;i<=5;i++){
                $('.player'+i+'-name-txt').removeClass('row-height-betsonopp');
                $('.player'+i+'-andar-value').removeClass('row-height-betsonopp');
                $('.player'+i+'-bahar-value').removeClass('row-height-betsonopp');
                $('.player'+i+'-total-value').removeClass('row-height-betsonopp');
                $('.player'+i+'-name-txt').addClass('row-height-oppbetsonme');
                $('.player'+i+'-andar-value').addClass('row-height-oppbetsonme');
                $('.player'+i+'-bahar-value').addClass('row-height-oppbetsonme');
                $('.player'+i+'-total-value').addClass('row-height-oppbetsonme');
           }
           _betsInfo.oppBetsOnMeDetails();
        }
    };
    this.onBetsTabClick = function(_id){
        if(selectedTab !== _id){
            if(selectedTab !== ''){
              $(selectedTab).removeClass('selected-highlight');
              $(selectedTab).addClass('normal-highlight');
            }
            selectedTab = '#'+_id;
            if(!$(selectedTab).hasClass('selected-highlight')){
              $(selectedTab).removeClass('normal-highlight');
              $(selectedTab).addClass('selected-highlight');
            }
            selectedTabHandler[_id]();  
        }
    };
    this.betsOnOppDetails = function(){
        _betsInfo.clearPlayerDetails();
        for(var i=0;i<objBetsInfo.betOwnOppsLst.length;i++){
           $('.player'+(i+1)+'-name-txt').text(objBetsInfo.betOwnOppsLst[i].userName);
           $('.player'+(i+1)+'-andar-value').text(objBetsInfo.betOwnOppsLst[i].andarBet);
           $('.player'+(i+1)+'-bahar-value').text(objBetsInfo.betOwnOppsLst[i].baharBet);
           $('.player'+(i+1)+'-total-value').text(objBetsInfo.betOwnOppsLst[i].totalBet);
        }
        $('.total-andar-value').text(objBetsInfo.totalAndarBet);
        $('.total-bahar-value').text(objBetsInfo.totalBaharBet);
        $('.total-overall-value').text(objBetsInfo.overAllBet);
    };
    this.oppBetsOnMeDetails = function(){
        _betsInfo.clearPlayerDetails();
        for(var i=0;i<objBetsInfo.betsOnMeLst.length;i++){
           $('.player'+(i+2)+'-name-txt').text(objBetsInfo.betsOnMeLst[i].userName);
           $('.player'+(i+2)+'-andar-value').text(objBetsInfo.betsOnMeLst[i].andarBet);
           $('.player'+(i+2)+'-bahar-value').text(objBetsInfo.betsOnMeLst[i].baharBet);
           $('.player'+(i+2)+'-total-value').text(objBetsInfo.betsOnMeLst[i].totalBet);
        }
        $('.total-andar-value').text(objBetsInfo.totalOppAndarBet);
        $('.total-bahar-value').text(objBetsInfo.totalOppBaharBet);
        $('.total-overall-value').text(objBetsInfo.overAllOnMeBet);
    };
    this.clearPlayerDetails = function(){
        for(var i=1;i<=5;i++){
           $('.player'+i+'-name-txt').text("-");
           $('.player'+i+'-andar-value').text("-");
           $('.player'+i+'-bahar-value').text("-");
           $('.player'+i+'-total-value').text("-");
        }
    };
    this.onCloseHandler = function(){
        BOTTOM_LAYER_POPUP = '';
        $('.bottom-layer').hide();
        $('.bets-info-popup').hide();
        $('.popup-container-bg').hide();
        $('.popup-container').hide();
        $('#myBetsBtn').addClass('autoskip_inactive');
        $('#myBetsBtn').removeClass('autoskip_active');
    };
    this.init();
};
function GameHelpPopup(){
    var helpPopupArea = '   <div class="help-popup">  '  + 
   '       <div class="help-content-title">  '  + 
   '           <span class="help-title-txt">HELP</span>  '  + 
   '       </div>  '  + 
   '       <div class="help-content"></div>  '  + 
   '       <div class="help-popup-close-btn close_btn_game" onclick="_gameHelpPopup.onCloseHandler(true);"></div>  '  + 
   '  </div>  ' ;     
  this.init = function(){
      $('.bottom-layer').append(helpPopupArea);
  };
  this.soundPopupShow = function(){
      if(BOTTOM_LAYER_POPUP !== ""){
        $(BOTTOM_LAYER_POPUP).hide();
      }
      $('.bottom-layer').show();  
      $('.help-popup').show();
      $('.popup-container-bg').show();
      $('.popup-container').show();
      BOTTOM_LAYER_POPUP = '.help-popup';
  };
  this.onCloseHandler = function(flag){
      if(flag){
          _sound.play('closebtn');
      }
      $('.bottom-layer').hide();  
      $('.help-popup').hide();
      $('.popup-container-bg').hide();
      $('.popup-container').hide();
      BOTTOM_LAYER_POPUP = '';
  };
   this.init();
};



function GameTable(){
    'use strict';
    
    var prevAndarCard = "";
    var prevBaharCard = "";
    var prevHouseCard = "";
    var dealerCmnMsgTimer;
    var dealerMsgTimer;
    var winAnimTimer = {};
    var xpAnimTimer = {};
    var gameWinType = -1;//either andar or bahar 0=andar,1=bahar
    var playerLoseTimer = {};
    var winAmtToPlayerTimer = {};
    
    this.init = function(){
        $("#tableInfoContainerId").append(   
            '  <div id="tableInfoId" class="tableInfo">'  + 
            '      <div id="tableNameId" class="tableName"></div>'  + 
            '  </div>  '  +                
            '   <div id="dealerMsg" class="dealer-msg callouts--right">  '  + 
            '       <div id="dealerMsgTxt" class="dealer-msg-txt"></div>  '  + 
            '   </div>  '  + 
            '   <div id="dealerCommonMsg" class="dealer-common-msg">  '  + 
            '       <div id="dealerCommonMsgTxt" class="dealer-common-msg-txt"></div>  '  + 
            '   </div>  '+
            '   <div id="tablePotAmount" class="table-pot-amount pot_bg">POT - 0</div>  '  + 
            '   <div id="tableCardHolder" class="table-card-holder">  '  + 
            '       <div id="houseCard" class="house-card">'+
            '       <div id="txtHouseCard" class="house-card-txt">HOUSE CARD</div>  '  + 
            '</div>  '  + 
            '       <div id="andarCard" class="andar-card">ANDAR</div>  '  + 
            '       <div id="diamondSymbol" class="diamond-symbol table_card_divider"></div>  '  + 
            '       <div id="baharCard" class="bahar-card">BAHAR</div>  '  + 
            '       <div id="carddectxtId" class="carddectxt">CARD DECK</div>  '  + 
            '       <div id="cardDeck0" class="card-deck card_back"></div>  '  + 
            '       <div id="cardDeck1" class="card-deck card_back"></div>  '  + 
            '       <div id="cardDeck2" class="card-deck card_back"></div>  '  + 
            '       <div id="cardDeck3" class="card-deck card_back"></div>  '  + 
            '   </div>  '  + 
            '  <div class="house-card-anim"></div>  '  + 
            '  <div class="andar-card-anim"></div>  '  + 
            '  <div class="bahar-card-anim"></div>  ' +
            '  <div id="tableBetInfoId" class="tableBetInfo">'  + 
            '       <div class="infomin-bet-holder">  '  + 
            '           <div class="info-table-minbet-txt" id="infoTableMinbetTxt">MINIMUM BET</div>  '  + 
            '           <div class="info-table-minbet" id="infoTableMinbet">" - 0"</div>  '  + 
            '       </div>  '  + 
            '       <div class="infomax-bet-holder">  '  + 
            '           <div class="info-table-maxbet-txt" id="infoTableMaxbetTxt">MAXIMUM BET</div>  '  + 
            '           <div class="info-table-maxbet" id="infoTableMaxbet">" - 0"</div>  '  + 
            '       </div>  '  + 
            '       <div class="infoforcebet-holder">   '  + 
            '           <div class="info-table-forcebet-txt" id="infoTableForcebetTxt">FORCED BET</div>  '  + 
            '           <div class="info-table-forcebet" id="infoTableForcebet">" - 0"</div>  '  + 
            '       </div>  '  + 
            '  </div>  '); 
 
        $('.tableName').text(GAME_TABLE_DETAILS.tableName);
        $('.info-table-minbet').html(" - "+onFindDenamination(GAME_TABLE_DETAILS.minBet,true));
        $('.info-table-maxbet').html(" - "+onFindDenamination(GAME_TABLE_DETAILS.maxBet,true));
        $('.info-table-forcebet').html(" - "+onFindDenamination(GAME_TABLE_DETAILS.ante,true));
    };
    /*
     * name : onUpdateStartTimer
     * desc : Game start timer displays here.
    */
    this.onUpdateStartTimer = function(time){
        if(!$('.dealer-common-msg').is(":visible")){
            $(".dealer-common-msg").show();
            _gameTable.onClearTableCards();
        }
        else if(time<1){
            $(".dealer-common-msg").hide();
        }
        
        $(".dealer-common-msg-txt").text("Game starts in "+time+" secs");
    };
    /*
     * clearing all card dealing related timer s and cards.
     * @returns {undefined}
     */
    this.clearAnimTimer = function(){
        clearInterval(CARD_DEAL_TIMER);
        clearInterval(winAnimTimer);
        clearTimeout(xpAnimTimer);
        clearTimeout(playerLoseTimer);
        clearTimeout(winAmtToPlayerTimer);
        if($(".bahar-card").hasClass("blink_me")){
            $(".bahar-card").removeClass("blink_me");
        }
        if($(".andar-card").hasClass("blink_me")){
            $(".andar-card").removeClass("blink_me");
        }
        if(prevAndarCard !== ""){
            $(".andar-card").removeClass(prevAndarCard);
            $(".andar-card-anim").removeClass(prevAndarCard);
        }        
        if(prevBaharCard !== ""){
            $(".bahar-card").removeClass(prevBaharCard);
            $(".bahar-card-anim").removeClass(prevBaharCard);
        }
        if($(".bahar-card").hasClass("ab-card-image-setup")){
            $(".bahar-card").removeClass("ab-card-image-setup");
        }
        if($(".andar-card").hasClass("ab-card-image-setup")){
            $(".andar-card").removeClass("ab-card-image-setup");
        }
    };
    /*
     * Deal cards from server.
     * @param {type} obj
     * @returns {undefined}
     */
    this.onDealCardDisplay = function(obj,startTypeId){
        /*obj = {"action":"GameCardPlayResponse",
            "tableId":10001,
            "winnerDetails":[{"winAmount":10000,"actionMessage":"Dhayal Wins 10000","xpPoints":4,"seatIndex":0,"userId":863,"tempBalance":21289810},
                             {"winAmount":10000,"actionMessage":"Mani Wins 10000","xpPoints":4,"seatIndex":1,"userId":863,"tempBalance":21289810}],
            "xpDetails":[{"xpPoints":4,"seatIndex":0,"userId":863,"tempBalance":21289810},{"xpPoints":2,"seatIndex":1,"userId":864,"tempBalance":137990}],
            "winnerSeatIndex":[0],
            "lossPlayerIndex":[1],
            "cards":["spade_12","diamond_13","heart_12","club_13","spade_14","diamond_3","heart_10","club_5"],
            "cardDelay":1,"responseType":"common"};*/
        var _obj = {};
        var _cardTypeId = startTypeId;
        var i = 0; 
        gameWinType = -1;
        gameWinType = (Number(obj.cards.length)%2);
        if(CARD_DEAL_TIMER !== null){
           _gameTable.clearAnimTimer();
        }
        CARD_DEAL_TIMER = setInterval(
                         function(){                          
                            _obj.cardTypeId = _cardTypeId;
                            _obj.card = obj.cards[i];
                            _obj.winFlag = 0;
                            if(i === (obj.cards.length -1)){
                                _obj.winFlag = _cardTypeId;
                            }                       
                            _gameTable.onUpdateTableInfo(_obj);
                            if(_cardTypeId === 1){
                                _cardTypeId = 2;
                            }else{
                                _cardTypeId = 1;
                            } 
                            i++;
                            if(i === obj.cards.length || (obj.cards === undefined)){
                                clearInterval(CARD_DEAL_TIMER);
                                if(obj.winnerDetails !== undefined){
                                    if(obj.winnerDetails.length > 0){
                                        _gameTable.onWindetailsDisplay(obj.winnerDetails,obj.lossPlayerIndex,obj.xpDetails);
                                    } 
                                }                        
                                return;
                            }
                         }, 1000);
    };
    /*
     * Display win details to players
     * @returns {undefined}
     */
    this.onWindetailsDisplay = function(winnerObj,losserObj,xpObj){
        _gameTable.onDealerCommonMsgShow(true,(_localization.getText['loss_chip_collect']+(gameWinType==0?"Bahar":"Andar")+" chips"),1500);

        //---move player loss chips to dealer---
        playerLoseTimer = setTimeout(function(){
            _gameTable.onMovePlayerLoseAmtToDealer(losserObj);
        },500);
        
        //---call win chip move animation from dealer to player after lose amount collected---
        winAmtToPlayerTimer = setTimeout(function(){
            _gameTable.onMoveWinAmtToPlayer(winnerObj,xpObj);
        },2000);
    };
    /**
     * Move player win amount to players from dealer
     * @param {type} obj
     * @param {type} xpObj
     * @returns {undefined}
     */
    this.onMoveWinAmtToPlayer = function(obj,xpObj){
        var i=0;
        var j=0;
        winAnimTimer = setInterval(
                function(){
                    _seatAnimation.chipAnim(SHUFFLED_SEAT_ORDER[obj[i].seatIndex],Number(obj[i].winAmount)/2,
                        'player_'+SHUFFLED_SEAT_ORDER[obj[i].seatIndex],1000,
                        function(){
                            if(_seatManager !== null){
                               _seatManager.onUpdateAndarBaharBet(obj[(i-1)].seatIndex,obj[(i-1)].winAmount,(gameWinType==0?2:1)); 
                            }
                            for(j=0;j<obj.length;j++){
                                if(CURRENT_USER_SEAT_INDEX === obj[j].seatIndex){
                                    _seatManager.onUpdateUserBalance(obj[j].seatIndex,obj[j].tempBalance);
                                    return;
                                }
                            }
                        });
                    _gameTable.onDealerCommonMsgShow(true,obj[i].actionMessage,5000);
                    i++;
                    if(i === obj.length){
                        clearInterval(winAnimTimer);
                        if(xpObj !== undefined){
                            xpAnimTimer = setTimeout(function(){
                                _seatAnimation.xpAnim(("+ "+xpObj.xpPoints),500);
                                clearTimeout(xpAnimTimer);
                            },1000);   
                        }               
                        return;
                    }
                }, 1100);
    }
    /**
     * Collect lose palyer chips to dealer before give win chips
     * @param {type} losePlayerList
     * @returns {undefined}
     */
    this.onMovePlayerLoseAmtToDealer = function(lossPlayerList)
    {
        for(var i = 0; i < lossPlayerList.length; i++){
            var lossAmount = 0;
            if(gameWinType == 0){
                //andar win
                lossAmount = Number(_seatManager.onGetBaharBet(lossPlayerList[i]));
                _seatManager.onUpdateAndarBaharBet(lossPlayerList[i],0,1);
                if(lossAmount > 0){
                    _seatAnimation.chipAnim(SHUFFLED_SEAT_ORDER[lossPlayerList[i]],lossAmount,"dealer",1000);
                }
            }else{
                //bahar win
                lossAmount = Number(_seatManager.onGetAndarBet(lossPlayerList[i]));
                _seatManager.onUpdateAndarBaharBet(lossPlayerList[i],0,2);
                if(lossAmount > 0){
                    _seatAnimation.chipAnim(SHUFFLED_SEAT_ORDER[lossPlayerList[i]],lossAmount,"dealer",1000);
                }
            }
        }
    }
    /*
     * name : onUpdateTableInfo
     * desc : It handles card dealing on table.
    */
    this.onUpdateTableInfo = function(obj){        
        if(obj.cardTypeId === 1){
            if(prevBaharCard !== ""){
                $(".bahar-card-anim").removeClass(prevBaharCard);
            }
            $(".bahar-card-anim").addClass(obj.card);
            animCards['baharcard'](obj.card,obj.winFlag);
        }else if(obj.cardTypeId === 2){
            if(prevAndarCard !== ""){
                $(".andar-card-anim").removeClass(prevAndarCard);
            }
            $(".andar-card-anim").addClass(obj.card);
            animCards['andarcard'](obj.card,obj.winFlag);
        }else{
            
        }
    };
    /*
     * name : onUpdatePotAmount
     * desc : It handles update pot amount.
    */
    this.onUpdatePotAmount = function(amount){
       if(amount > 0){
        var number =  $('.table-pot-amount').text().split('-')[1];
        animateResultCount(true,number,amount,'.table-pot-amount','POT - ');
       }else if(amount === 0){
           $('.table-pot-amount').text('POT - '+amount);
       }
    };
    /*
     * name : onHouseCardShow
     * desc : House card display here.
    */
    this.onHouseCardShow = function(_card,_interrupt){
        if(!_interrupt){
            if(prevHouseCard !== ""){
                $(".house-card-anim").removeClass(prevHouseCard);
            }
            $(".house-card-anim").addClass(_card);
            animCards['housecard'](_card);
        }else{
            $(".house-card").addClass("ab-card-image-setup");
            $(".house-card").addClass(_card);
        }        
        prevHouseCard = _card;
    };
    /*
     * object name : animCards
     * desc : Handling house card , andar card , Bahar card animation.
    */
    var animCards = {
        'housecard':function(_card){
            _sound.play('houseCardPick');
            $(".house-card-anim").show();
            $(".house-card-anim").removeClass('removeanimate');
            $(".house-card-anim").show();
            $(".house-card-anim").animate({
                left: '560px',
                top:'395px'
            },
            500,
            function(){
                if(prevHouseCard !== ""){
                    $(".house-card").removeClass(prevHouseCard);
                }
                if(!$(".house-card").hasClass("ab-card-image-setup")){
                    $(".house-card").addClass("ab-card-image-setup");
                }
                $(".house-card").addClass(_card);
                prevHouseCard = _card;
                $(".house-card-anim").hide();
                $(".house-card-anim").css({
                    'left': '910px',
                    'top': '180px',
                    'opacity':'1',
                    'transition': 'transform 250ms ease-in-out',
                    'position': 'absolute'
                });
                $(".house-card-anim").removeClass('animate');
                $(".house-card-anim").addClass('removeanimate');
            });
            $(".house-card-anim").addClass('animate');              
        },
        'andarcard':function(_card,_winFlag){
            _sound.play('andarSound');
            $(".andar-card-anim").show();
            $(".andar-card-anim").removeClass('removeanimate');
            $(".andar-card-anim").animate({
                left: '800px',
                top:'395px'
            },
            "fast",
            function(){
                if(prevAndarCard !== ""){
                    $(".andar-card").removeClass(prevAndarCard);
                }
                if(!$(".andar-card").hasClass("ab-card-image-setup")){
                    $(".andar-card").addClass("ab-card-image-setup");
                }
                $(".andar-card").addClass(_card);
                prevAndarCard = _card;
                $(".andar-card-anim").hide();
                $(".andar-card-anim").css({
                    'left': '910px',
                    'top': '180px',
                    'transition': 'transform 250ms ease-in-out',
                    'opacity':'1',
                    'position': 'absolute'
                });
                $(".andar-card-anim").removeClass('animate');
                $(".andar-card-anim").addClass('removeanimate');
                
                if(_winFlag === 1 || _winFlag === 2){
                    if(_winFlag === 1){
                        $(".bahar-card").addClass("blink_me");
                    }
                    if(_winFlag === 2){
                        $(".andar-card").addClass("blink_me");
                    }
                    _sound.play('winSound');
                }
            });
            $(".andar-card-anim").addClass('animate');
        },
        'baharcard':function(_card,_winFlag){   
            _sound.play('baharSound');
            $(".bahar-card-anim").show();
            $(".bahar-card-anim").removeClass('removeanimate');
            $(".bahar-card-anim").animate({
                left: '1020px',
                top:'395px'
            },
            "fast",
            function(){
                if(prevBaharCard !== ""){
                    $(".bahar-card").removeClass(prevBaharCard);
                }
                if(!$(".bahar-card").hasClass("ab-card-image-setup")){
                    $(".bahar-card").addClass("ab-card-image-setup");
                }
                $(".bahar-card").addClass(_card);
                prevBaharCard = _card;
                $(".bahar-card-anim").hide();
                $(".bahar-card-anim").css({
                    'left': '910px',
                    'top': '180px',
                    'transition': 'transform 250ms ease-in-out',
                    'opacity':'1',
                    'position': 'absolute'
                });
                $(".bahar-card-anim").removeClass('animate');
                $(".bahar-card-anim").addClass('removeanimate');
                
                if(_winFlag === 1 || _winFlag === 2){
                    if(_winFlag === 1){
                        $(".bahar-card").addClass("blink_me");
                    }
                    if(_winFlag === 2){
                        $(".andar-card").addClass("blink_me");
                    }
                    _sound.play('winSound');
                }
            });
            $(".bahar-card-anim").addClass('animate');
        }
    };
    /*
     * Show dealer message
     * @param {boolean} flag
     * @param {string} msg
     * @returns {undefined}
     */
    this.onDealerMsgShow = function(flag,msg,duration){        
        if(flag){
            $('.dealer-msg-txt').text(msg);
            $('.dealer-msg').show();
            if(duration !== undefined){
                if(dealerMsgTimer !== undefined){
                    clearTimeout(dealerMsgTimer);
                }
                dealerMsgTimer = setTimeout(function(){
                    $('.dealer-msg').hide();
                },duration);
            }            
        }else{
           ('.dealer-msg').hide(); 
        }
    };
    /*
     * Show dealer common message
     * @param {boolean} flag
     * @param {string} msg
     * @returns {undefined}
     */
    this.onDealerCommonMsgShow = function(flag,msg,duration){
        if(flag){
            $('.dealer-common-msg-txt').text(msg);
            $('.dealer-common-msg').show();
            if(dealerCmnMsgTimer !== undefined){
                clearTimeout(dealerCmnMsgTimer);
            }
            if(duration !== undefined){                
                dealerCmnMsgTimer = setTimeout(function(){
                    $('.dealer-common-msg').hide();
                },duration);
            }            
        }else{
           ('.dealer-common-msg').hide(); 
        }
    };
    /*
     * name : onClearTableCards
     * desc : it clears all cards from previous game.
    */
    this.onClearTableCards = function(){
        clearInterval(CARD_DEAL_TIMER);
        clearInterval(winAnimTimer);
        clearTimeout(xpAnimTimer);
        clearTimeout(playerLoseTimer);
        clearTimeout(winAmtToPlayerTimer);
        
        if(prevBaharCard !== ""){
            $(".bahar-card").removeClass(prevBaharCard);
            $(".bahar-card-anim").removeClass(prevBaharCard);
        }
        if(prevAndarCard !== ""){
            $(".andar-card").removeClass(prevAndarCard);
            $(".andar-card-anim").removeClass(prevAndarCard);
        }        
        if(prevHouseCard !== ""){
            $(".house-card").removeClass(prevHouseCard);
            $(".house-card-anim").removeClass(prevHouseCard);
        }
        if($(".bahar-card").hasClass("ab-card-image-setup")){
            $(".bahar-card").removeClass("ab-card-image-setup");
        }
        if($(".andar-card").hasClass("ab-card-image-setup")){
            $(".andar-card").removeClass("ab-card-image-setup");
        }
        if($(".house-card").hasClass("ab-card-image-setup")){
            $(".house-card").removeClass("ab-card-image-setup");
        }
        if($(".bahar-card").hasClass("blink_me")){
            $(".bahar-card").removeClass("blink_me");
        }
        if($(".andar-card").hasClass("blink_me")){
            $(".andar-card").removeClass("blink_me");
        }
        prevHouseCard = "";
        prevAndarCard = "";
        prevBaharCard = "";
    };
    this.init();
}

function FeatureBet(){
    'use strict';
    
    var playerServerIndexArr=[];
     /*
     * name : init
     * desc : intiates feature bet functionalities
    */
    this.init = function () {
            $('#featureBetParentId').append('<div class="mybets-footer-bg mybet_bg">'+
                                            '<div class="mybets-base-titile">MY BETS</div>'+
                                            '<div class="mybets-info-base footer_user_icon_bg"></div>'+
                                            '<div class="mybets-info-pname"></div>'+
                                            '<div class="mybets-info-andarchip left_a"></div>'+
                                            '<div class="mybets-info-andarval"></div>'+
                                            '<div class="mybets-info-baharchip right_b"></div>'+
                                            '<div class="mybets-info-baharval"></div>'+
                                        '</div>'+
                                        '<div id="fbFooterBg" class="fb-footer-bg featurebet_bg"></div>'+
                                        '<div class="fb-footer-title">MY BETS ON OPPONENT</div>'+                                        
                                        '<div id="oppPlayerHolder" class="opp-player-holder"></div>');
                                
        /**
         * in FeatureBet panel current user does not come. so the index 2 is not need here for center player.
         * so the index will be 0,1,3,4 so why (i+1) if i>1
         */
        for(var i=0;i<(TOTAL_SEAT-1);i++){
            $('.opp-player-holder').append(
                '<div id="fbplayerId-'+i+'" class="fbplayer-'+i+'" onclick="_featureBet.onPlayerSelect('+(i>1?(i+1):i)+')">  '  + 
                '  <div id="fbplayerbaseId-'+i+'" class="fbplayerbase-'+i+' footer_user_icon_bg"></div>  '  + 
                '  <div id="fbplayeroverlayId-'+i+'" class="fbplayeroverlay-'+i+'"></div>  '  + 
                '  <div id="fbplayernameId-'+i+'" class="fbplayername-'+i+'"></div>  '  + 
                '  <div class="fbbetandarchip-'+i+' left_a"></div>  '  + 
                '  <div class="fbbet-andarval-'+i+'"></div>'+
                '  <div class="fbbetbaharchip-'+i+' right_b"></div>  '  + 
                '  <div class="fbbet-baharval-'+i+'"></div>'+
                '</div>'
            );  
        }
    };
    /*
     * it updates opponent bets info on footer
     * @returns {undefined}
     */
    this.onOpponentBetsUpdation = function(_datas){
        _gameFooter.onShowHideFooter(false,false);
        for(var i=0;i<5;i++){
            if(_datas[i] !== undefined){
                if(i === 0){
                    $('.mybets-info-pname').text(_datas[i].userName);
                    $('.mybets-info-andarval').text(_datas[i].andarBet);
                    $('.mybets-info-baharval').text(_datas[i].baharBet);
                }else{
                    $('.fbbetandarchip-'+(i-1)).css({'opacity':1});
                    $('.fbbetbaharchip-'+(i-1)).css({'opacity':1});       
                    $('.fbplayerbase-'+(i-1)).css({'opacity':1});
                    $('.fbplayername-'+(i-1)).text(_datas[i].userName);
                    $('.fbbet-andarval-'+(i-1)).text(_datas[i].andarBet);
                    $('.fbbet-baharval-'+(i-1)).text(_datas[i].baharBet);
                }
            }else{
                if(i !== 0){
                    $('.fbbetandarchip-'+(i-1)).css({'opacity':0.5});
                    $('.fbbetbaharchip-'+(i-1)).css({'opacity':0.5});
                    $('.fbplayerbase-'+(i-1)).css({'opacity':0.5});
                    $('.fbplayername-'+(i-1)).text("");
                    $('.fbbet-andarval-'+(i-1)).text("");
                    $('.fbbet-baharval-'+(i-1)).text("");
                }
            }
        }
    };
    /**
     * Create local player object to make FEATURE BET
     * @param {type} resObj
     * @returns {undefined}
     */
    this.onCreateLocalPlayerObject = function(resObj){
        if(Number(resObj.seatIndex) != CURRENT_USER_SEAT_INDEX && !PLAYERS_OBJ[resObj.seatIndex]){
            PLAYERS_OBJ[resObj.seatIndex] = {};
            PLAYERS_OBJ[resObj.seatIndex]['seatIndex'] = resObj.seatIndex;
            PLAYERS_OBJ[resObj.seatIndex]['userName'] = resObj.userName;
            PLAYERS_OBJ[resObj.seatIndex]['avatar'] = resObj.avatarUrl;
            PLAYERS_OBJ[resObj.seatIndex]['andarBetBalance'] = 0;
            PLAYERS_OBJ[resObj.seatIndex]['baharBetBalance'] = 0;
            PLAYERS_OBJ[resObj.seatIndex]['andarTotalFeatureBet'] = 0;
            PLAYERS_OBJ[resObj.seatIndex]['baharTotalFeatureBet'] = 0;
            PLAYERS_OBJ[resObj.seatIndex]['isShowFeatureBetSymbol'] = false;
            console.log("Player object created for seatIndex : ",resObj.seatIndex," obj is : ",PLAYERS_OBJ[resObj.seatIndex]);
        }
    }
    /**
     * Update opponent players local object details for featurebet
     * @returns {undefined}
     */
    this.onUpdateLocalPlayerObjectDetails = function(isUpdateByServer,resObj,isClear){
        if(isUpdateByServer == true){
            //----value update from SERVER when opponent player made own and opponent bet
            if(resObj.responseType == "opponent"){
                if(PLAYERS_OBJ[resObj.seatIndex]){
                    if(resObj.betVariantType == 1){
                        //---update bahar bet balance values---
                        PLAYERS_OBJ[resObj.seatIndex]['baharBetBalance'] = Number(resObj.betBalance?resObj.betBalance:0)-PLAYERS_OBJ[resObj.seatIndex]['baharTotalFeatureBet'];
                    }else{
                        //---update andar bet balance values---
                        PLAYERS_OBJ[resObj.seatIndex]['andarBetBalance'] = Number(resObj.betBalance?resObj.betBalance:0)-PLAYERS_OBJ[resObj.seatIndex]['andarTotalFeatureBet'];
                    }
                    this.onCheckBetLimitByServerUpdate(resObj);
                }else{
                    console.log("<<< PLAYERS_OBJ not found for seatIndex : ",resObj.seatIndex);
                }
            }
        }else{
            //---value update form LOCAL when user made feature bet
            if(PLAYERS_OBJ[resObj.seatIndex]){
                if(resObj.betVariantType == 1){
                    //---update bahar bet values---
                    this.onUpdateBaharFeatureBet(resObj,isClear);
                }else{
                    //---update andar bet values---
                    this.onUpdateAndarFeatureBet(resObj,isClear);
                }
            }else{
                console.log("<<< PLAYERS_OBJ not found for seatIndex : ",resObj.seatIndex);
            }
        }
        
        this.onUpdateFeatureBetPanelPlayerDetails();
    }
    /**
     * Update Andar feature amount
     * @param {type} resObj
     * @returns {undefined}
     */
    this.onUpdateAndarFeatureBet = function(resObj,isClear){
        if(isClear){
            PLAYERS_OBJ[resObj.seatIndex]['andarBetBalance'] += Number(PLAYERS_OBJ[resObj.seatIndex]['andarTotalFeatureBet']);
            PLAYERS_OBJ[resObj.seatIndex]['andarTotalFeatureBet'] = 0;
        }else{
            var currentTotalAndarBet = (Number(PLAYERS_OBJ[resObj.seatIndex]['andarTotalFeatureBet'])+Number(resObj.betAmount));
            console.log("onUpdateAndarFeatureBet ",resObj.betAmount," andarBetBalance ",PLAYERS_OBJ[resObj.seatIndex]['andarBetBalance']);
            if(Number(resObj.betAmount) > Number(PLAYERS_OBJ[resObj.seatIndex]['andarBetBalance'])){
                console.log("---Andar feature bet FAILURE because of not enough points---");
                _lobbyErrorPopup.showErrorPopup(true,"Error","OPPONENT BET BALACE NOT ENOUGH TO FEATURE BET");
            }else{
                PLAYERS_OBJ[resObj.seatIndex]['andarTotalFeatureBet'] = currentTotalAndarBet;
                PLAYERS_OBJ[resObj.seatIndex]['andarBetBalance'] -= Number(resObj.betAmount);
                console.log("---Andar feature bet SUCCESS ---seatIndex : ",resObj.seatIndex," totalAndarBet ",PLAYERS_OBJ[resObj.seatIndex]['andarTotalFeatureBet']);
            }
        }
    }
    /**
     * Update Bahar feature amount
     * @param {type} resObj
     * @returns {undefined}
     */
    this.onUpdateBaharFeatureBet = function(resObj,isClear){
        if(isClear){
            PLAYERS_OBJ[resObj.seatIndex]['baharBetBalance'] += Number(PLAYERS_OBJ[resObj.seatIndex]['baharTotalFeatureBet']);
            PLAYERS_OBJ[resObj.seatIndex]['baharTotalFeatureBet'] = 0;
        }else{
            var currentTotalBaharBet = (Number(PLAYERS_OBJ[resObj.seatIndex]['baharTotalFeatureBet'])+Number(resObj.betAmount));
            if(Number(resObj.betAmount) > Number(PLAYERS_OBJ[resObj.seatIndex]['baharBetBalance'])){
                console.log("---Bahar feature bet FAILURE because of not enough points---");
                _lobbyErrorPopup.showErrorPopup(true,"Error","OPPONENT BET BALACE NOT ENOUGH TO FEATURE BET");
            }else{
                PLAYERS_OBJ[resObj.seatIndex]['baharTotalFeatureBet'] = currentTotalBaharBet;
                PLAYERS_OBJ[resObj.seatIndex]['baharBetBalance'] -= Number(resObj.betAmount);
                console.log("---Bahar feature bet SUCCESS ---seatIndex : ",resObj.seatIndex," totalBaharBet ",PLAYERS_OBJ[resObj.seatIndex]['baharTotalFeatureBet']);
            }
        }
    }
    /**
     * Check feature bet value with server betbalance to clear the feature bet
     * @param {type} resObj
     * @returns {undefined}
     */
    this.onCheckBetLimitByServerUpdate = function(resObj){
        if(resObj.betVariantType == 1){
            if(Number(PLAYERS_OBJ[resObj.seatIndex]['baharTotalFeatureBet']) > Number(PLAYERS_OBJ[resObj.seatIndex]['baharBetBalance'])){
                console.log("---reset BAHAR feature bet for seatIndex : ",resObj.seatIndex);
                PLAYERS_OBJ[resObj.seatIndex]['baharTotalFeatureBet'] = 0;
            }
        }else{
            if(Number(PLAYERS_OBJ[resObj.seatIndex]['andarTotalFeatureBet']) > Number(PLAYERS_OBJ[resObj.seatIndex]['andarBetBalance'])){
                console.log("---reset ANDAR feature bet for seatIndex : ",resObj.seatIndex);
                PLAYERS_OBJ[resObj.seatIndex]['andarTotalFeatureBet'] = 0;
            }
        }
    }
    /**
     * Feature bet panel reset for every BetAcceptance response value updation
     * @returns {undefined}
     */
    this.onResetPlayersFeatureBetPanel = function(){
        for(var i=0; i<(ORIGINAL_SEAT_ORDER.length-1); i++){
            $(".fbplayername-"+i).text("");
            $(".fbbetsymbol-"+i).hide();
        }
    }
    /**
     * set player in feature bet panel
     * @returns {undefined}
     */
    this.onUpdateFeatureBetPanelPlayerDetails = function(){
        this.onResetPlayersFeatureBetPanel();
        
        var i=0;
        var featureBetPlayerCount=0;
        playerServerIndexArr = [];
        for(i=0; i<ORIGINAL_SEAT_ORDER.length; i++){
            if(PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[i]] && i!=2){
                if(Number(PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[i]]['andarBetBalance']) > 0 || Number(PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[i]]['baharBetBalance']) > 0 || Number(PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[i]]['baharTotalFeatureBet']) > 0 || Number(PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[i]]['andarTotalFeatureBet']) >0)
                {
                   $(".fbplayername-"+featureBetPlayerCount).text(PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[i]]['userName']);
                   playerServerIndexArr.push(i);
                   
                   if(Number(PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[i]]['baharTotalFeatureBet']) > 0 || Number(PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[i]]['andarTotalFeatureBet']) >0){
                        $(".fbbetsymbol-"+featureBetPlayerCount).show(); 
                        _seatManager.onShowHideFutureBetIcon(ORIGINAL_SEAT_ORDER[i],true);
                   }else{
                       _seatManager.onShowHideFutureBetIcon(ORIGINAL_SEAT_ORDER[i],false);
                   }
                   
                   featureBetPlayerCount++;
                }
            }
        }
        
        if(featureBetPlayerCount <= 0){
            _featureBet.onShowHideFeatureBet(false);
            //_gameFooter.enableBetDisabler(true);
        }
    }
    /**
     * User selected for feature bet
     * @param {type} selectedPlayerId
     * @returns {undefined}
     */
    this.onPlayerSelect = function(selectedPlayerId){
        console.log("----onPlayerSelect----id---- : ",selectedPlayerId," and playerObj ",PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[playerServerIndexArr[selectedPlayerId]]]);
        if(PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[playerServerIndexArr[selectedPlayerId]]]){
            console.log("************FeatureBet Available************");
            FEATURE_BET_SELECTED_SEAT_INDEX = ORIGINAL_SEAT_ORDER[playerServerIndexArr[selectedPlayerId]];
            //_gameFooter.onUpdateFeatureBetPlayerDetails(PLAYERS_OBJ[FEATURE_BET_SELECTED_SEAT_INDEX]);
        }
    }
    /**
     * Show or Hide footer to show feature bet option
     * @param {type} show
     * @returns {undefined}
     */
    this.onShowHideFeatureBet = function(show){
        if(show){
            $('.betpanelparent').hide();
            $('.featurebetparent').css({'display':'block',"top":'210px'});
            $('.featurebetparent').animate({"top":'0px'},200,"linear",function(){_featureBet.onCompleteFeatueBetShowHideAnim(true);});
        }else{
            if($('.featurebetparent').css("display") == "none" && $('.featurebetparent').css("top") == "210px"){
                _gameFooter.onShowHideFooter(true);
            }else{
                $('.featurebetparent').css({'display':'block',"top":'0px'});
                $('.featurebetparent').animate({"top":'210px'},150,"linear",function(){_featureBet.onCompleteFeatueBetShowHideAnim(false);});
            }
        }
    }
    /**
     * Show or Hide Footer container after Feature Bet contianer hide or show complete
     * @param {type} show
     * @returns {undefined}
     */
    this.onCompleteFeatueBetShowHideAnim = function(show){
        console.log("FeatureBet animation compelted for ",show);
        if(show==false){
            $('.featurebetparent').css({'display':"none","top":'210px'});
            _gameFooter.onShowHideFooter(!show);
        }
    }
    /**
     * send all the feature bets to server for user opponenet bet
     * @returns {undefined}
     */
    this.onSendFeatureBetRequestToServer = function(){
        console.log("<<<<<onSendFeatureBetRequestToServer>>>>>");
        var i=0;
        var obj = {
                    "action" : "FutureBetRequest",
                    "sessionId" : USER_SESSION_ID,
                    "tableId" : TABLE_ID
                };
        var futureBets = [];
        
        for(i=0; i<ORIGINAL_SEAT_ORDER.length; i++){
            if(PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[i]] && i!=2){
                if(Number(PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[i]]['baharTotalFeatureBet']) > 0 || Number(PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[i]]['andarTotalFeatureBet']) > 0)
                {
                   console.log("----FeatureBet Values send to server :: seatIndex : ",PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[i]]['seatIndex']," AndarBet : ",PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[i]]['andarTotalFeatureBet']," BaharBet : ",PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[i]]['baharTotalFeatureBet']);
                   if(Number(PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[i]]['baharTotalFeatureBet']) > 0){
                       futureBets.push({"oppUserSessionId":_seatManager.onGetUserSessionId(PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[i]]['seatIndex']),"betType":2,"betVariantType":1,"betAmount":Number(PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[i]]['baharTotalFeatureBet'])});
                       PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[i]]['baharTotalFeatureBet'] = 0;
                   }
                   if(Number(PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[i]]['andarTotalFeatureBet']) > 0){
                       futureBets.push({"oppUserSessionId":_seatManager.onGetUserSessionId(PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[i]]['seatIndex']),"betType":2,"betVariantType":2,"betAmount":Number(PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[i]]['andarTotalFeatureBet'])});
                       PLAYERS_OBJ[ORIGINAL_SEAT_ORDER[i]]['andarTotalFeatureBet'] = 0;
                   }
                }
            }
        }
        
        if(futureBets.length > 0){
            obj["futureBets"] = futureBets; 
            _tableScoketHandling.onSendTableSocketRequest(obj);
            console.log("--feature bet obj : ",obj);
            IS_FUTUREBET_REQUEST_SENT = true;
        }
        
    }
    
    /**
     * Enable and Disable the feature bet based on the player turn
     * @param {type} isEnable
     * @returns {undefined}
     */
    this.onEnableFeatureBet = function(isEnable){
        if(isEnable){
            //---feature bet enable
            IS_MY_TURN = false;
            IS_ENABLED_FEATURE_BET = true;
            _gameFooter.onShowHideFooter(false);
        }else{
            //---feature bet disable
            IS_MY_TURN = true;
            IS_ENABLED_FEATURE_BET = false;
            _gameFooter.onShowHideFooter(true,true);
            //_gameFooter.onUpdateOwnPlayerDetailsOnFooter();
        }
    }
    /*
     * name : dispose
     * desc : dispose all variables in to null and "" here.
    */
    this.dispose = function(){
        
    };
}

function BetHandling(){
    'use strict';
    var isOwnAndarBetValid = false;
    var isOwnBaharBetValid = false;
    var isOpponentAndarBetValid = false;
    var isOpponentBaharBetValid = false;
    /**
     * Reset local bet values for OWN bet
     * @returns {undefined}
     */
    this.onResetOwnBetValues = function () {
        TOTAL_OWN_ANDAR_BET = 0;
        TOTAL_OWN_BAHAR_BET = 0;
        TOTAL_OWN_BET = 0;
        
        TOTAL_ANDAR_BET = 0;
        TOTAL_BAHAR_BET = 0;
        TOTAL_BET = 0;
    };
    /**
     * Reset local selected bet chip
     * @returns {undefined}
     */
    this.onResetSelectedBetChip = function(){
        CURRENT_SELECTED_CHIP = GAME_TABLE_DETAILS.chipArr[1];
    }
    /**
     * Set opponent player bet balance to validate opponent bet
     * @param {type} betBalance
     * @returns {undefined}
     */
    this.onSetOpponentBetBalance = function(betBalance){
        console.log("onSetOpponentBetBalance ",betBalance);
        OPPONENT_BET_BALANCE = betBalance;
        //var isChipValueEqualToBalance = false;
        //---change selected chip value to available bet value of opponent betbalance---
        if(CURRENT_SELECTED_CHIP > Number(betBalance)){
            this.onSelectedChipChangeToAvailableBet(betBalance);
        }
    }
    /**
     * change selected chip to available bet value of oppponent bet balance
     * @param {type} amount
     * @returns {undefined}
     */
    this.onSelectedChipChangeToAvailableBet = function(betBalance){
        var i = 0;
        var betChipArr = GAME_TABLE_DETAILS.chipArr;
        for(var i = 0; i<betChipArr.length; i++){
            if(betChipArr[i] >= Number(betBalance)){
                if(betChipArr[i] > Number(betBalance)){
                    if(i != 0){
                        i -= 1;
                    }
                }
                break;
            }
        }
        this.onUpdateSelectedBetChip(i);
    }
    /**
     * Update user bet on andar and bahar after bet error or invalid bet
     * @returns {undefined}
     */
    this.onUpdateUserBetOnSeat = function(){
        _seatManager.onUpdateAndarBaharBet(CURRENT_USER_SEAT_INDEX,TOTAL_BAHAR_BET,1);
        _seatManager.onUpdateAndarBaharBet(CURRENT_USER_SEAT_INDEX,TOTAL_ANDAR_BET,2);
    }
    /**
     * Update selected bet chip value
     */
    this.onUpdateSelectedBetChip = function(chipId){
        if(BET_TYPE == 1){
            if(IS_OPPONENT_PLAYER_SELECTED == true){
                if(this.isValidBetChipForOpponent(GAME_TABLE_DETAILS.chipArr[chipId])){
                    CURRENT_SELECTED_CHIP = GAME_TABLE_DETAILS.chipArr[chipId];
                    _gameFooter.onUpdateBetChipHighlight(chipId);
                }
            }else{
                if(this.isValidBetChipForOwn(GAME_TABLE_DETAILS.chipArr[chipId])){
                    CURRENT_SELECTED_CHIP = GAME_TABLE_DETAILS.chipArr[chipId];
                    _gameFooter.onUpdateBetChipHighlight(chipId);
                }
            }
        }else{
           if(this.isValidBetChipForOpponent(GAME_TABLE_DETAILS.chipArr[chipId])){
                CURRENT_SELECTED_CHIP = GAME_TABLE_DETAILS.chipArr[chipId];
                _gameFooter.onUpdateBetChipHighlight(chipId);
            }
        }
    }
    /**
     * Check chip for OWN bet
     * Validate current selected chip value is less or equal to balance otherwise throw error
     * @param {type} chipValue
     * @returns {undefined}
     */
    this.isValidBetChipForOwn = function(chipValue){
        var isChipValid = false;
        if((Number(BALANCE) >= Number(chipValue)) && ((this.onGetOwnTotalBet() + Number(chipValue)) <= MAX_BET)){
            isChipValid = true;
        }else{
            if(Number(BALANCE) < Number(chipValue)){
                _lobbyErrorPopup.showErrorPopup(true,_localization.getText["popup_title_alert"],_localization.getText["not_enough_balance"]);
            }else if((this.onGetOwnTotalBet() + Number(chipValue)) > MAX_BET){
                _lobbyErrorPopup.showErrorPopup(true,_localization.getText["popup_title_alert"],_localization.getText['max_bet_limit']);
            }
        }
        return isChipValid;
    }
    /**
     * Check chip for OPPONENT bet
     * Validate current selected chip value is less or equal to balance otherwise throw error
     * @param {type} chipValue
     * @returns {undefined}
     */
    this.isValidBetChipForOpponent = function(chipValue,betVariantType){
        var isChipValid = false;
        if(betVariantType == 1){
            if(BALANCE >= Number(chipValue)){
                if(Number(OPPONENT_BET_BALANCE-(this.onGetOpponentBaharBet())) >= Number(chipValue)){
                    isChipValid = true;
                }else{
                    if(Number(OPPONENT_BET_BALANCE-(this.onGetOpponentBaharBet())) > 0){
                        isChipValid = true;
                        this.onSelectedChipChangeToAvailableBet(Number(OPPONENT_BET_BALANCE-(this.onGetOpponentBaharBet())));
                        //_seat.onShowCurrentPlayerAlertMsg("please select low chips",2000);
                    }else{
                        _seat.onShowCurrentPlayerAlertMsg(_localization.getText['opp_bet_notavail'],2000);
                    }
                }
            }else{
                isChipValid = false;
                _lobbyErrorPopup.showErrorPopup(true,_localization.getText["popup_title_alert"],_localization.getText["not_enough_balance"]);
            }
        }else{
            if(BALANCE >= Number(chipValue)){
                if(Number(OPPONENT_BET_BALANCE-(this.onGetOpponentAndarBet())) >= Number(chipValue)){
                    isChipValid = true;
                }else{
                    if(Number(OPPONENT_BET_BALANCE-(this.onGetOpponentAndarBet())) > 0){
                        isChipValid = true;
                        this.onSelectedChipChangeToAvailableBet(Number(OPPONENT_BET_BALANCE-(this.onGetOpponentAndarBet())));
                        //_seat.onShowCurrentPlayerAlertMsg("please select low chips",2000);
                    }else{
                        _seat.onShowCurrentPlayerAlertMsg(_localization.getText['opp_bet_notavail'],2000);
                    }
                }
            }else{
                isChipValid = false;
                _lobbyErrorPopup.showErrorPopup(true,_localization.getText["popup_title_alert"],_localization.getText["not_enough_balance"]);
            }
        }
        return isChipValid;
    }
    /**
     * on Calculate andar bet for OWN BET
     * @returns {undefined}
     */
    this.isValidOwnAndarBet = function(){
        isOwnAndarBetValid = false;
        if(this.isValidBetChipForOwn(CURRENT_SELECTED_CHIP)){
            TOTAL_OWN_ANDAR_BET += CURRENT_SELECTED_CHIP;
            TOTAL_ANDAR_BET += CURRENT_SELECTED_CHIP;
            TOTAL_BET += CURRENT_SELECTED_CHIP;
            TOTAL_OWN_BET += CURRENT_SELECTED_CHIP;
            this.onUpdatePlayerBetObj(1,2,CURRENT_SELECTED_CHIP);
            isOwnAndarBetValid = true;
            _gameFooter.onEnaleConfirmBtn(true);
            this.onRemoveBalance(CURRENT_SELECTED_CHIP);
        }else{
            //alert("Invalid own Andar bet amount");
        }
        return isOwnAndarBetValid;
    }
    /**
     * on Calculate bahar bet for OWN BET
     * @returns {undefined}
     */
    this.isValidOwnBaharBet = function(){
        isOwnBaharBetValid = false;
        if(this.isValidBetChipForOwn(CURRENT_SELECTED_CHIP)){
            TOTAL_OWN_BAHAR_BET += CURRENT_SELECTED_CHIP;
            TOTAL_OWN_BET += CURRENT_SELECTED_CHIP;
            TOTAL_BAHAR_BET += CURRENT_SELECTED_CHIP;
            TOTAL_BET += CURRENT_SELECTED_CHIP;
            this.onUpdatePlayerBetObj(1,1,CURRENT_SELECTED_CHIP);
            isOwnBaharBetValid = true;
            _gameFooter.onEnaleConfirmBtn(true);
            this.onRemoveBalance(CURRENT_SELECTED_CHIP);
        }else{
            //alert("Invalid own Bahar bet amount");
        }
        return isOwnBaharBetValid;
    }
    /**
     * on Calculate andar bet for OPPONENT BET
     * @returns {undefined}
     */
    this.isValidOpponentAndarBet = function(isCalculateBet){
        isOpponentAndarBetValid = false;
        if(this.isValidBetChipForOpponent(CURRENT_SELECTED_CHIP,2)){
            if(isCalculateBet){
                TOTAL_BAHAR_BET += CURRENT_SELECTED_CHIP;//here TOTAL_BAHAR_BET set for opponenet bet 
                TOTAL_BET += CURRENT_SELECTED_CHIP;
                this.onUpdatePlayerBetObj(2,2,CURRENT_SELECTED_CHIP);
                _gameFooter.onEnaleConfirmBtn(true);
                this.onRemoveBalance(CURRENT_SELECTED_CHIP);
            }
            isOpponentAndarBetValid = true;
            
        }else{
            //alert("Invalid opponent Andar bet amount");
        }
        return isOpponentAndarBetValid;
    }
    /**
     * on Calculate bahar bet for OPPONENT BET
     * @returns {undefined}
     */
    this.isValidOpponentBaharBet = function(isCalculateBet){
        isOpponentBaharBetValid = false;
        if(this.isValidBetChipForOpponent(CURRENT_SELECTED_CHIP,1)){
            if(isCalculateBet){
                TOTAL_ANDAR_BET += CURRENT_SELECTED_CHIP;//here TOTAL_ANDAR_BET set for opponenet bet
                TOTAL_BET += CURRENT_SELECTED_CHIP;
                this.onUpdatePlayerBetObj(2,1,CURRENT_SELECTED_CHIP);
                _gameFooter.onEnaleConfirmBtn(true);
                this.onRemoveBalance(CURRENT_SELECTED_CHIP);
            }
            isOpponentBaharBetValid = true;
        }else{
            //alert("Invalid opponent Bahar bet amount");
        }
        return isOpponentBaharBetValid;
    }
    /**
     * Add current player balance 
     * @returns {undefined}
     */
    this.onAddBalance = function(amount){
        console.log("onAddBalance BALANCE "+BALANCE+" : amount : "+amount);
        BALANCE += amount;
        if(_seatManager){
            if(BALANCE === "" || BALANCE === undefined || isNaN(BALANCE) || BALANCE < 0){
                console.log("onRemoveBalance update error");
                _seatManager.onUpdateUserBalance(CURRENT_USER_SEAT_INDEX,0);
            }else{
                _seatManager.onUpdateUserBalance(CURRENT_USER_SEAT_INDEX,BALANCE);
            }
        }
    }
    /**
     * Remove current player balance 
     * @returns {undefined}
     */
    this.onRemoveBalance = function(amount){
        console.log("onRemoveBalance BALANCE "+BALANCE+" : amount : "+amount);
        BALANCE -= amount;
        if(_seatManager){
            if(BALANCE === "" || BALANCE === undefined || isNaN(BALANCE) || BALANCE < 0){
                console.log("onRemoveBalance update error");
                _seatManager.onUpdateUserBalance(CURRENT_USER_SEAT_INDEX,0);
            }else{
                _seatManager.onUpdateUserBalance(CURRENT_USER_SEAT_INDEX,BALANCE);
            }
        }
    }
    /**
     * Update player bet object for bet request both OWN and OPPONENT bets
     * @param {type} betType 1 or OWN and 2 for OPPONENT
     * @param {type} betVariant 1 or Bahar and 2 for Andar
     * @param {type} amount
     * @returns {undefined}
     */
    this.onUpdatePlayerBetObj = function(betType,betVariant,amount){
        if(betType == 1){
            if(betVariant == 1){
                BET_REQUEST_OBJ["baharBet"] += amount;
            }else{
                BET_REQUEST_OBJ["andarBet"] += amount;
            }
        }else{
            if(betVariant == 1){
                BET_REQUEST_OBJ["opponentBet"][CURRENT_SELECTED_SEAT_ID]["baharBet"] += amount;    
            }else{
                BET_REQUEST_OBJ["opponentBet"][CURRENT_SELECTED_SEAT_ID]["andarBet"] += amount;
            }
        }
    }
    /**
     * get own total bet to validate furtther bet
     * @param {type} seatId
     * @returns {unresolved}
     */
    this.onGetOwnTotalBet = function(){
        return Number(BET_REQUEST_OBJ["andarBet"])+Number(BET_REQUEST_OBJ["baharBet"]);
    }
    /**
     * get opponent Andar total bet to validate further bet
     * @param {type} seatId
     * @returns {unresolved}
     */
    this.onGetOpponentAndarBet = function(){
        return Number(BET_REQUEST_OBJ["opponentBet"][CURRENT_SELECTED_SEAT_ID]["andarBet"]);
    }
    /**
     * get opponent Bahar total bet to validate further bet
     * @param {type} seatId
     * @returns {unresolved}
     */
    this.onGetOpponentBaharBet = function(){
        return Number(BET_REQUEST_OBJ["opponentBet"][CURRENT_SELECTED_SEAT_ID]["baharBet"]);
    }
    /**
     * get opponent total bet to validate furtther bet
     * @param {type} seatId
     * @returns {unresolved}
     */
    this.onGetOpponentTotalBet = function(){
        return Number(BET_REQUEST_OBJ["opponentBet"][CURRENT_SELECTED_SEAT_ID]["andarBet"])+Number(BET_REQUEST_OBJ["opponentBet"][CURRENT_SELECTED_SEAT_ID]["baharBet"]);
    }
    /**
     * Create bet object for every new round
     * @returns {undefined}
     */
    this.onCreateBetRequestObj = function(){
        BET_REQUEST_OBJ = null;
        BET_REQUEST_OBJ = {"andarBet":0,"baharBet":0};
        BET_REQUEST_OBJ["action"] = "BetRequest";
        BET_REQUEST_OBJ["tableId"] = TABLE_ID;
        
        BET_REQUEST_OBJ["opponentBet"] = {};
        BET_REQUEST_OBJ["opponentBet"][0] = {"andarBet":0,"baharBet":0,"oppUserSessionId":""};
        BET_REQUEST_OBJ["opponentBet"][1] = {"andarBet":0,"baharBet":0,"oppUserSessionId":""};
        BET_REQUEST_OBJ["opponentBet"][3] = {"andarBet":0,"baharBet":0,"oppUserSessionId":""};
        BET_REQUEST_OBJ["opponentBet"][4] = {"andarBet":0,"baharBet":0,"oppUserSessionId":""};
    }
    /**
     * Clear local bets and update user balance
     * @returns {undefined}
     */
    this.onClearBetAndUpdateBalance = function(isRemoveAllBet){
        var totalOwnAndarBetAmount = 0;
        var totalOwnBaharBetAmount = 0;
        var totalOpponentAndarBetAmount = 0;
        var totalOpponentBaharBetAmount = 0;
        
        totalOwnAndarBetAmount += Number(BET_REQUEST_OBJ.andarBet);
        totalOwnBaharBetAmount += Number(BET_REQUEST_OBJ.baharBet);
        
        TOTAL_OWN_ANDAR_BET -= totalOwnAndarBetAmount;
        TOTAL_OWN_BAHAR_BET -= totalOwnBaharBetAmount;
        TOTAL_OWN_BET -= (totalOwnAndarBetAmount+totalOwnBaharBetAmount);//to reduce own bet amount from total own bet
        
        BET_REQUEST_OBJ.andarBet = 0;
        BET_REQUEST_OBJ.baharBet = 0;
        
        if(isRemoveAllBet == true){
            var i=0;
            var keyName = 0;
            for(i = 0; i<BET_REQUEST_OBJ_KEY_ARR.length; i++){
                keyName = BET_REQUEST_OBJ_KEY_ARR[i];
                totalOpponentAndarBetAmount += BET_REQUEST_OBJ["opponentBet"][keyName]['andarBet'];
                totalOpponentBaharBetAmount += BET_REQUEST_OBJ["opponentBet"][keyName]['baharBet'];

                BET_REQUEST_OBJ["opponentBet"][keyName]['andarBet'] = 0;
                BET_REQUEST_OBJ["opponentBet"][keyName]['baharBet'] = 0;
            }
        }
        this.onAddBalance((totalOwnAndarBetAmount+totalOwnBaharBetAmount+totalOpponentAndarBetAmount+totalOpponentBaharBetAmount));
        
        TOTAL_ANDAR_BET -= totalOpponentBaharBetAmount;//here reduce opposite bet value to reset opponent bet
        TOTAL_BAHAR_BET -= totalOpponentAndarBetAmount;//here reduce opposite bet value to reset opponent bet
        TOTAL_BET -= (totalOpponentAndarBetAmount+totalOpponentBaharBetAmount);
        
        TOTAL_ANDAR_BET -= totalOwnAndarBetAmount;
        TOTAL_BAHAR_BET -= totalOwnBaharBetAmount;
        TOTAL_BET -= (totalOwnAndarBetAmount+totalOwnBaharBetAmount);
        
        this.onUpdateUserBetOnSeat();
    }
}
/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
function OpponentBetHandling(){
    'use strict';
    
    /**
     * Handle the user own bet and opponent bets by selecting user avatar,andar or bahar bet area on seat
     * @returns {undefined}
     */
    this.onSelectUserBetOption = function(betVariantType){
        console.log("**** onSelectUserBetOption : seatId : ",CURRENT_BET_OPTION_USER_SEATID," betVariantType : ",betVariantType," betType : ",BET_TYPE);
        
        //---highlight the selected bet area Andar or Bahar---
        var i=0;
        for(i=0;i<TOTAL_SEAT;i++){
            _seatManager.onShowHideBetHighlight(i,-1);
        }
        _seatManager.onShowHideBetHighlight(CURRENT_BET_OPTION_USER_SEATID,betVariantType);
    }
}


/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
function SeatManager(){
    'use strict';    
    
    var glowPlayers = [];
    /**
     * Rearrange the seat order based on current user seatIndex
     * @returns {undefined}
     */
    this.onSetupPlayerSeat = function(){
        var i  = 0;   
        var localSeatOrder = [];
        for(i=0;i<ORIGINAL_SEAT_ORDER.length;i++){
            console.log("server seat index : "+ORIGINAL_SEAT_ORDER[i]+" => local seat index : "+i);
            localSeatOrder.push(ORIGINAL_SEAT_ORDER[(ORIGINAL_SEAT_ORDER.length-1)-i]);
            SHUFFLED_SEAT_ORDER[ORIGINAL_SEAT_ORDER[i]] = i;
            SEAT_INDEX[i] = ORIGINAL_SEAT_ORDER[i];
        }        
        console.log("local seat order done Right to Left : ",localSeatOrder);
        console.log("============================================");        
    };
    /**
     * Swap seat index to set CURRENT PLAYER IN CENTER POSITION
     * this function will be recursive function until current player seat index come to center
     * @returns {undefined}
     */
    this.onPrepareSeatOrder = function(){        
        ORIGINAL_SEAT_ORDER.push(ORIGINAL_SEAT_ORDER.shift());        
        if(ORIGINAL_SEAT_ORDER[2] == CURRENT_USER_SEAT_INDEX){
            console.log("============================================");
            console.log("CURRENT_USER_SEAT_INDEX : ",CURRENT_USER_SEAT_INDEX);            
            this.onSetupPlayerSeat();
        }else{
            this.onPrepareSeatOrder();
        }
    };
    /**
     * Initialize all the seats for available players in buyin response
     * @param {type} buyInResObj
     * @returns {undefined}
     */
    this.onSeatInitialize = function(buyInResObj){        
        if(!buyInResObj.userLists) return;
        
        var i=0;
        var userListsLen = buyInResObj.userLists.length;
        if(buyInResObj.ksSeatIndex !== undefined){
           this.onShowHideKickStarterIcon(buyInResObj.ksSeatIndex); 
        }
        for(i=0;i<userListsLen;i++){
            this.onShowPlayerSeat(buyInResObj.userLists[i]['seatIndex'],buyInResObj.userLists[i]);            
        }        
    };
    /**
     * Initally show all seats as empty or
     * Hide particular seat by its id
     * @param {type} seatId
     * @param {type} allSeat
     * @returns {undefined}
     */
    this.onShowEmptySeat = function(seatId,allSeat){
        if(allSeat){
            var i=0;
            for(i=0;i<TOTAL_SEAT;i++){
                _seat.showEmptySeat(SHUFFLED_SEAT_ORDER[i]);
            }
        }else{
           _seat.showEmptySeat(SHUFFLED_SEAT_ORDER[seatId]); 
        }
    };
    /**
     * Show particular seat by its id
     * @param {type} seatId     
     * @returns {undefined}
     */
    this.onShowPlayerSeat = function(seatId,playerObj){
        _seat.showPlayerSeat(SHUFFLED_SEAT_ORDER[seatId],playerObj);
        _featureBet.onCreateLocalPlayerObject(playerObj);
    };
    /**
     * Update own and opponent user balance based on user seat id
     * @param {type} seatId
     * @returns {undefined}
     */
    this.onUpdateUserBalance = function(seatId,balance){
        if(seatId === CURRENT_USER_SEAT_INDEX){
            BALANCE = Number(balance);
        }
        _seat.setUserBalance(SHUFFLED_SEAT_ORDER[seatId],balance);
    };
    /**
     * Update own and opponent user name based on user seat id
     * @param {type} seatId
     * @returns {undefined}
     */
    this.onUpdateUserName = function(seatId,userName){
        _seat.setUserName(SHUFFLED_SEAT_ORDER[seatId],userName);
    };
    /**
     * Update user Andarbet
     * @param {type} seatId
     * @param {type} bet
     * @returns {undefined}
     */
    this.onUpdateAndarBaharBet = function(seatId,betAmount,betVariantType){
        if(betVariantType == 1){
            _seat.setBaharBet(SHUFFLED_SEAT_ORDER[seatId],betAmount);
        }else if(betVariantType == 2){
            _seat.setAndarBet(SHUFFLED_SEAT_ORDER[seatId],betAmount);
        }
    }
    /**
     * Update user Andar and Bahar Availablebet
     * @param {type} seatId
     * @param {type} bet
     * @returns {undefined}
     */
    this.onUpdateAndarBaharAvailableBet = function(seatId,betBalance,betVariantType){
        if(betVariantType == 1){
             _seat.setBaharAvailableBet(SHUFFLED_SEAT_ORDER[seatId],betBalance,betVariantType);
         }else if(betVariantType == 2){
             _seat.setAndarAvailableBet(SHUFFLED_SEAT_ORDER[seatId],betBalance,betVariantType);
         }else if(betVariantType == 3){
             //--Hide both andar and bahar avaialble bet values
             _seat.setBaharAvailableBet(SHUFFLED_SEAT_ORDER[seatId],betBalance,1);
             _seat.setAndarAvailableBet(SHUFFLED_SEAT_ORDER[seatId],betBalance,2);
         }
    }
    /**
     * Update bet values when server response came this will update on player turn running
     * betType 1 for ownBet update
     * betType 2 for opponentBet update
     * betVariantType 1 for baharBet update
     * betVariantType 2 for andarBet update
     * @param {type} obj
     * @returns {undefined}
     */
    this.onUpdateBetValuesFromSeverOld = function(obj){
        if(obj.responseType == "player"){
            if(obj.betType==1){
                if(obj.abetAmount){
                    this.onUpdateAndarBaharBet(obj.seatIndex,obj.abetAmount,2);
                }
                if(obj.bbetAmount){
                    this.onUpdateAndarBaharBet(obj.seatIndex,obj.bbetAmount,1);
                }
            }else{
                /**
                 * update bet and balance details of WHO made opponent bet on ME
                 */
                if(obj.abetAmount){
                    this.onUpdateAndarBaharBet(obj.seatIndex,obj.abetAmount,2);
                }
                if(obj.bbetAmount){
                    this.onUpdateAndarBaharBet(obj.seatIndex,obj.bbetAmount,1);
                }
                //---update betbalance values----
                if(obj.details.abetBalance != undefined){
                    this.onUpdateAndarBaharAvailableBet(obj.details.seatIndex,obj.details.abetBalance,2);
                }
                if(obj.details.bbetBalance != undefined){
                    this.onUpdateAndarBaharAvailableBet(obj.details.seatIndex,obj.details.bbetBalance,1);
                }
            }
        }else{
            if(obj.betType==1){
                /**
                 * update bet and balance details of opponent OWN bet
                 */
                if(obj.abetAmount){
                    this.onUpdateAndarBaharBet(obj.seatIndex,obj.abetAmount,2);
                }
                if(obj.bbetAmount){
                    this.onUpdateAndarBaharBet(obj.seatIndex,obj.bbetAmount,1);
                }
                //---update betbalance values----
                if(obj.abetBalance != undefined){
                    this.onUpdateAndarBaharAvailableBet(obj.seatIndex,obj.abetBalance,2);
                }
                if(obj.bbetBalance != undefined){
                    this.onUpdateAndarBaharAvailableBet(obj.seatIndex,obj.bbetBalance,1);
                }
            }else{
                /**
                 * update user bet and balance details whom made opponent bet on others
                 * if betBalance key CONTAIN this opponent bet made by OPPONENT PLAYER
                 * if betBalance key DOES NOT CONTAIN this opponent bet made by MYSELF
                 */
                if(obj.abetAmount){
                    this.onUpdateAndarBaharBet(obj.seatIndex,obj.abetAmount,2);
                }
                if(obj.bbetAmount){
                    this.onUpdateAndarBaharBet(obj.seatIndex,obj.bbetAmount,1);
                }
                //---update betbalance values----
                if(obj.abetBalance != undefined){
                    this.onUpdateAndarBaharAvailableBet(obj.seatIndex,obj.abetBalance,2);
                }
                if(obj.bbetBalance != undefined){
                    this.onUpdateAndarBaharAvailableBet(obj.seatIndex,obj.bbetBalance,1);
                }
                
                /**
                 * update user bet and balance details whom beted by some one
                 */
                if(obj.details.abetAmount){
                    this.onUpdateAndarBaharBet(obj.details.seatIndex,obj.details.abetAmount,2);
                }
                if(obj.details.bbetAmount){
                    this.onUpdateAndarBaharBet(obj.details.seatIndex,obj.details.bbetAmount,1);
                }
                //---update betbalance values----
                if(obj.details.abetBalance != undefined){
                    this.onUpdateAndarBaharAvailableBet(obj.details.seatIndex,obj.details.abetBalance,2);
                }
                if(obj.details.bbetBalance != undefined){
                    this.onUpdateAndarBaharAvailableBet(obj.details.seatIndex,obj.details.bbetBalance,1);
                }
            }
        }
        if(obj.tempBalance != undefined)
            this.onUpdateUserBalance(obj.seatIndex,obj.tempBalance);
        
        if(obj.details){
            if(obj.details.tempBalance != undefined){
                this.onUpdateUserBalance(obj.details.seatIndex,obj.details.tempBalance);
            }
        }
    };
    /**
     * Update bet values when server response came this will update on player turn running
     * betType 1 for ownBet update
     * betType 2 for opponentBet update
     * betVariantType 1 for baharBet update
     * betVariantType 2 for andarBet update
     * @param {type} obj
     * @returns {undefined}
     */
    this.onUpdateBetValuesFromSever = function(obj){
        var i = 0;
        
        if(obj.bbetAmount != undefined)
            this.onUpdateAndarBaharBet(obj.seatIndex,obj.bbetAmount,1);
        
        if(obj.abetAmount != undefined)
            this.onUpdateAndarBaharBet(obj.seatIndex,obj.abetAmount,2);
        
        this.onUpdateUserBalance(obj.seatIndex,obj.tempBalance);
        
        if(obj.responseType == "opponent"){
            if(obj.bbetBalance != undefined)
                this.onUpdateAndarBaharAvailableBet(obj.seatIndex,obj.bbetBalance,1);
            
            if(obj.abetBalance != undefined)
                this.onUpdateAndarBaharAvailableBet(obj.seatIndex,obj.abetBalance,2);
        }           
        if(obj.oppBet != undefined){
            if(obj.oppBet.length > 0){
                for(i=0; i<obj.oppBet.length; i++){
                    if(obj.oppBet[i].bbetAmount != undefined)
                        this.onUpdateAndarBaharBet(obj.oppBet[i].seatIndex,obj.oppBet[i].bbetAmount,1);
                    
                    if(obj.oppBet[i].abetAmount != undefined)
                        this.onUpdateAndarBaharBet(obj.oppBet[i].seatIndex,obj.oppBet[i].abetAmount,2);
                    
                    if(obj.oppBet[i].bbetBalance != undefined)
                        this.onUpdateAndarBaharAvailableBet(obj.oppBet[i].seatIndex,obj.oppBet[i].bbetBalance,1);
                    
                    if(obj.oppBet[i].abetBalance != undefined)
                        this.onUpdateAndarBaharAvailableBet(obj.oppBet[i].seatIndex,obj.oppBet[i].abetBalance,2);
                }
            }
        }
        
        //---check error for only player response---
        if(obj.responseType == "player"){
            var errorMsg = null;
            if(obj.ownBetError != undefined){
                errorMsg = obj.ownBetError.message;
            }
            if(obj.oppBetError != undefined){
                if(errorMsg != null)
                    errorMsg += "<br>"+obj.oppBetError.message;
                else
                    errorMsg = obj.oppBetError.message;
            }
            if(errorMsg != null){
                _lobbyErrorPopup.showErrorPopup(true,"Error",errorMsg);
            }
        }
    };
    /**
     * Update bet values locally while Advanced option enabled
     * @param {type} seatId
     * @param {type} betAmount
     * @param {type} betVariantType
     * @param {type} betType
     * @param {type} betBalance
     * @returns {undefined}
     */
    this.onUpdateBetValuesFromLocal = function(seatId,betAmount,betVariantType,betType,betBalance){
        //for own bet update
        this.onUpdateAndarBaharBet(seatId,betAmount,betVariantType);
        //for opponent available bet update
        this.onUpdateAndarBaharAvailableBet(seatId,betBalance,betVariantType);
    };
    /**
     * Show or Hide the kickstarter icon based on player 
     * @returns {undefined}
     */
    this.onShowHideKickStarterIcon = function(seatId){
        _seat.showHideKickStarterIcon(SHUFFLED_SEAT_ORDER[seatId]);
    };
    /**
     * Show or Hide the TimerHighlight based on player 
     * @returns {undefined}
     */
    this.onShowHideTimerHighlight = function(seatId,isHideAll){
        _seat.showHideTimerHighlight(SHUFFLED_SEAT_ORDER[seatId],isHideAll);
    };
    /**
     * Show or Hide the futrue bet icon based on player 
     * @returns {undefined}
     */
    this.onShowHideFutureBetIcon = function(seatId,show,isHideAll){
        _seat.showHideFutureBetIcon(SHUFFLED_SEAT_ORDER[seatId],show,isHideAll);
    };
    /**
     * Show or Hide bet highlight bg based on bet selection 
     * @returns {undefined}
     */
    this.onShowHideBetHighlight = function(seatId,betVariantType){
        _seat.showHideBetHighlight(SHUFFLED_SEAT_ORDER[seatId],betVariantType);
    };
    /*
     * show/hide timer
     * @param {number} seatId
     * @param {boolean} isHide
     * @returns {undefined}
     */
    this.onShowHideTimer = function(seatId,isHide){
        _seat.showHideTimer(SHUFFLED_SEAT_ORDER[seatId],isHide);
    }
    /*
     * It enables disconnection text on player
     * @param {boolean} flag
     * @param {number} seatId
     * @returns {undefined}
     */
    this.onShowDisconnection = function(seatId,flag,txt,distimer){
        _seat.showDisconnection(SHUFFLED_SEAT_ORDER[seatId],flag,txt,distimer);
        if(distimer !== undefined){
            _seatManager.onShowHideTimerHighlight(seatId);
        }
    };
    /**
     * Seat Glow show or hide
     * @param {type} seatId
     * @param {type} isHideAll
     * @returns {undefined}
     */
    this.onShowHideSeatGlow = function(seatId,isHideAll){
        _seat.showHideSeatGlow(SHUFFLED_SEAT_ORDER[seatId],isHideAll);
    }
    /**
     * Get user sessionid
     * @param {type} seatId
     * @returns {unresolved}
     */
    this.onGetUserSessionId = function(seatId){
        return _seat.getSessionId(SHUFFLED_SEAT_ORDER[seatId]);
    };
    /**
     * get user name
     * @param {type} seatId
     * @returns {jQuery}
     */
    this.onGetUserName = function(seatId){
        return _seat.getUserName(SHUFFLED_SEAT_ORDER[seatId]); 
    };
    /**
     * get user andar bet
     * @param {type} seatId
     * @returns {undefined}
     */
    this.onGetAndarBet = function(seatId){
        return _seat.getAndarBet(SHUFFLED_SEAT_ORDER[seatId]);
    }
    /**
     * get user bahar bet
     * @param {type} seatId
     * @returns {undefined}
     */
    this.onGetBaharBet = function(seatId){
        return _seat.getBaharBet(SHUFFLED_SEAT_ORDER[seatId]);
    }
    /**
     * get user andar betBalance
     * @param {type} seatId
     * @returns {undefined}
     */
    this.onGetAndarBetBalance = function(seatId){
        return _seat.getAndarBetBalance(SHUFFLED_SEAT_ORDER[seatId]);
    }
    /**
     * get user bahar betBalance
     * @param {type} seatId
     * @returns {undefined}
     */
    this.onGetBaharBetBalance = function(seatId){
        return _seat.getBaharBetBalance(SHUFFLED_SEAT_ORDER[seatId]);
    }
    /**
     * Update player turn timer second
     * @param {type} seatId
     * @param {type} time
     * @returns {undefined}
     */
    this.onUpdateTimer = function(seatId,time){        
        _seat.updateTimer(SHUFFLED_SEAT_ORDER[seatId],time);
    };
    
    /**
     * Stop player turn timer second
     * @param {type} seatId
     * @returns {undefined}
     */
    this.onStopTimer = function(seatId){        
        _seat.stopTimer(SHUFFLED_SEAT_ORDER[seatId]);
    };
    /**
     * Change andar or bahar bet are bg like silver,green,andar or bahar color image
     * @param {type} seatId
     * @param {type} bgType
     * @param {type} betType
     * @returns {undefined}
     */
    this.OnChangeAndarOrBaharBetBg = function(seatId,betType,betVariantType){
        _seat.changeAndarOrBaharBetBg(SHUFFLED_SEAT_ORDER[seatId],betType,betVariantType);
    };
    /**
     * Reset all text values like username,balance,bet values for particular seat
     * @param {type} seatId
     * @returns {undefined}
     */
    this.resetAllTextValues = function(seatId,allSeat){        
        if(allSeat){
            var i=0;
            for(i=0;i<TOTAL_SEAT;i++){
                _seat.resetAllTextValues(SHUFFLED_SEAT_ORDER[i]);                
            }
        }else{
           _seat.resetAllTextValues(SHUFFLED_SEAT_ORDER[seatId]);
        }
    };
    /**
     * Reset Andar and Bahar text values before winning update
     * @param {type} seatId
     * @returns {undefined}
     */
    this.resetAndarBaharBet = function(seatId,allSeat){
        if(allSeat){
            var i=0;
            for(i=0;i<TOTAL_SEAT;i++){
                this.OnChangeAndarOrBaharBetBg(SHUFFLED_SEAT_ORDER[i],"default",1);
                this.OnChangeAndarOrBaharBetBg(SHUFFLED_SEAT_ORDER[i],"default",2);
                this.onUpdateAndarBaharBet(SHUFFLED_SEAT_ORDER[i],0,1);
                this.onUpdateAndarBaharBet(SHUFFLED_SEAT_ORDER[i],0,2);                
            }
        }else{
            this.OnChangeAndarOrBaharBetBg(SHUFFLED_SEAT_ORDER[i],"default",1);
            this.OnChangeAndarOrBaharBetBg(SHUFFLED_SEAT_ORDER[i],"default",2);
            this.onUpdateAndarBaharBet(SHUFFLED_SEAT_ORDER[i],0,1);
            this.onUpdateAndarBaharBet(SHUFFLED_SEAT_ORDER[i],0,2);
        }
    }
    /**
     * Chat message display on play
     * @param {type} seatId,msg
     * @returns {undefined}
     */
    this.onUpdateChatMsg = function(seatId,msg){        
        _seat.showChatMsg(SHUFFLED_SEAT_ORDER[seatId],msg);
    };
    /*
     * A/B chip animation on win
     * @param {number} seatId
     * @returns {undefined}
     */
    this.onUpdateWinChip = function(seatId,cardtype){
        _seat.showChipAnim(SHUFFLED_SEAT_ORDER[seatId],cardtype);
    };
    /**
     * Hide the Timerhighlight,seatGlow and betAreaHighlight when user turn skip or end
     * @returns {undefined}
     */
    this.onHideTimerSeatGlowBetHighlight = function(seatId){
        this.onShowHideTimerHighlight(seatId,true);
        this.onShowHideSeatGlow(-1,true);
        this.onHideAllSeatBetHighlight();
    }
    /**
     * Hide all seats bet highlight
     * @returns {undefined}
     */
    this.onHideAllSeatBetHighlight = function(){
        var i=0;
        for(i=0;i<TOTAL_SEAT;i++){
            _seatManager.onShowHideBetHighlight(i,-1);
        }
    }
    /**
     * Remove all the click events to seats to restrict any click during game play
     * @returns {undefined}
     */
    this.onRemoveSeatClickEvents = function(){
        _seat.removeSeatClickEvents();
    };    
    /*
     * remove chip anim on refresh action
     * @returns {undefined}
     */
    this.removeChipAnim = function(){
        for(var i=0;i<TOTAL_SEAT;i++){
            if($('.seatbaharchip-'+i).hasClass('jumpanim')){
                $('.seatbaharchip-'+i).removeClass('jumpanim');
            }
            if($('.seatandharchip-'+i).hasClass('jumpanim')){
                $('.seatandharchip-'+i).removeClass('jumpanim');
            }
        }
    };
    /*
     * Updating boot amount and other things after house card anim.
     * @param {object} obj
     * @returns {undefined}
     */
    this.onUpdateStartRoundResponse = function(){
        var i=0;
        for(i=0;i<START_ROUND_RESPONSE_OBJ.userLists.length;i++){
            if(Number(START_ROUND_RESPONSE_OBJ.userLists[i].seatIndex) == Number(CURRENT_USER_SEAT_INDEX)){
                MIN_BET = START_ROUND_RESPONSE_OBJ.userLists[i].minBet;
                MAX_BET = START_ROUND_RESPONSE_OBJ.userLists[i].maxBet;
            }
            _seatManager.onUpdateUserBalance(START_ROUND_RESPONSE_OBJ.userLists[i].seatIndex,START_ROUND_RESPONSE_OBJ.userLists[i].tempBalance);
            if(START_ROUND_RESPONSE_OBJ.userLists[i].seatIndex != START_ROUND_RESPONSE_OBJ.ksSeatIndex){
                _seatAnimation.chipAnim(SHUFFLED_SEAT_ORDER[START_ROUND_RESPONSE_OBJ.userLists[i].seatIndex],START_ROUND_RESPONSE_OBJ.tableAnte,'dealer',1000);
            }
        }
    };
    /*
     * it used to display glow on players who is having balance to bet 
     * by other players.
     * @param {array} obj
     * @returns {undefined}
     */
    this.onUpdatePlayerGlow = function(obj){        
        if(glowPlayers.length > 0){
          for(var i=0;i<glowPlayers.length;i++){
              _seat.onShowAvailableBetGlow(false,SHUFFLED_SEAT_ORDER[glowPlayers[i]]);
          }   
        }
        if(obj !== undefined){
            for(var j=0;j<obj.length;j++){
              _seat.onShowAvailableBetGlow(true,SHUFFLED_SEAT_ORDER[obj[j]]);
            }
            glowPlayers = obj;
        }
    };
    /**
     * dispose all things when this class remove from parent     
     * @returns {undefined}
     */
    this.dispose = function(){
        this.onShowEmptySeat(-1,true);
    };
    if(CURRENT_USER_SEAT_INDEX > 4 || CURRENT_USER_SEAT_INDEX < 0){
        return;
    }
    this.onPrepareSeatOrder();
    this.onShowEmptySeat(-1,true);        
}
/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
function Seat(){
    'use strict';
     var timeoutObj = {};
     var disconnectTimer = {};
     /*
     * HERE SEATS ARE ALIGNED FROM RIGHT TO LEFT
     * name : init
     * desc : intiates seat functionalities
    */   
    this.init = function () {        
        for(var i=0; i<TOTAL_SEAT; i++)
        {
            $("#seatContainerId").append( '   <div id="seatid-'+i+'" class="seat-'+i+'">  '  + 
 '       <div id="seatChatCallout-'+i+'" class="seat-chat-callout callouts--bottom">  '  + 
 '           <span id="chatText-'+i+'">HELLO</span>  '  + 
 '       </div>  ' + 
 '       <div id="seatUsernameBgid-'+i+'" class="seatusernamebg-'+i+'"></div>  '  +
 '       <div id="seatAndarBetHolderid-'+i+'" class="seatandharbetholder-'+i+'">  '  + 
    '       <div id="seatAndarBetAreaid-'+i+'" class="seatandharbetarea-'+i+'">  '  +
    '           <div id="seatAndarBetbalanceAreaid-'+i+'" class="seatandarbetavailablearea-'+i+' ">  '  + 
    '               <div id="seatAndharbetBalanceBgid-'+i+'" class="seatandharbetavailablebg-'+i+' seat_andar_balance_bg"></div>  '  + 
    '               <div id="seatAndharbetBalanceTxtid-'+i+'" class=" seatandharbetavailabletxt-'+i+'"></div>  '  + 
    '           </div>  '  + 
    '           <div id="seatAndharbetHighlightid-'+i+'" class="seatandharbethighlight-'+i+' seat_bet_value_glow_base"></div>  '  + 
    '           <div id="seatAndharbetBaseid-'+i+'" class="seatandharbetbase-'+i+' seat_bet_value_default"></div>  '  + 
    '           <div id="seatAndharbetBgid-'+i+'" class="seatandharbetbg-'+i+' seat_bet_value_default_base"></div>  '  + 
    '           <div id="seatAndharbetTxtid-'+i+'" class="seatandharbettxt-'+i+'"></div>  '  + 
    '           <div id="seatAndharChipid-'+i+'" class="seatandharchip-'+i+'"></div>  '  + 
    '       </div>  '  + 
 '       </div>  '  + 
 '       <div id="seatBaharBetHolderid-'+i+'" class="seatbaharbetholder-'+i+'">  '  + 
    '       <div id="seatBaharBetAreaid-'+i+'" class="seatbaharbetarea-'+i+'">  '  + 
    '           <div id="seatBaharBetAvailableAreaid-'+i+'" class="seatbaharbetavailablearea-'+i+'">  '  + 
    '               <div id="seatBaharBetAvailableBgid-'+i+'" class="seatbaharbetavailablebg-'+i+' seat_bahar_balance_bg"></div>  '  + 
    '               <div id="seatBaharBetAvailableTxtid-'+i+'" class="seatbaharbetavailabletxt-'+i+'"></div>  '  + 
    '            </div>          '  + 
    '           <div id="seatBaharbetHighlightid-'+i+'" class="seatbaharbethighlight-'+i+' seat_bet_value_glow_base"></div>  '  + 
    '           <div id="seatBaharbetBaseid-'+i+'" class="seatbadharbetbase-'+i+' seat_bet_value_default"></div>  '  + 
    '           <div id="seatBaharbetBgid-'+i+'" class="seatbaharbetbg-'+i+' seat_bet_value_default_base"></div>  '  + 
    '           <div id="seatBaharbetTxtid-'+i+'" class="seatbaharbettxt-'+i+'"></div>  '  + 
    '           <div id="seatBaharchipid-'+i+'" class="seatbaharchip-'+i+'"></div>  '  + 
    '       </div>  '  + 
 '       </div>  '  +
 '       <div id="seatGlowHighlightid-'+i+'" class="seatglowhighlight-'+i+' seat-glow"></div>'  +
 '       <div id="seatTimerHighlightid-'+i+'" class="seattimerhighlight-'+i+' seat-avataring-glow"></div>  '  + 
 '       <div id="seatAvatarringid-'+i+'" class="seatavatarring-'+i+' seat_base"></div>  '  + 
 '       <div id="seatTimerTopid-'+i+'" class="seattimertop-'+i+' seat_avatar_base"></div>  '  + 
 '       <div id="seatAvatarImgid-'+i+'" class="seatavatarimg-'+i+' seat_avatar_base"></div>  '  +
 '       <div class="playeravatarholder-'+i+'">  '  + 
 '          <img id="gameplayeravatar-'+i+'" class="avatarimage-'+i+' guest_avatar"></img>  '  + 
 '          <div class="avatarouterring-'+i+' avatar_outerring"></div>  '  + 
 '       </div>  '  +
 '       <div id="seatTimerid-'+i+'" class="seattimer-'+i+'">30</div>  '  +
 '       <div id="seatDisconnectid-'+i+'" class="seatDisconnect-'+i+'">  '  + 
 '          <div id="seatDctimerid-'+i+'" class="seatDctimer-'+i+'">20</div>  '  +
 '          <div id="seatDctxt-'+i+'" class="seatDctxt-'+i+'">Disconnected</div>  '  +
 '       </div>  '  + 
 '       <div id="seatTopShineid-'+i+'" class="seattopshine-'+i+' seat_top_shine"></div>  '  +  
 '       <div id="seatUsernameid-'+i+'" class=" seatusername-'+i+'"></div>  '  +  
 '       <div id="seatGiftImgid-'+i+'" class="seatgiftimg-'+i+' gift"></div>  '  + 
 '       <div id="seatKickstarterImgid-'+i+'" class="seatkickstarterimg-'+i+' kickstarter"></div>  '  + 
 '       <div id="seatFeatureBetImgid-'+i+'" class="seatfeaturebetimg-'+i+' future_bet"></div>  '  + 
 '       <div id="seatplayerStakeImgid-'+i+'" class="seatplayerstakeimg-'+i+' player_stake"></div>  '  + 
 '       <div id="seatAvatarClickEventImgid-'+i+'" class="seatavatarring-'+i+' seat_base"></div>  '  + 
 '  </div>  ');
        }
        
        /**
         * for 0 and 1 value for seat-0 and seat-1
         * for 3 and 4 value for seat-3 and seat-4
         * for 2 only current player mean center seat i.e seat-2
         * set username bg and bet chips
         */
        for(var i=0; i<TOTAL_SEAT; i++){
            if(i==0 || i==1){
                $('.seatusernamebg-'+i).addClass('seat_username_bg');
                $('.seatandharchip-'+i).addClass('right_a');
                $('.seatbaharchip-'+i).addClass('right_b');
            }else if(i==2){
                $('.seatusernamebg-'+i).addClass('seat_player_name_base');
                $('.seatandharchip-'+i).addClass('left_a');
                $('.seatbaharchip-'+i).addClass('right_b');
                $('.seat-'+i).append('<div id="userbalanceid-'+i+'" class=" userbalance-'+i+'"></div>'  + 
'<div id="ownPlayermessage" class="own-player-message">'+
'<div id="ownMsgTxt" class="own-msg-txt">Please select your bet</div>  '  + 
'</div>');
            }else{
                $('.seatusernamebg-'+i).addClass('seat_username_bg');
                $('.seatandharchip-'+i).addClass('left_a');
                $('.seatbaharchip-'+i).addClass('left_b');
            }
        }
    };
    /**
     * show empty seat
     * @param {type} seatId
     * @returns {undefined}
     */
    this.showEmptySeat = function(seatId){
        $('#seatAndarBetAreaid-'+seatId).off("click");
        $('#seatBaharBetAreaid-'+seatId).off("click");
        $('#seatAvatarClickEventImgid-'+seatId).off("click");
        $('#seatGiftImgid-'+seatId).off("click");
        
        this.resetAllTextValues(seatId);
        
        $('.seatandharbetarea-'+seatId).hide();
        $('.seatandarbetavailablearea-'+seatId).hide();
        $('.seatandharbethighlight-'+seatId).hide();
        $('.seatandharbetbase-'+seatId).hide();
        $('.seatandharbetbg-'+seatId).hide();
        $('.seatandharbettxt-'+seatId).hide();
        $('.seatandharchip-'+seatId).hide();
        
        $('.seatbaharbetarea-'+seatId).hide();
        $('.seatbaharbetavailablearea-'+seatId).hide();
        $('.seatbaharbethighlight-'+seatId).hide();
        $('.seatbadharbetbase-'+seatId).hide();
        $('.seatbaharbetbg-'+seatId).hide();
        $('.seatbaharbettxt-'+seatId).hide();
        $('.seatbaharchip-'+seatId).hide();
        
        $('.seattimerhighlight-'+seatId).hide();
        $('.seatglowhighlight-'+seatId).hide();
        $('.seattimer-'+seatId).hide();
        $('.seatDisconnect-'+seatId).hide();
        $('.playeravatarholder-'+seatId).hide();
        $('.seatavatarimg-'+seatId).hide();
        $('.seatusernamebg-'+seatId).hide();
        $('.seatusername-'+seatId).hide();        
        $('.seatgiftimg-'+seatId).hide();
        $('.seatkickstarterimg-'+seatId).hide();
        $('.seatfeaturebetimg-'+seatId).hide();
        $('.seatplayerstakeimg-'+seatId).hide();
        
        if(Number(seatId) === 2){
            $('.seatandharbetavailablebg-'+seatId).hide();
            $('.seatandharbetavailabletxt-'+seatId).hide();
            $('.seatbaharbetavailablebg-'+seatId).hide();
            $('.seatbaharbetavailabletxt-'+seatId).hide();
            $('.userbalance-'+seatId).hide();
        }
    };
    /**
     * show player seat
     * @param {type} seatId
     * @returns {undefined}
     */
    this.showPlayerSeat = function(seatId,playerObj){ 
        this.onUpdatePlayerAvatar(seatId,playerObj['avatarUrl']);
        this.setUserName(seatId,playerObj['userName']);
        this.setUserBalance(seatId,playerObj['tempBalance']);
        this.setSessionId(seatId,playerObj['sessionId']);        
        
        $('.seatandharbetarea-'+seatId).show();
        $('.seatbaharbetarea-'+seatId).show();
        
        $('.seatusernamebg-'+seatId).show();
        $('.seatusernamebg-'+seatId).show();
        $('.seatusername-'+seatId).show();     
        if(Number(seatId) === 2){
             $('.userbalance-'+seatId).show();
        }       
        
        //$('.seatgiftimg-'+seatId).show();
        //$('.seatplayerstakeimg-'+seatId).show();
        $('.playeravatarholder-'+seatId).show();
        $('.seatandharbetbase-'+seatId).show();
        $('.seatandharbetbg-'+seatId).show();
        $('.seatandharbettxt-'+seatId).show();
        $('.seatandharchip-'+seatId).show();
        
        $('.seatbadharbetbase-'+seatId).show();
        $('.seatbaharbetbg-'+seatId).show();
        $('.seatbaharbettxt-'+seatId).show();
        $('.seatbaharchip-'+seatId).show();
        
        $('#seatAndarBetAreaid-'+seatId).click(this.onSeatAndarBaharBetClicked);
        $('#seatBaharBetAreaid-'+seatId).click(this.onSeatAndarBaharBetClicked);
        $('#seatAvatarClickEventImgid-'+seatId).click(this.onSeatAvatarClicked);
        
        $('#seatGiftImgid-'+seatId).click(this.onGiftClicked);
        
        this.changeAndarOrBaharBetBg(seatId,"default",1);
        this.changeAndarOrBaharBetBg(seatId,"default",2);
        
        /*this.showHideKickStarterIcon(seatId);
        this.showHideFutureBetIcon(seatId);
        this.setAndarAvailableBet(seatId,2,110);
        this.setBaharAvailableBet(seatId,3,10);
        this.showHideBetHighlight(seatId,1);
        this.showHideBetHighlight(seatId,0);
        this.changeAndarOrBaharBetBg(seatId,'andar',2);
        this.changeAndarOrBaharBetBg(seatId,'available',1);*/
    };
    /**
     * Update player avatar to guest or facebook
     * @returns {undefined}
     */
    this.onUpdatePlayerAvatar = function(seatId,avatarUrl){
        if(avatarUrl !== "guest" && avatarUrl !== undefined){
            var avatarTag = document.getElementById("gameplayeravatar-"+seatId);
            avatarUrl = avatarUrl.replace("type=","");
            avatarTag.src = avatarUrl+"width=185&height=185";    
        }
    }
    /**
     * set user name
     * @returns {undefined}
     */
    this.setUserName = function(seatId,userName){
        $('.seatusername-'+seatId).text(String(userName).substring(0, 11));       
    };
    /**
     * get user name
     * @param {type} seatId
     * @returns {jQuery} 
     */
    this.getUserName = function(seatId){
        return $('.seatusername-'+seatId).text();       
    };
    /**
     * update user balance
     * @param {type} seatId
     * @returns {undefined}
     */
    this.setUserBalance = function(seatId,balance){
        //$('.userbalance-'+seatId).text(balance);
        if(seatId === 2){
            animateResultCount(true,$('.userbalance-'+seatId).text(),balance,('.userbalance-'+seatId));
        }
    };
    /**
     * store opponent players sessiond
     * it will used to send seesionid to server on opponents bet request
     * @param {type} seatId
     * @param {type} sessionId
     * @returns {undefined}
     */
    this.setSessionId = function(seatId,sessionId){
        OPPONENTS_SESSION_ID_LIST[seatId] = sessionId;
    };
    /**
     * to get the opponent user session id
     * @param {type} seatId
     * @returns {unresolved}
     */
    this.getSessionId = function(seatId){
        return OPPONENTS_SESSION_ID_LIST[seatId];
    };
    /**
     * update andhar bet
     * @param {type} seatId
     * @returns {undefined}
     */
    this.setAndarBet = function(seatId,bet){
        this.changeAndarOrBaharBetBg(seatId,BET_TYPE_ANDAR,bet);
        //$('.seatandharbettxt-'+seatId).text(bet);
        animateResultCount(true,$('.seatandharbettxt-'+seatId).text(),bet,('.seatandharbettxt-'+seatId));
    };
    /**
     * get user andar bet
     * @param {type} seatId
     * @returns {undefined}
     */
    this.getAndarBet = function(seatId){
        return $('.seatandharbettxt-'+seatId).text();
    }
    /**
     * update bahar bet
     * @param {type} seatId
     * @returns {undefined}
     */
    this.setBaharBet = function(seatId,bet){
        this.changeAndarOrBaharBetBg(seatId,BET_TYPE_BAHAR,bet);
        //$('.seatbaharbettxt-'+seatId).text(bet);
        animateResultCount(true,$('.seatbaharbettxt-'+seatId).text(),bet,('.seatbaharbettxt-'+seatId));
    };
    /**
     * get user bahar bet
     * @param {type} seatId
     * @returns {undefined}
     */
    this.getBaharBet = function(seatId){
        return $('.seatbaharbettxt-'+seatId).text();
    }
    /**
    * get user andar bet balance
    */
    this.getAndarBetBalance = function(seatId){
        return $('.seatandharbetavailabletxt-'+seatId).text().split(':')[1];
    }
    /**
    * get user bahar bet balance
    */
    this.getBaharBetBalance = function(seatId){
        return $('.seatbaharbetavailabletxt-'+seatId).text().split(':')[1];
    }
    /**
     * Update opponent available bet in Andar
     * @param {type} seatId
     * @param {type} bet
     * @returns {undefined}
     */
    this.setAndarAvailableBet = function(seatId,bet,betVariant){ 
        $('.seatandharbetavailabletxt-'+seatId).text("BAL : "+bet);
        if(Number(bet)<=0){
            this.enableDisableAvailableBetArea(seatId,betVariant,false);
        }else{
            this.enableDisableAvailableBetArea(seatId,betVariant,true);
        }
    };
    /**
     * Update opponent available bet in Bahar
     * @param {type} seatId
     * @param {type} bet
     * @returns {undefined}
     */
    this.setBaharAvailableBet = function(seatId,bet,betVariant){
        $('.seatbaharbetavailabletxt-'+seatId).text("BAL : "+bet);
        if(Number(bet)<=0){
            this.enableDisableAvailableBetArea(seatId,betVariant,false);
        }
        else{
            this.enableDisableAvailableBetArea(seatId,betVariant,true);  
        }
    };
    /**
     * Enale or Disable the avilable bet strip on opponents bets
     * @param {type} seatId
     * @param {type} bln
     * @returns {undefined}
     */
    this.enableDisableAvailableBetArea = function(seatId,betVariant,bln){
        if(Number(betVariant) == 2){
            if(bln){
                if(!$('.seatandarbetavailablearea-'+seatId).is(":visible")){
                    $('.seatandarbetavailablearea-'+seatId).show();
                }   
            }else{
                $('.seatandarbetavailablearea-'+seatId).hide();
            }
        }else{
            if(bln){
                if(!$('.seatbaharbetavailablearea-'+seatId).is(":visible")){
                    $('.seatbaharbetavailablearea-'+seatId).show();
                }      
            }else{
                $('.seatbaharbetavailablearea-'+seatId).hide();
            }
        }
    };
    /**
     * Show or Hide the kickstarter icon based on player 
     * @returns {undefined}
     */
    this.showHideKickStarterIcon = function(seatId){
        var i=0
        for(i=0;i<TOTAL_SEAT;i++){
            $('.seatkickstarterimg-'+i).hide();
        }
        $('.seatkickstarterimg-'+seatId).show();
    };
    /**
     * Show or Hide the timerhighlight icon based on player 
     * @returns {undefined}
     */
    this.showHideTimerHighlight = function(seatId,isHideAll){
        var i=0
        for(i=0;i<TOTAL_SEAT;i++){
            $('.seattimerhighlight-'+i).hide();
            $('.seattimerhighlight-'+i).removeClass('rotate');
        }
        
        if(isHideAll) return;
        
        $('.seattimerhighlight-'+seatId).addClass('rotate');
        $('.seattimerhighlight-'+seatId).show();
    };
    /**
     * Seat Glow show and hide based on user choose opponenet bet
     * @param {type} seatId
     * @param {type} isHideAll
     * @returns {undefined}
     */
    this.showHideSeatGlow = function(seatId,isHideAll){
        var i=0
        for(i=0;i<TOTAL_SEAT;i++){
            $('.seatglowhighlight-'+i).hide();
        }
        
        if(isHideAll) return;
        
        $('.seatglowhighlight-'+seatId).show();
    }
    /**
     * Show or Hide the featuere bet icon based on player 
     * @returns {undefined}
     */
    this.showHideFutureBetIcon = function(seatId,show,isHideAll){
        if(isHideAll){
            var i=0
            for(i=0;i<TOTAL_SEAT;i++){
                $('.seatfeaturebetimg-'+i).hide();
            }
        }else{
            if(show){
                $('.seatfeaturebetimg-'+seatId).show();
            }else{
                $('.seatfeaturebetimg-'+seatId).hide();
            }
        }
    };
    /**
     * Show or Hide bet highlight bg based on bet selection 
     * @returns {undefined}
     */
    this.showHideBetHighlight = function(seatId,betVariantType){        
        if(betVariantType !== 1 && betVariantType !== 2){
            if(seatId === 2){
                $('.seatandharbethighlight-'+seatId).removeClass("blink_me");
                $(".seatbaharbethighlight-"+seatId).removeClass("blink_me");
            }
            $('.seatandharbethighlight-'+seatId).hide();
            $('.seatbaharbethighlight-'+seatId).hide();
            return;
        }
        
        if(Number(betVariantType) === 1){
            if(seatId === 2){
                _seat.onBlinkHighlight('bahar');
            }else{
                $('.seatandharbethighlight-'+seatId).hide();
                $('.seatbaharbethighlight-'+seatId).show();
            }
        }else{
            if(seatId === 2){
                _seat.onBlinkHighlight('andar');
            }else{
                $('.seatbaharbethighlight-'+seatId).hide();
                $('.seatandharbethighlight-'+seatId).show();
            }
        }
    };
    /**
     * Change andar or bahar bet are bg like silver,green,andar or bahar color image
     * @param {type} seatId
     * @param {type} betType - may be default,available(green),andar or bahar
     * @returns {undefined}
     */
    this.changeAndarOrBaharBetBg = function(seatId,betVariantType,betAmout){
        if(Number(betAmout) > 0){
            if(betVariantType == BET_TYPE_ANDAR){
                $('.seatandharbetbg-'+seatId).removeClass(document.getElementById('seatAndharbetBgid-'+seatId).classList[document.getElementById('seatAndharbetBgid-'+seatId).classList.length-1]);
                $('.seatandharbetbg-'+seatId).addClass('seat_bet_value_'+BET_TYPE_ANDAR+'_base');
            }else if(betVariantType == BET_TYPE_BAHAR){
                $('.seatbaharbetbg-'+seatId).removeClass(document.getElementById('seatBaharbetBgid-'+seatId).classList[document.getElementById('seatBaharbetBgid-'+seatId).classList.length-1]);
                $('.seatbaharbetbg-'+seatId).addClass('seat_bet_value_'+BET_TYPE_BAHAR+'_base');
            }
        }else{
            if(betVariantType == BET_TYPE_ANDAR){
                $('.seatandharbetbg-'+seatId).removeClass(document.getElementById('seatAndharbetBgid-'+seatId).classList[document.getElementById('seatAndharbetBgid-'+seatId).classList.length-1]);
                $('.seatandharbetbg-'+seatId).addClass('seat_bet_value_default_base');
            }else if(betVariantType == BET_TYPE_BAHAR){
                $('.seatbaharbetbg-'+seatId).removeClass(document.getElementById('seatBaharbetBgid-'+seatId).classList[document.getElementById('seatBaharbetBgid-'+seatId).classList.length-1]);
                $('.seatbaharbetbg-'+seatId).addClass('seat_bet_value_default_base');
            }
        }
    };
    /**
     * Update player turn timer second
     * @param {type} seatId
     * @param {type} time
     * @returns {undefined}
     */
    this.updateTimer = function(seatId,time){   
        if(time > -1){
            $('.seattimer-'+seatId).show();
            if((USER_WARNING_TIME > time) && (USER_FREEZE_TIME <= time)){
                $('.seattimer-'+seatId).css({
                   'color':'#ff7500' 
                });
            }else if((USER_WARNING_TIME > time) && (USER_FREEZE_TIME >= time)){
                $('.seattimer-'+seatId).css({
                   'color':'#ff0000' 
                });
            }else{
                $('.seattimer-'+seatId).css({
                   'color': '#00fd00'
                });
            }
            $('.seattimer-'+seatId).text(time);
            if(time === 0){
                setTimeout(function(){
                    $('.seattimer-'+seatId).hide();
                    clearTimeout();
                    clearInterval(USER_TIMER);
                    IS_USER_TIMER_RUNNING = false;
                },1000);
            }
        }
    };    
    /*
     * show/hide seat timer
     * @param {number} seatId
     * @param {boolean} isHide
     * @returns {undefined}
     */
    this.showHideTimer = function(seatId,isHide){
        if(isHide){
          $('.seattimer-'+seatId).hide();
          $('.seattimerhighlight-'+seatId).removeClass('rotate');
          $('.seattimerhighlight-'+seatId).hide();
        }else{
          $('.seattimer-'+seatId).show(); 
        }
    };
    /*
     * It displays disconnected players.
     * @param {boolean} flag
     * @returns {undefined}
     */
    this.showDisconnection = function(seatId,flag,txt,timer){
        if(flag){
          $('.seatDisconnect-'+seatId).show();
          if(timer !== undefined){
            DISTIMER_COUNT = timer;  
            $('.seatDctimer-'+seatId).show();  
            $('.seatDctimer-'+seatId).text(DISTIMER_COUNT);
            if((DISTIMER_COUNT > 0) && (txt !== _localization.getText['disconnected'])){
                $('.seatDctxt-'+seatId).text(txt);
                $('.seatDctxt-'+seatId).show();
            }
            if(disconnectTimer["distimer_"+seatId] !== undefined){
               clearInterval(disconnectTimer["distimer_"+seatId]); 
            }
            IS_MY_TURN = true;
            disconnectTimer["distimer_"+seatId] = setInterval(function(){
               DISTIMER_COUNT = DISTIMER_COUNT - 1;
               if(DISTIMER_COUNT >= 0){
                   $('.seatDctimer-'+seatId).text(DISTIMER_COUNT);
                   if((DISTIMER_COUNT <= 1)  && ($('.seatDctxt-'+seatId).text() === _localization.getText['extra_timer'])){
                        _gameFooter.onResetValuesToNextTimer(seatId);
                        _gameFooter.onSendAutoBetRequest();
                    }
               }else{
                   $('.seatDctimer-'+seatId).hide(); 
                   if($(".seatDctxt-"+seatId).is(':hidden') || ($(".seatDctxt-"+seatId).text() === _localization.getText['extra_timer'])){
                       $('.seatDisconnect-'+seatId).hide();
                   }
                   clearInterval(disconnectTimer["distimer_"+seatId]);
               }
            },1000); 
            DISCONNECT_TIMER = disconnectTimer["distimer_"+seatId];
          }else{
              $('.seatDctxt-'+seatId).text(txt);
              $('.seatDctxt-'+seatId).show();
          }
        }else{
          if(disconnectTimer["distimer_"+seatId] !== undefined){
              if($('.seatDctimer-'+seatId).is(':hidden')){
                $('.seatDctxt-'+seatId).hide();
                $('.seatDisconnect-'+seatId).hide();
              }else{
                  $('.seatDctxt-'+seatId).text(txt);
              }
          }else{
              $('.seatDctxt-'+seatId).hide();
              $('.seatDisconnect-'+seatId).hide();
          }
        }
    };
    /**
     * stop player turn timer second
     * @param {type} seatId
     * @returns {undefined}
     */
    this.stopTimer = function(seatId){
       $('.seattimer-'+seatId).empty();
    };
    /**
     * Reset all textbox values like andhar,bahar balance and name etc.., when seat removed
     * @param {type} seatId
     * @returns {undefined}
     */
    this.resetAllTextValues = function(seatId){
        $('.seatusername-'+seatId).text("");
        /*if(seatId === 2){
            $('.userbalance-'+seatId).text("");
        }*/       
        $('.seatandharbettxt-'+seatId).text("0");
        $('.seatbaharbettxt-'+seatId).text("0");
        $('.seatandharbetavailabletxt-'+seatId).text("");
        $('.seatbaharbetavailabletxt-'+seatId).text("");
    };
    /**
     * Remove all seats click events before every game card throw start
     * @returns {undefined}
     */
    this.removeSeatClickEvents = function(){
        for(var i=0;i<TOTAL_SEAT;i++){
            $('#seatAndarBetAreaid-'+i).off("click");
            $('#seatBaharBetAreaid-'+i).off("click");
            $('#seatAvatarClickEventImgid-'+i).off("click");
            $('#seatGiftImgid-'+i).off("click");
        }
    }
    /**
     * Highlight andar or bahar bet area when user to the own or opponenet bet area
     * @param {type} evt
     * @returns {undefined}
     */
    this.onSeatAndarBaharBetClicked = function(evt){
        if(!IS_GAME_RUNING) return;
        
        if(IS_MY_TURN == false){
            _seat.onShowCurrentPlayerAlertMsg(_localization.getText['wait_your_turn'],2000);
            return;
        }
        _sound.play('buttonSound');
        var seatId = evt.currentTarget.id;
        //check seat 2 or other seat to check this is own or oppoent bet
        BET_TYPE = (Number(seatId.split("-")[1]) === 2?1:2);
        _seatManager.onHideAllSeatBetHighlight();
        
        /*if(IS_OPPONENT_PLAYER_SELECTED == false || (BET_TYPE == 2 && (CURRENT_BET_OPTION_USER_SEATID != SEAT_INDEX[seatId.split("-")[1]])))
            CURRENT_SELECTED_SEAT_ID = Number(seatId.split("-")[1]);*/
        
        if(BET_TYPE == 2){
            CURRENT_SELECTED_SEAT_ID = Number(seatId.split("-")[1]);
        }
        
        CURRENT_BET_OPTION_USER_SEATID = SEAT_INDEX[seatId.split("-")[1]];
        
        if(seatId.split("-")[0] === "seatAndarBetAreaid"){
            //---do ANDAR bet---
            if(BET_TYPE == 1){
                if(IS_OPPONENT_PLAYER_SELECTED == true){
                    if(SELECTED_OPPONENT_BET_VARIANTTYPE == 1){
                        if(_betHandling.isValidOpponentBaharBet(true)){
                            _opponentBetHandling.onSelectUserBetOption(2);
                            _seat.setAndarBet(SHUFFLED_SEAT_ORDER[CURRENT_BET_OPTION_USER_SEATID],TOTAL_ANDAR_BET);
                        }else{
                            console.log("Cant do opponent bet in Bahar");
                        }
                    }else{
                        _seat.onShowCurrentPlayerAlertMsg(_localization.getText['bet_on_bahar'],2000);
                        _seat.onBlinkHighlight('bahar');
                    }
                }else{
                    if(_betHandling.isValidOwnAndarBet()){
                        _opponentBetHandling.onSelectUserBetOption(2);
                        _seat.setAndarBet(SHUFFLED_SEAT_ORDER[CURRENT_BET_OPTION_USER_SEATID],TOTAL_ANDAR_BET);
                    }
                }
            }else{
                _betHandling.onSetOpponentBetBalance(Number(_seat.getAndarBetBalance(SHUFFLED_SEAT_ORDER[CURRENT_BET_OPTION_USER_SEATID])));
                
                if(_betHandling.isValidOpponentAndarBet(false)){
                    SELECTED_OPPONENT_BET_VARIANTTYPE = 2;
                    _opponentBetHandling.onSelectUserBetOption(2);
                    _seat.onShowCurrentPlayerAlertMsg(_localization.getText['bet_on_bahar'],2000);
                    _seat.onBlinkHighlight('bahar');
                }else{
                    //_seat.onShowCurrentPlayerAlertMsg("Opponent bet not available",2000);
                }
            }
        }else{
            //---do BAHAR bet---
            if(BET_TYPE == 1){
                if(IS_OPPONENT_PLAYER_SELECTED == true){
                    if(SELECTED_OPPONENT_BET_VARIANTTYPE == 2){
                        if(_betHandling.isValidOpponentAndarBet(true)){
                            _opponentBetHandling.onSelectUserBetOption(1);
                            _seat.setBaharBet(SHUFFLED_SEAT_ORDER[CURRENT_BET_OPTION_USER_SEATID],TOTAL_BAHAR_BET);
                        }else{
                            console.log("Cant do opponent bet in Andar");
                        }
                    }else{
                        _seat.onShowCurrentPlayerAlertMsg(_localization.getText['bet_on_andar'],2000);
                        _seat.onBlinkHighlight('andar');
                    }
                }else{
                    if(_betHandling.isValidOwnBaharBet()){
                        _opponentBetHandling.onSelectUserBetOption(1);
                        _seat.setBaharBet(SHUFFLED_SEAT_ORDER[CURRENT_BET_OPTION_USER_SEATID],TOTAL_BAHAR_BET);
                    }
                }
            }else{
                _betHandling.onSetOpponentBetBalance(Number(_seat.getBaharBetBalance(SHUFFLED_SEAT_ORDER[CURRENT_BET_OPTION_USER_SEATID])));
                
                if(_betHandling.isValidOpponentBaharBet(false)){
                    SELECTED_OPPONENT_BET_VARIANTTYPE = 1;
                    _opponentBetHandling.onSelectUserBetOption(1);
                    _seat.onShowCurrentPlayerAlertMsg(_localization.getText['bet_on_andar'],2000);
                    _seat.onBlinkHighlight('andar');
                }else{
                    //_seat.onShowCurrentPlayerAlertMsg("Opponent bet not available",2000);
                }
            }
        }
        
        if(BET_TYPE == 2){
            IS_OPPONENT_PLAYER_SELECTED = true;
            BET_REQUEST_OBJ["opponentBet"][CURRENT_SELECTED_SEAT_ID]["oppUserSessionId"] = _seat.getSessionId(SHUFFLED_SEAT_ORDER[CURRENT_BET_OPTION_USER_SEATID]);
        }
    }
    /**
     * Enable opponent or own bet selection when user select the user avatar
     * @param {type} evt
     * @returns {undefined}
     */
    this.onSeatAvatarClicked = function(evt){
        _seat.onHandleSeatAvatarClick(evt.currentTarget.id);
    }
    /**
     * Handle seat avatar click event
     * @param {type} selectedSeatId
     * @returns {undefined}
     */
    this.onHandleSeatAvatarClick = function(selectedSeatId){
        if(!IS_GAME_RUNING) return;
        
        if(IS_MY_TURN == false){
            _seat.onShowCurrentPlayerAlertMsg(_localization.getText['wait_your_turn'],2000);
            return;
        }
        _sound.play('buttonSound');
        var seatId = selectedSeatId;
        
        //check seat 2 or other seat to check this is own or oppoent bet
        BET_TYPE = (Number(seatId.split("-")[1]) === 2?1:2);
       _seatManager.onHideAllSeatBetHighlight();
        CURRENT_SELECTED_SEAT_ID = Number(seatId.split("-")[1]);
        CURRENT_BET_OPTION_USER_SEATID = SEAT_INDEX[seatId.split("-")[1]];
        
        if(BET_TYPE == 2){
            IS_OPPONENT_PLAYER_SELECTED = true;
            BET_REQUEST_OBJ["opponentBet"][CURRENT_SELECTED_SEAT_ID]["oppUserSessionId"] = _seat.getSessionId(SHUFFLED_SEAT_ORDER[CURRENT_BET_OPTION_USER_SEATID]);
            
            _betHandling.onSetOpponentBetBalance(Number(_seat.getBaharBetBalance(SHUFFLED_SEAT_ORDER[CURRENT_BET_OPTION_USER_SEATID])));
                
            if(_betHandling.isValidOpponentBaharBet(false)){
                SELECTED_OPPONENT_BET_VARIANTTYPE = 1;
                _opponentBetHandling.onSelectUserBetOption(1);
                _seat.onShowCurrentPlayerAlertMsg(_localization.getText['bet_on_andar'],2000);
                _seat.onBlinkHighlight('andar');
            }else{
                _betHandling.onSetOpponentBetBalance(Number(_seat.getAndarBetBalance(SHUFFLED_SEAT_ORDER[CURRENT_BET_OPTION_USER_SEATID])));
                
                if(_betHandling.isValidOpponentAndarBet(false)){
                    SELECTED_OPPONENT_BET_VARIANTTYPE = 2;
                    _opponentBetHandling.onSelectUserBetOption(2);
                    _seat.onShowCurrentPlayerAlertMsg(_localization.getText['bet_on_bahar'],2000);
                    _seat.onBlinkHighlight('bahar');
                }else{
                    //_seat.onShowCurrentPlayerAlertMsg("Opponent bet not available",2000);
                }
            }
        }else{
            IS_OPPONENT_PLAYER_SELECTED = false;
           _seat.onBlinkHighlight("both");
        }
    };
    /*
     * Bet highlight on opponent player click.
     * @param {string} str
     * @returns {undefined}
     */
    this.onBlinkHighlight = function(str){
        if(str === 'andar'){
            $(".seatbaharbethighlight-2").hide();
            if($(".seatbaharbethighlight-2").hasClass("blink_me")){
                $(".seatbaharbethighlight-2").removeClass("blink_me");
            }
            $(".seatandharbethighlight-2").show();
            if(!$(".seatandharbethighlight-2").hasClass("blink_me")){
                $(".seatandharbethighlight-2").addClass("blink_me");
            }            
        }else if(str === 'bahar'){
            $(".seatandharbethighlight-2").hide();
            if($(".seatandharbethighlight-2").hasClass("blink_me")){
                $(".seatandharbethighlight-2").removeClass("blink_me");
            }
            $(".seatbaharbethighlight-2").show();
            if(!$(".seatbaharbethighlight-2").hasClass("blink_me")){
                $(".seatbaharbethighlight-2").addClass("blink_me");
            }
        }else{
            $(".seatandharbethighlight-2").show();
            $(".seatbaharbethighlight-2").show();
            $(".seatandharbethighlight-2").addClass("blink_me");
            $(".seatbaharbethighlight-2").addClass("blink_me");
        }
    };
    /**
     * Show the gift popup when user select the gift icon on seat
     * @param {type} evt
     * @returns {undefined}
     */
    this.onGiftClicked = function(evt){
        _sound.play('buttonSound');
        var seatId = evt.currentTarget.id;
        console.log("onGiftClicked seatID : ",seatId.split("-")[1]);
    };
    /**
     * Show chat on player based on seat id.
     * @param {type} _seatId,_msg
     * @returns {undefined}
     */
    this.showChatMsg = function(_seatId,_msg){
        if(timeoutObj[_seatId+""] !== undefined){
            clearTimeout(timeoutObj[_seatId+""]);
            timeoutObj[_seatId+""] = null;
        }
        $('#seatChatCallout-'+_seatId).show();
        $('#chatText-'+_seatId).text(_msg);
        timeoutObj[_seatId+""] = setTimeout(
                    function(){
                        $('#seatChatCallout-'+_seatId).hide(); 
                    }, 3000);
    };
    /*
     * Andar/Bahar chip animation on win
     * @param {number} _seatId
     * @returns {undefined}
     */
    this.showChipAnim = function(_seatId,cardtype){
        if(cardtype === 1){
            $('.seatbaharchip-'+_seatId).addClass('jumpanim');
        }else{
            $('.seatandharchip-'+_seatId).addClass('jumpanim');
        }
    };
    /**
     * Show current player alert
     * @param {type} _msg
     * @param {type} _time
     * @returns {undefined}
     */
    this.onShowCurrentPlayerAlertMsg = function(_msg,_time,needToClearMsg){
        if(timeoutObj["userAlert"] !== undefined){
            clearTimeout(timeoutObj["userAlert"]);
            timeoutObj["userAlert"] = null;
        }
        document.getElementById("ownPlayermessage").style.display = "none";
        
        if(needToClearMsg) return;
        
        timeoutObj["userAlert"] = setTimeout(function(){
            $('.own-msg-txt').removeClass('flash');
            document.getElementById("ownPlayermessage").style.display = "none";
        },_time);
            
        $('.own-msg-txt').addClass('flash');
        document.getElementById("ownMsgTxt").innerHTML = _msg;
        document.getElementById("ownPlayermessage").style.display = "block";
    };
    /*
     * it used to display glow on players who is having balance to bet 
     * by other players.
     * @param {boolean,number} flag,seatId
     * @returns {undefined}
     */
    this.onShowAvailableBetGlow = function(flag,seatId){
      if(flag){
          $('.seatglowhighlight-'+seatId).show();
      }else{
          $('.seatglowhighlight-'+seatId).hide();
      }
    };
    /**
     * dispose all things when this class remove from parent     
     * @returns {undefined}
     */
    this.dispose = function(){
        
    };
    this.init();    
}
function TableSocketHandling(){
    'use strict';
    
    /*
     * name : onCreateConnection
     * desc : Creates inner lobby and table sockets here.
    */
    this.onCreateSocketConnection = function(){
        console.log("is use socket io in game ",IS_USE_SOCKETIO);
        SERVER_URL = "?cookie="+encodeURIComponent('authToken=' + USER_SESSION_ID + ";");
        _webSokcetIO.getNewConnection({namespace:TABLE_ID+SERVER_URL,
                                       name:TABLE_ID,
                                        connectCallBack:_tableScoketHandling.onTableSocketConnected,
                                        messageCallBack:_tableScoketHandling.onHandlingTableSocketAutoResponse,
                                        connectFailCallBack:_tableScoketHandling.onSocketConnectionFailed,
                                        disconnectCallBack:_tableScoketHandling.onSocketDisconnected,
                                        reconnectCallBack:_tableScoketHandling.onSocketReconnected});
    };
    /*
     * name : onTableFullSocCreation
     * desc : It disconnects old socket and creates new socket at 
     *        the time of table is full.
    */
    this.onTableFullSocCreation = function(oldsocket,newTableId){
        console.log("Creating new socket ",oldsocket);
        _webSocketIO.killConnection(oldsocket); 
        TABLE_ID = newTableId;
        _webSokcetIO.getNewConnection({namespace:TABLE_ID+SERVER_URL,
                                       name:TABLE_ID,
                                        connectCallBack:_tableScoketHandling.onNewTableSocCreation,
                                        messageCallBack:_tableScoketHandling.onHandlingTableSocketAutoResponse,
                                        connectFailCallBack:_tableScoketHandling.onSocketConnectionFailed,
                                        disconnectCallBack:_tableScoketHandling.onSocketDisconnected,
                                        reconnectCallBack:_tableScoketHandling.onSocketReconnected});
    };
     /**
     * Connection success call back on new table creation
     * @returns {undefined}
     */
    this.onNewTableSocCreation = function(){
        console.log("on New Table Socket Connected");
        if(BUYIN_RESPONSE_OBJ !== null){
             _gamePage.init(BUYIN_RESPONSE_OBJ);
        }
    };
    /**
     * Table socke connection created successfully
     * @returns {undefined}
     */
    this.onTableSocketConnected = function(){
        console.log("onTableSocketConnected");
        _tableScoketHandling.init();
    }
    /**
     * Login socket connection failed
     * @returns {undefined}
     */
    this.onSocketConnectionFailed = function(){
        console.log("table socekt connection failed");
    }
    /**
     * Login socketd reconnected
     * @returns {undefined}
     */
    this.onSocketReconnected = function(){
        console.log("table socekt reconnected");
        IS_GAME_RECONNECTED = true;
        _lobbyErrorPopup.showDisconnect(true,_lobbyLocalization.getText['txt_reconnected_title'],_lobbyLocalization.getText['txt_reconnected_message'],null,false,3000);
    }
    /**
     * Login socket disconnected
     * @returns {undefined}
     */
    this.onSocketDisconnected = function(){
        console.log("table socekt disconnected");
        if(FORCED_GAME_TO_DISCONNECT == false && IS_USER_INSIDE_GAME == true){
            IS_GAME_RECONNECTED = true;
            _lobbyErrorPopup.showDisconnect(true,_lobbyLocalization.getText['txt_disconnected_title'],_lobbyLocalization.getText['txt_reconnecting_message'],null,false);
        }
    }
    /*
    * name : init
    * desc : initiate game logic pages
    */
     this.init = function(){
        if(_gamePage == null){
            _gamePage = new GamePage();
        }
        if(_gameResponseHandling == null){
            _gameResponseHandling = new GameResponseHandling();
        }
        _tableScoketHandling.onSendBuyInRequest();
     };
     /*
     * name : onSendBuyInRequest
     * desc : Buyin request handling
    */
     this.onSendBuyInRequest = function(){
        var buyinRequest = {  
                                action: "BuyInRequest",
                                sessionId  : USER_SESSION_ID,
                                menuId : 100,
                                tableId : TABLE_ID,
                                buyInAmount : 10000,
                                autoBuyIn : false
                            };
        _tableScoketHandling.onSendTableSocketRequest(buyinRequest);
     };
     /*
     * name : onSendTableSocketRequest
     * desc : Inner lobby request to server.
    */
    this.onSendTableSocketRequest = function(reqObj){
        _webSokcetIO.getConnection(TABLE_ID).onSendRequest(reqObj,_tableScoketHandling.onHandlingTableSocketRequestResponse);
    };
    /**
     * Handling table socket request response
     * @param {type} errObj
     * @param {type} resObj
     * @returns {undefined}
     */
    this.onHandlingTableSocketRequestResponse = function(errObj,resObj){
        if(errObj){
            console.log("table socket REQUEST response has error : ",errObj);
            return;
        }
        resObj = JSON.parse(resObj);
        console.log("table socket REQUEST response Obj ",resObj);
        _gameResponseHandling.onSplitResponse(resObj);
    }
    /**
     * Handling table socket auto responses
     * @param {type} resObj
     * @returns {undefined}
     */
    this.onHandlingTableSocketAutoResponse = function(resObj){
        resObj = JSON.parse(resObj);
        console.log("table socket AUTO response Obj ",resObj);
        if(_gameResponseHandling !== null){
            _gameResponseHandling.onSplitResponse(resObj);
        }
    }
    /*
     * name : dispose
     * desc : dispose all variables in to null and "" here.
    */
     this.dispose = function(){
         FORCED_GAME_TO_DISCONNECT = true;
         _webSokcetIO.killConnection(TABLE_ID);
         _gameResponseHandling = null;
     };
}
function GameTopBar(){
    var histroyDetails;
    var gameInnerHeader ='<div class="game-inner-header" id="gameInnerHeader">  '  + 
 '       <div class="headerleftbar">  '  + 
 '           <div class="leftarrow back_btn" onclick="_gameTopBar.onLeaveTableClick();"></div>  '  + 
 '           <div id="chatBtn" class="chat-btn chat" onclick="_gameTopBar.onChatClick();"></div>  '  + 
 '       </div>  '  + 
 '       <div class="headerrightbar">  '  + 
 '           <div class="historydetails history_bg">  '  + 
 '               <span class="recentdetails ">Recent Wins </span>  '  + 
 '               <span class="history ">History</span>  '  + 
 '               <div class="winscategorydetails" id="winscategorydetailsId"></div>  '  + 
 '           </div>  '  + 
 '           <div id="gameSettingsBtn" class="settings-holder settings" onclick="_gameTopBar.onSettingsClick();"></div>  '  + 
 '       </div>   '  + 
 '  </div>  ' ;   
    var _histroyLength = 0;
    /*
     * name : init
     * desc : Game top bar initiates here.
    */
    this.init = function(_obj){
        document.getElementById("gameHeader").innerHTML = gameInnerHeader;
        if(_obj.gameHistory !== undefined){
           _gameTopBar.onHistroyHandler(_obj.gameHistory);
        }
    };
    /*
     * name : onHistroyHandler
     * desc : Adding histroy on histroy bar.
    */
    this.onHistroyHandler = function(_hisArray){
        histroyDetails = "";
        if(_hisArray.length > 8){
            _histroyLength = 8;
        }else{
            _histroyLength = _hisArray.length;
        }
        for(var i=0;i<_histroyLength;i++){
           histroyDetails = histroyDetails+'<div class="winscategory ">'+_hisArray[i]+'</div>';
        }
        document.getElementById("winscategorydetailsId").innerHTML = histroyDetails;
    };
    /*
     * name : onLeaveTableClick
     * desc : Leave table from game handling here.
    */
    this.onLeaveTableClick = function(){
       _sound.play('buttonSound');
      _lobbyErrorPopup.showOkCanPopup(true,function(_status){
          if(_status == 'yes'){              
                var obj = {
                    "action" : "LeaveGameRequest",
                    "sessionId" : USER_SESSION_ID,
                    "tableId" : TABLE_ID                    
                };
                IS_PLAYER_CLICKED_LEAVE_TABLE = true;
                _tableScoketHandling.onSendTableSocketRequest(obj);
                _lobbyErrorPopup.showOkCanPopup(false);
                _seatManager.onShowEmptySeat(null,true);
                onExitGame();
          }else{
              _lobbyErrorPopup.showOkCanPopup(false);
          }
      },
      'Warning',_localization.getText['leave_game']);
    };
    /*
     * name : onChatClick
     * desc : It pop out default message container.
    */
    this.onChatClick = function(){
        _sound.play('buttonSound');
        _gameCommonContainer.enableChatWindow();
    };
    /*
     * name : onSettingsClick
     * desc : It pop out setting options container.
    */
    this.onSettingsClick = function(){
        _sound.play('buttonSound');
        _lobbySetting.enableSettingsWindow();
    };
    /*
     * name : selectSettings
     * desc : change settings icon to selected/unselected mode.
    */
    this.selectChat = function(flag){
        if(flag){
            $('.chat-btn').removeClass('chat');
            $('.chat-btn').addClass('chat_highlight');
        }else{
            $('.chat-btn').removeClass('chat_highlight');
            $('.chat-btn').addClass('chat');
        }
    };
    /*
     * name : selectChat
     * desc : change chat icon to selected/unselected mode.
    */
    this.selectSettings = function(flag){
        if(flag){
            $('.settings-holder').removeClass('settings');
            $('.settings-holder').addClass('settings_highlight');
        }else{
            $('.settings-holder').removeClass('settings_highlight');
            $('.settings-holder').addClass('settings');
        }
    };
}
var _gameTopBar = null;
function GameFooter(){
    var footer =    '   <div id="betpanelparentid" class="betpanelparent">  '  + 
 '       <div class="betpanel-bg betpanelbg"></div>  '  + 
 '      <div id="betchiphighlightid" class="betchiphighlight bet_chip_highlight"></div>'+
 '       <div class="chipholder"></div>  '  + 
 '       <div class="skip-btn skip_btn" id="skipBtn" onclick="_gameFooter.onSkipHandler();">  '  + 
 '           <div class="skip-txt">SKIP</div>  '  + 
 '       </div>  '  + 
 '       <div class="betconfirm-btn confirm_btn" onclick="_gameFooter.onSendBetRequest();">  '  + 
 '           <div class="betconfirm-txt">CONFIRM</div>  '  + 
 '       </div>  '  + 
 '       <div class="betpanel-skip-btn-disabler"></div>  '  + 
 '       <div class="betpanel-confirm-btn-disabler"></div>  '  + 
 '  </div>  '+
 '   <div id="featureBetParentId" class="featurebetparent"></div>  '  + 
 '   <div class="bet-holder-disabler" id="betDisabler">  '  +
 '           <div class="betDisabler-txt">PLEASE WAIT FOR NEXT GAME TO JOIN</div>  '  +
 '  </div>  ' ;                   
 
    var chipHighlightPos = [282,452,622,792,962];
    /*
     * name : init
     * desc : Game footer initiates here.
    */
    this.init = function(){
        document.getElementById("gameFooter").innerHTML = footer;
        if(_featureBet === null){
           _featureBet = new FeatureBet();
        }
        _featureBet.init();
        var chipConfigArr = GAME_TABLE_DETAILS.chipArr;
        
        for(var i=0;i<chipConfigArr.length;i++){
            $('.chipholder').append('<div id="betchipid-'+i+'" class="betchip-'+i+' bet_chip_'+i+'" onclick="_gameFooter.onChipSelect('+i+');">'+
                                    '<div id="betchiptxtid-'+i+'" class="betchiptxt-'+i+'">'+currencyConvert(chipConfigArr[i])+'</div>'+
                                    '</div>');
        }
        CURRENT_BET_OPTION_USER_SEATID = CURRENT_USER_SEAT_INDEX;
        
        _betHandling.onResetOwnBetValues();
        _betHandling.onResetSelectedBetChip();
        _betHandling.onCreateBetRequestObj();
        
        MIN_BET = 1000;
        MAX_BET = 50000;
        //this.enableBetDisabler(true);
        this.onEnaleConfirmBtn(false);
        this.onEnaleSkipBtn(false);
    };
    /**
     * Bet chip selection handling
     * @param {type} chipId
     * @returns {undefined}
     */
    this.onChipSelect = function(chipId){
        console.log("Currrent selected chipd value "+GAME_TABLE_DETAILS.chipArr[chipId]);
        _sound.play('betChipClick');
        _betHandling.onUpdateSelectedBetChip(chipId);
    }
    /**
     * update bet chip highlight
     * @param {type} chipId
     * @returns {undefined}
     */
    this.onUpdateBetChipHighlight = function(chipId){
        document.getElementById('betchiphighlightid').style.left = chipHighlightPos[chipId]+"px";
    }
    /*
     * Update user name based on user selection
     * name : updateAndarBet
     * desc : It updates andar update on footer.
    */
    this.updateUserName = function(name){
        $(".playername-txt").text(name);
    };
    /**
     * Send auto bet request to server after timer end <=2 seconds
     * @returns {undefined}
     */
    this.onSendAutoBetRequest = function(){
        if(TOTAL_BET > 0){
            this.onSendBetRequest(true);
        }else{
            console.log("Bet not available");
        }
    }
    /*
     * name : onSendBetRequest
     * desc : This handles bet amount which user selected.
    */
    this.onSendBetRequest = function(isAutoBetRequest){
        _sound.play('buttonSound');
        _gameFooter.onEnaleConfirmBtn(false);
        
        if(BET_REQUEST_OBJ)
        {
            var isOpponentBetAvailable = false;
            var i=0;
            var keyName = 0;
            
            if(TOTAL_OWN_BET < MIN_BET)
            {
                if(!isAutoBetRequest) {
                    //----checking there is any opponent bet avilable or not----
                    for(i = 0; i<BET_REQUEST_OBJ_KEY_ARR.length; i++){
                        keyName = BET_REQUEST_OBJ_KEY_ARR[i];
                        if(BET_REQUEST_OBJ["opponentBet"][keyName]['andarBet'] > 0  || BET_REQUEST_OBJ["opponentBet"][keyName]['baharBet'] > 0){
                            isOpponentBetAvailable = true;
                        }
                    }
                    
                    //----generate opponent bet array from local BET_REQUEST_OBJ object----
                    if(isOpponentBetAvailable == true){
                        if(TOTAL_OWN_BET > 0){
                            //_seat.onShowCurrentPlayerAlertMsg(_localization.getText['own_bet_fail'],3000);
                            _lobbyErrorPopup.showErrorPopup(true,"Error",_localization.getText['own_bet_returned_tobalance'],null,4000,false);
                        }
                        
                        _betHandling.onClearBetAndUpdateBalance(false);//pass false to clear own bet only
                        _gameFooter.onGenerateOpponetBetArr();
                        
                        //----send bet request----
                        _tableScoketHandling.onSendTableSocketRequest(BET_REQUEST_OBJ);
                    }else{
                        _lobbyErrorPopup.showErrorPopup(true,"Error",_localization.getText['own_require_minbet']);
                    }
                }else{
                    if(TOTAL_OWN_BET > 0)
                        _seat.onShowCurrentPlayerAlertMsg(_localization.getText['own_bet_return'],1500);
                    
                    _gameFooter.onGenerateOpponetBetArr();

                    //----send bet request----
                    _tableScoketHandling.onSendTableSocketRequest(BET_REQUEST_OBJ);
                    
                    //clear bet
                    _betHandling.onClearBetAndUpdateBalance(false);
                }
            }else{
                _gameFooter.onGenerateOpponetBetArr();
                
                //----send bet request----
                _tableScoketHandling.onSendTableSocketRequest(BET_REQUEST_OBJ);
            }
        }else{
            if(!isAutoBetRequest){
                _lobbyErrorPopup.showErrorPopup(true,"Error",_localization.getText['invalid_bet']);
            }else{
                //clear bet
                _betHandling.onClearBetAndUpdateBalance(true);
            }
        }
    };
    /**
     * generate opponent bets array
     * @returns {undefined}
     */
    this.onGenerateOpponetBetArr = function(){
        var opponentBetArr = [];
        for(i = 0; i<BET_REQUEST_OBJ_KEY_ARR.length; i++){
            if(BET_REQUEST_OBJ["opponentBet"][BET_REQUEST_OBJ_KEY_ARR[i]]["andarBet"] > 0 || BET_REQUEST_OBJ["opponentBet"][BET_REQUEST_OBJ_KEY_ARR[i]]["baharBet"] > 0)
            {
                opponentBetArr.push({"andarBet":BET_REQUEST_OBJ["opponentBet"][BET_REQUEST_OBJ_KEY_ARR[i]]["andarBet"],
                                    "baharBet":BET_REQUEST_OBJ["opponentBet"][BET_REQUEST_OBJ_KEY_ARR[i]]["baharBet"],
                                    "oppUserSessionId":BET_REQUEST_OBJ["opponentBet"][BET_REQUEST_OBJ_KEY_ARR[i]]["oppUserSessionId"]});
            }
         }
        BET_REQUEST_OBJ["opponentBetArr"] = opponentBetArr;
    }
    /**
     * clear user timer
     * @returns {undefined}
     */
    this.onClearUserTimer = function(seatid){
        console.log("clear timer called");
        clearInterval(USER_TIMER);
        if(DISCONNECT_TIMER !== null){
           clearInterval(DISCONNECT_TIMER); 
           $('.seatDctxt-'+SHUFFLED_SEAT_ORDER[seatid]).hide();
           $('.seatDisconnect-'+SHUFFLED_SEAT_ORDER[seatid]).hide();
           $('.seatDctimer-'+SHUFFLED_SEAT_ORDER[seatid]).hide();  
        }
        IS_USER_TIMER_RUNNING = false;
    }
    /*
     * name : enableBetDisabler
     * desc : It will add disabler on bet holder.
    */
   this.enableBetDisabler = function(flag){
       if(!IS_PLAYER_WAIT_FOR_NEXT_ROUND){
        if(flag){
            $('#betDisabler').show();
        }else{
            $('#betDisabler').hide();
        }
       }
   };
    /*
     * name : onSkipHandler
     * desc : Skip and move next hand.
    */
    this.onSkipHandler = function(){
        _sound.play('buttonSound');
        _betHandling.onClearBetAndUpdateBalance(true);
        _gameFooter.onResetValuesToNextTimer(CURRENT_USER_SEAT_INDEX);
        console.log("onSkipHandler");
        var obj = {
            "action" : "SkipTurnRequest",
            "sessionId" : USER_SESSION_ID,
            "tableId" : TABLE_ID
        }
        _tableScoketHandling.onSendTableSocketRequest(obj);
    };
    /**
     * Reset current player local variable after his turn completed
     * @param {type} seatIndex
     * @returns {undefined}
     */
    this.onResetValuesToNextTimer = function(seatIndex){
        _seat.onShowCurrentPlayerAlertMsg("clear",0,true);
        IS_OPPONENT_PLAYER_SELECTED = false;
        IS_MY_TURN = false;
        OPPONENT_BET_USER_SESSIONID = null;
        _seatManager.onHideTimerSeatGlowBetHighlight(seatIndex);
        _gameFooter.onEnaleSkipBtn(false);
        _gameFooter.onEnaleConfirmBtn(false);
    }
    /**
     * Show or Hide footer to show feature bet option
     * @param {type} show
     * @returns {undefined}
     */
    this.onShowHideFooter = function(show,hideFeatureBet){
        if(!IS_PLAYER_WAIT_FOR_NEXT_ROUND){
            _gameFooter.onShowWaitingMsgHolder(false);
            if(show){
                if($('.betpanelparent').css("display") === "block" && $('.betpanelparent').css("top") === "0px"){
                    return;
                }else{
                    if(hideFeatureBet){
                        _featureBet.onShowHideFeatureBet(false);
                    }else{
                        $('.betpanelparent').css({'display':"block","top":'210px'});
                        $('.betpanelparent').animate({"top":'0px'},200,"linear",function(){_gameFooter.onCompleteFooterShowHideAnim(true);});
                    }
                }
            }else{
                if($('.betpanelparent').css("display") === "none" && $('.betpanelparent').css("top") === "210px"){
                    return;
                }else{
                    $('.betpanelparent').css({'display':"block","top":'0px'});
                    $('.betpanelparent').animate({"top":'210px'},150,"linear",function(){_gameFooter.onCompleteFooterShowHideAnim(false);});
                }
            }
        }
    };
    /*
     * Waiting for next round message on game play.
     * @param {boolean} show
     * @returns {undefined}
     */
    this.onShowWaitingMsgHolder = function(show){
        if(show){
            $('.betpanelparent').hide();
            $('.featurebetparent').hide();
            $('.bet-holder-disabler').show();
            $('.bet-holder-disabler').animate({"top":'3px'},500,"linear");
        }else{
            $('.bet-holder-disabler').hide();
            $('.bet-holder-disabler').animate({"top":'230px'},200,"linear");
        }
    };
    /**
     * Show or Hide Feature bet container after Footer contianer hide or show complete
     * @param {type} show
     * @returns {undefined}
     */
    this.onCompleteFooterShowHideAnim = function(show){
        console.log("footer animation compelted for ",show);
        if(show==false){
            $('.betpanelparent').css({'display':"none","top":'210px'});
            _featureBet.onShowHideFeatureBet(!show);
        }
    };
    /**
     * Enable and Disable the confirm button disabler
     * @param {type} enable
     * @returns {undefined}
     */
    this.onEnaleConfirmBtn = function(enable){
        if(enable){
            $('.betconfirm-btn').css("opacity", "1");
            $('.betpanel-confirm-btn-disabler').hide();
        }else{
            $('.betconfirm-btn').css("opacity", "0.5");
            $('.betpanel-confirm-btn-disabler').show();
        }
    }
    /**
     * Enable and Disable the confirm button disabler
     * @param {type} enable
     * @returns {undefined}
     */
    this.onEnaleSkipBtn = function(enable){
        if(enable){
            console.log("onEnableSkipBtn call 2");
            $('.skip-btn').css("opacity", "1");
            $('.betpanel-skip-btn-disabler').hide();
        }else{
            $('.skip-btn').css("opacity", "0.5");
            $('.betpanel-skip-btn-disabler').show();
        }
    }
};
var _gameFooter = null;
function GameCommonContainer(){
    'use strict';
   
   var selectedMsgOption = '';
   var chatMsgs = '';
 
   /*
    * name : init
    * desc : It creates settings,chat and bet button on screen.
   */
   this.init = function(){
        $("#gamePlayContainer").append( '   <div id="settingsContainer" class="game-settings-container">  '  + 
 '       <div id="soundHandler" class="sound-handler normal-highlight" onclick="_lobbySetting.onSetOptionClick(this.id);">  '  + 
 '           <span id="soundTxt" class="sound-txt">SOUND</span>  '  + 
 '       </div>  '  + 
 '       <div id="privacyPolicyHandler" class="privacy-policy-handler normal-highlight" onclick="_lobbySetting.onSetOptionClick(this.id)">  '  + 
 '           <span id="privacyPolicyTxt" class="privacy-policy-txt">PRIVACY POLICY</span>  '  + 
 '       </div>  '  + 
 '       <div id="TandCHandler" class="tandc-handler normal-highlight" onclick="_lobbySetting.onSetOptionClick(this.id)">  '  + 
 '           <span id="TandCTxt" class="tandc-txt">TERMS & CONDITION</span>  '  + 
 '       </div>  '  + 
 '       <div id="helpHandler" class="help-handler normal-highlight" onclick="_lobbySetting.onSetOptionClick(this.id)">  '  + 
 '           <span id="helpTxt" class="help-txt ">HELP</span>  '  + 
 '       </div>  '  + 
 '       <div id="supportHandler" class="support-handler normal-highlight" onclick="_lobbySetting.onSetOptionClick(this.id)">  '  + 
 '           <span id="supportTxt" class="support-txt ">SUPPORT</span>  '  + 
 '       </div>  '  + 
 '   </div>  '  + 
 '   <div class="mybets-btn autoskip_inactive" id="myBetsBtn" onclick="_gameFooter.onBetInfoHandler();">  '  + 
 '       <div class="my-txt ">MY</div>  '  + 
 '       <div class="bets-txt ">BETS</div>  '  + 
 '   </div>  '  + 
 '   <div class="autoskip-btn autoskip_inactive" id="autoSkipBtn" onclick="_gameCommonContainer.onAutoskipHandler(this.id);">  '  + 
 '       <div class="auto-txt ">AUTO</div>  '  + 
 '       <div class="skip-txt ">SKIP</div>  '  + 
 '   </div>  '  + 
 '   <div id="chatMsgContainer" class="chat-msg-container"></div>  '  + 
 '  <div class="bet-info-btn ok_can_btn" id="betInfoBtn" onclick="_gameCommonContainer.onBetInfoHandler();">BETS INFO</div>  '+
 '<div id="dealerTip" class="dealer-tip dealer-tip-heartbeat tips" onclick="_gameCommonContainer.onTipSend();"></div>');  
 
        for(var i=0;i<CHAT_MSGS.length;i++){
            chatMsgs = chatMsgs +  '<div id="chatMsg_'+i+'" class="chatMsg-'+i+' normal-highlight chat-msg-setup" onclick="_gameCommonContainer.onChatMsgClick(this.id)">  '  + 
 '           <span id="chatMsgTxt" class="chatMsg-txt">'+CHAT_MSGS[i]+'</span>  '  + 
 '           </div>'; 
        }
        $('.chatMsg-0').css({
            'margin-top': '0px'
        });
        document.getElementById("chatMsgContainer").innerHTML = chatMsgs;
    };
    /*
    * name : onChatMsgClick
    * desc : Predefined Chat message sending to server.
    */
    this.onChatMsgClick = function(_id){
        if(selectedMsgOption !== _id){
            if(selectedMsgOption !== ''){
              $(selectedMsgOption).removeClass('selected-highlight');
              $(selectedMsgOption).addClass('normal-highlight');
            }
            selectedMsgOption = '#'+_id;
            if(!$(selectedMsgOption).hasClass('selected-highlight')){
              $(selectedMsgOption).removeClass('normal-highlight');
              $(selectedMsgOption).addClass('selected-highlight');
            }
            var obj = {
                "action" : "ChatRequest",
                "sessionId" : USER_SESSION_ID,
                "tableId" : TABLE_ID,
                "chatMessage" : CHAT_MSGS[_id.split('_')[1]]
            };
            _tableScoketHandling.onSendTableSocketRequest(obj);
        }
        _gameCommonContainer.enableChatWindow();
    };
    /*
    * name : enableChatWindow
    * desc : Enable/Disable chat window.
    */
    this.enableChatWindow = function(){
        if(!CHAT_WINDOW_FLAG){
            $('.chat-msg-container').slideDown('fast');
            _gameTopBar.selectChat(true);
            CHAT_WINDOW_FLAG = true;
        }else{
            $(selectedMsgOption).removeClass('selected-highlight');
            $(selectedMsgOption).addClass('normal-highlight');
            selectedMsgOption = '';
            $('.chat-msg-container').slideUp('fast');
            _gameTopBar.selectChat(false);
            CHAT_WINDOW_FLAG = false;
        }
    };
    /*
     * name : onAutoskipHandler
     * desc : Autoskip of next hand.
    */
    this.onAutoskipHandler = function(_id){
        console.log("onAutoskipHandler");
        if($('#'+_id).hasClass('autoskip_active')){
            $('#'+_id).removeClass('autoskip_active');
            $('#'+_id).addClass('autoskip_inactive');
        }else{
            $('#'+_id).removeClass('autoskip_inactive');
            $('#'+_id).addClass('autoskip_active');
        }
    };    
    /*
     * tip to dealer
     * @param {}
     * @returns {undefined}
     */
    this.onTipSend = function(){
        var obj = {
                    "action" : "TipRequest",
                    "sessionId" : USER_SESSION_ID,
                    "tableId" : TABLE_ID
                };
        _tableScoketHandling.onSendTableSocketRequest(obj);
    };
    this.init();
};
function SeatAnimation(){
    'use strict';
    var potAmountposition = {'top': '300px','left': '815px'};
    var dealerposition = {'top': '200px','left': '900px'};
    var player_0 = {'left': '1460px','top': '260px'};
    var player_1 = {'left': '1500px','top': '585px'};
    var player_2 = {'left': '860px','top': '750px'};
    var player_3 = {'left': '240px','top': '590px'};
    var player_4 = {'left': '295px','top': '260px'};
    var xpPosition = {'left': '920px','top': '600px'};
    
    this.init = function(){
        for(var i=0; i<5;i++){
            $('.seat-anim-container').append( '<div class="chip-'+i+'-holder" id="chip'+i+'Holder">  '  + 
 '       <div class="chip-'+i+'-bg" id="chip'+i+'Bg"></div>  '  +               
 '       <div class="chip-'+i+'-stake player_stake" id="chip'+i+'Stake"></div>  '  + 
 '       <div class="chip-'+i+'-value" id="chip'+i+'Value">500</div>  '  + 
 '  </div>  ');
        }
        $('.seat-anim-container').append('<div class="xp-holder position" id="xpHolder">  '  + 
 '       <div class="xp-bg xp_bg" id="xpBg"></div>  '  + 
 '       <div class="xp-stake xp" id="xpStake"></div>  '  + 
 '       <div class="xp-value" id="xpValue">+5</div>  '  + 
 '  </div>  ');
    };
    /*
     * name : chipAnim
     * desc : Chip animation from player.
     * param : seatId , amount , animto(animation from player to dealer/pot amount)
    */
    this.chipAnim = function(seatId,amount,animationTo,duration,callback){
      var position = '';
      var animTo = '';
      var objAnimTo = {
            'dealer':function(){
                position = 'position';
                animTo = dealerposition;
            },
            'potamount':function(){
                position = 'position';
                animTo = potAmountposition;
            },
            'player_0':function(){
                position = 'potAmountposition';
                animTo = player_0;
            },
            'player_1':function(){
                position = 'potAmountposition';
                animTo = player_1;
            },
            'player_2':function(){
                position = 'potAmountposition';
                animTo = player_2;
            },
            'player_3':function(){
                position = 'potAmountposition';
                animTo = player_3;
            },
            'player_4':function(){
                position = 'potAmountposition';
                animTo = player_4;
            }
        };
      objAnimTo[animationTo]();
      $('.seat-anim-container').show();
      $('.chip-'+seatId+'-holder').addClass(position);
      $('.chip-'+seatId+'-value').text(amount);
      $('.chip-'+seatId+'-holder').show();
      _sound.play('chipMove');
      $('.chip-'+seatId+'-holder').animate(
        animTo,
        duration,
        function(){
            $('.chip-'+seatId+'-holder').hide();
            $('.chip-'+seatId+'-holder').css({
                'top': '',
                'left': ''
            });
            $('.chip-'+seatId+'-holder').removeClass(position);
            
            if(callback !== undefined){
               callback();
            }
        });  
    };
    /*
     * xp animation done here.
     * {number} duration
     * {function} callback
     */
    this.xpAnim = function(value,duration,callback){
        $('.xp-holder').addClass('position');
        $('.xp-value').text(value);
        $('.xp-holder').show();
        $('.xp-holder').animate(
            xpPosition,
            duration,
            function(){
                if(callback !== undefined){
                   callback();
                }
                //$('.xp-holder').removeClass('position');
                $('.xp-holder').addClass('puffOut');
                setTimeout(function(){                    
                    $('.xp-holder').removeClass('puffOut');
                    $('.xp-holder').hide();
                    $('.xp-holder').css({
                        'top': '',
                        'left': ''
                    });
                    $('.xp-holder').removeClass('position');
                },1000);
        });  
    };
    this.init();
}
function GamePage(){
    'use strict';
    var waitForNextGameTimer = {};
    
    var gameContainer =  '   <div class="game-area-container" id="gameAreaContainer">  '  + 
 '       <div class="game-play-container" id="gamePlayContainer">  '  + 
 '           <div id="gameDealer" class="game-dealer dealer"></div>  '  + 
 '           <div class="game-table" id="gameTable"><div class="game-table-bg"></div></div>  '  + 
 '           <div id="tableInfoContainerId" class="tableInfoContainer"></div>  '  + 
 '           <div id="seatContainerId" class="seatContainer"></div>  '  + 
 '           <div id="seatAnimContainer" class="seat-anim-container"></div>  '  + 
 '       </div>  '  + 
 '       <div class="game-header" id="gameHeader"></div>  '  + 
 '       <div class="game-footer" id="gameFooter"></div>  '  + 
 '  </div>  ' ;
     
    /*
     * initiates game page.
     * @param {object} obj
     * @returns {undefined}
     */
    this.init = function (obj) {
        if(!obj) return;
        
        FORCED_GAME_TO_DISCONNECT = false;
        IS_PLAYER_WAIT_FOR_NEXT_ROUND = false;
        
        USER_TOTAL_TIMER = Number(obj.userTotalTimer); 
        CURRENT_USER_SEAT_INDEX = obj.currentSeatIndex;
        CURRENT_USER_ID = obj.currentUserId;
        USER_TOTAL_TIMER = obj.userTotalTimer;
        USER_WARNING_TIME = Math.round(USER_TOTAL_TIMER - (USER_TOTAL_TIMER*0.6));
        USER_FREEZE_TIME = Math.round(USER_TOTAL_TIMER - (USER_TOTAL_TIMER*0.8));
        
        console.log("***CURRENT_USER_ID : "+CURRENT_USER_ID+" CURRENT_USER_SEAT_INDEX : "+CURRENT_USER_SEAT_INDEX);
        
        if(!IS_GAME_RECONNECTED){
            document.getElementById("main-inner-container").innerHTML = gameContainer;
            _gamePage.onGameClassInitialization();
        }
        _gameTopBar.init(obj);
        _gameFooter.init(obj);    
        _gamePage.onGameResetBeforeStart(obj);
        IS_GAME_RUNING = obj.interrupt;
        
        if(IS_MY_TURN)
            _seatManager.onShowHideBetHighlight(CURRENT_BET_OPTION_USER_SEATID,1);//CURRENT_BET_OPTION_USER_SEATID set value in Footer init
            
        if(obj.houseCard !== undefined){          
            _gameTable.onHouseCardShow(obj.houseCard,true);
        }
        _gamePage.onUserInterrupt(obj);
        if(obj.actionMessage !== undefined){
           _gameTable.onDealerCommonMsgShow(true,obj.actionMessage);
        }
        if(obj.betsInfo !== undefined){
           _featureBet.onOpponentBetsUpdation(obj.betsInfo); 
        }
        
        if(GAME_TABLE_DETAILS !== null && !obj.interrupt){
            _gameEnteringScreen.enteringScreenShow(GAME_TABLE_DETAILS);
        }
        
        //-----call to lobby for inform that game is loaded successfully to hide lobby-----
        if(TEST_GAME_ALONE==false)
            onGameLoadSuccessfully();
        
        $("#game-main-container").show();
        
        if(IS_GAME_RECONNECTED){
            IS_GAME_RECONNECTED = false;
        }else{
            _gameResize.doResize();
        }
    };
    /*
     * 
     * @returns {undefined}
     */
    this.onGameResetBeforeStart = function(obj){
        _gameTable.onClearTableCards();
        //_gameTopBar.onHistroyHandler(obj.gameHistory);
        //_gameTable.onUpdatePotAmount(obj.totalPotAmount);
        _seatManager.resetAllTextValues(-1,true);
        _seatManager.resetAndarBaharBet(-1,true);
        _betHandling.onResetOwnBetValues();
        _betHandling.onCreateBetRequestObj();

        //---feature bet values reset for next game
        IS_MY_TURN = false;
        IS_GAME_RUNING = false;
        IS_OPPONENT_PLAYER_SELECTED = false;
        OPPONENT_BET_USER_SESSIONID = null;
        IS_ENABLED_FEATURE_BET = false;
        IS_PLAYER_WAIT_FOR_NEXT_ROUND = false;
        FEATURE_BET_SELECTED_SEAT_INDEX=-1;

        CURRENT_USER_SEAT_INDEX = obj.currentSeatIndex;
        CURRENT_USER_ID = obj.currentUserId;

        BET_TYPE = 1;
        CURRENT_BET_OPTION_USER_SEATID = 0;
        ORIGINAL_SEAT_ORDER = [0,1,2,3,4];
        SHUFFLED_SEAT_ORDER = {};
        SEAT_INDEX = {};
        OPPONENTS_SESSION_ID_LIST = {};
        if(PLAYERS_OBJ){
            for(var player in PLAYERS_OBJ){
                delete PLAYERS_OBJ[player];
            }
        }
        PLAYERS_OBJ = {};
        _featureBet.onResetPlayersFeatureBetPanel();

        _seatManager.onPrepareSeatOrder();
        _seatManager.onShowHideSeatGlow(-1,true);
        _seatManager.onShowEmptySeat(-1,true);
        _seatManager.onSeatInitialize(obj);
        _seatManager.removeChipAnim();
        _seatManager.onHideAllSeatBetHighlight();
        //_gameFooter.onResetFooter();
        _gameFooter.onShowWaitingMsgHolder(false);
        
        var disconnectPlayerCnt = 0;
        var i=0;
        for(i=0;i<obj.userLists.length;i++){
            //_seatManager.onUpdateUserBalance(obj.userLists[i].seatIndex,obj.userLists[i].tempBalance);
            _seatManager.onUpdateUserName(obj.userLists[i].seatIndex,obj.userLists[i].userName);
            _seatManager.OnChangeAndarOrBaharBetBg(obj.userLists[i].seatIndex,"default",1);
            _seatManager.OnChangeAndarOrBaharBetBg(obj.userLists[i].seatIndex,"default",2);
            
            if(obj.userLists[i].isConnect){
                disconnectPlayerCnt++;
                _seatManager.onShowDisconnection(obj.userLists[i].seatIndex,true,_localization.getText['disconnected']);
            }
        }
        
        if(obj.userLists.length === 1 || ((obj.userLists.length-1) === disconnectPlayerCnt)){
            _gameTable.onDealerCommonMsgShow(true,_localization.getText['wait_for_opponent']);
        }
        
        clearInterval(USER_TIMER);
        clearInterval(CARD_DEAL_TIMER);
        IS_USER_TIMER_RUNNING = false;
    };
    this.onGameClassInitialization = function(){
        _localization = new Localization();
        _opponentBetHandling = new OpponentBetHandling();
        _betHandling = new BetHandling();   
        _gameFooter = new GameFooter();
        _seatAnimation = new SeatAnimation();
        _seat = new Seat();
        _seatManager = new SeatManager();
        _gameTopBar = new GameTopBar();
        _gameTable = new GameTable();
        _gameCommonContainer = new GameCommonContainer();
        if(_gameEnteringScreen === null){
            _gameEnteringScreen = new GameEnteringScreen();        
        }
    };
    /*
     * name : onUserInterrupt
     * desc : handling 
    */
    this.onUserInterrupt = function(obj){
        var i=0;
        
        if(obj.interrupt){
            MIN_BET = obj.minBet;
            MAX_BET = obj.maxBet;
            TOTAL_ANDAR_BET = Number(obj.andarBet?obj.andarBet:0);
            TOTAL_BAHAR_BET = Number(obj.baharBet?obj.baharBet:0);
            TOTAL_BET = (TOTAL_ANDAR_BET+TOTAL_BAHAR_BET);
            TOTAL_OWN_BET = Number(obj.totalOwnBet?obj.totalOwnBet:0);            
            if(obj.glowList !== undefined){
                _seatManager.onUpdatePlayerGlow(obj.glowList);
            }
        }
        if(obj.gameCards !== undefined){
            _gameTable.onDealCardDisplay(obj.gameCards,obj.gameCards.cardTypeId);
        }
        if(!obj.interrupt){
            _gameTable.onDealerMsgShow(true,_localization.getText['txt_welcome']+" "+obj.currentUserName,5000);
        }
        if(obj.userTimer !== undefined){
            if(obj.currentSeatIndex === obj.userTimer.seatIndex){
                _gamePage.onPlayerTimerHandling(obj.userTimer);
            }else{
                _gamePage.onOpponentTimerHandling(obj.userTimer);   
            }
        }
        if(!obj.interrupt && obj.isGameRunning){
            IS_PLAYER_WAIT_FOR_NEXT_ROUND = true;
            /*waitForNextGameTimer = setTimeout(function(){
                clearTimeout(waitForNextGameTimer);
                _gameFooter.onShowWaitingMsgHolder(true);
            },2000);*/
            
        }
        for(i=0;i<obj.userLists.length;i++){
            _seatManager.onUpdateUserBalance(obj.userLists[i].seatIndex,obj.userLists[i].tempBalance);
            _seatManager.onUpdateUserName(obj.userLists[i].seatIndex,obj.userLists[i].userName);
            _seatManager.onUpdateAndarBaharBet(obj.userLists[i].seatIndex,obj.userLists[i].baharBet,1);
            _seatManager.onUpdateAndarBaharBet(obj.userLists[i].seatIndex,obj.userLists[i].andarBet,2);
            _seatManager.onUpdateAndarBaharAvailableBet(obj.userLists[i].seatIndex,obj.userLists[i].baharBetBalance,1);
            _seatManager.onUpdateAndarBaharAvailableBet(obj.userLists[i].seatIndex,obj.userLists[i].andarBetBalance,2);
            if(obj.userLists[i].baharBet > 0){                
                _seatManager.OnChangeAndarOrBaharBetBg(obj.userLists[i].seatIndex,'bahar',1);
            }else{
                _seatManager.OnChangeAndarOrBaharBetBg(obj.userLists[i].seatIndex,'default',1);
            }
            
            if(obj.userLists[i].andarBet > 0){
                _seatManager.OnChangeAndarOrBaharBetBg(obj.userLists[i].seatIndex,'andar',2);
            }else{
                _seatManager.OnChangeAndarOrBaharBetBg(obj.userLists[i].seatIndex,'default',2);
            }
            
            if(obj.userLists[i].isConnect){
                _seatManager.onShowDisconnection(obj.userLists[i].seatIndex,true,_localization.getText['disconnected']);
            }
        }    
        if(obj.disconnectTimer !== undefined){
           _seatManager.onShowDisconnection(obj.disconnectTimer.seatIndex,true,_localization.getText['connected'],
                                            obj.disconnectTimer.countTimer); 
        }
        if(obj.disconnectExtraTimer !== undefined){
           _seatManager.onShowDisconnection(obj.disconnectExtraTimer.seatIndex,true,_localization.getText['extra_timer'],
                                            obj.disconnectExtraTimer.countTimer); 
        }
        if(obj.currentTimerSeatIndex !== undefined){
            _seatManager.onShowHideTimerHighlight(obj.currentTimerSeatIndex);
        }
    };
    /*
     * It handles own player timer
     * @param {object} obj
     * @returns {undefined}
     */
    this.onPlayerTimerHandling = function(obj){
        if(!IS_USER_TIMER_RUNNING && obj.countTimer > 0){
            if(_seatManager !== null){
                IS_USER_TIMER_RUNNING = true;
                IS_MY_TURN = true;
                IS_GAME_RUNING = true;
                _seatManager.onUpdateTimer(obj.seatIndex,obj.countTimer);

                TIMER_COUNT =  obj.countTimer - 1;
                USER_TIMER = setInterval(function(){
                    _seatManager.onUpdateTimer(obj.seatIndex,TIMER_COUNT);
                    if(TIMER_COUNT <= 2){
                        _gameFooter.onResetValuesToNextTimer(obj.seatIndex);
                        _gameFooter.onSendAutoBetRequest();
                    }
                    TIMER_COUNT-- ;
                },1000);

                BET_TYPE = 1;
                IS_OPPONENT_PLAYER_SELECTED = false;
                _betHandling.onCreateBetRequestObj();
                CURRENT_BET_OPTION_USER_SEATID = CURRENT_USER_SEAT_INDEX;
                CURRENT_SELECTED_SEAT_ID = 2;
                _seat.onBlinkHighlight("both");
                _gameTable.onDealerCommonMsgShow(true,obj.userName+" is playing");
                _seatManager.onShowHideTimerHighlight(obj.seatIndex);
                _gameFooter.onEnaleSkipBtn(true);
                _gameFooter.onEnaleConfirmBtn(false);
                _seat.onShowCurrentPlayerAlertMsg(_localization.getText['select_opponent_avatar'],5000);
                _gameFooter.onShowHideFooter(true,true);
            }
        }
    };
    /*
     * It handles opponent player timer.
     * @param {object} obj
     * @returns {undefined}
     */
    this.onOpponentTimerHandling = function(obj){
        if(obj.countTimer === (USER_TOTAL_TIMER-1)){
            _seatManager.onShowHideTimerHighlight(obj.seatIndex);     
            _gameTable.onDealerCommonMsgShow(true,obj.userName+" is playing");
        }          
        IS_MY_TURN = false;
        IS_GAME_RUNING = true;
        
        if(!IS_USER_TIMER_RUNNING && obj.countTimer > 0){
            if(_seatManager !== null){
                IS_USER_TIMER_RUNNING = true;
                _seatManager.onUpdateTimer(obj.seatIndex,obj.countTimer);                
                TIMER_COUNT =  obj.countTimer - 1;
                USER_TIMER = setInterval(function(){
                    _seatManager.onUpdateTimer(obj.seatIndex,TIMER_COUNT); 
                    if(TIMER_COUNT < 1){
                        _seatManager.onHideTimerSeatGlowBetHighlight(obj.seatIndex);
                    }
                    TIMER_COUNT-- ;
                },1000);
            }
        }
    };
    /*
     * name : dispose
     * desc : dispose all variables in to null and "" here.
    */
    this.dispose = function(){
        gameContainer = "";
    };
}

/*
    * Handling preloader functionality here.
*/
function Preloader(){
    'use strict';
    
    /*
     * name : loadAssets
     * desc : It handles loading assets using given array
     * callback : onprogress
     * complete : oncomplete
    */
    this.loadAssets = function(assetsArray,onprogress,oncomplete){
        var counter =0;
        var totalLoaded =0;
        var increment = 100 / assetsArray.length;
        var loadingPercentage=0;
        var image;
        for(var t=0; t<assetsArray.length; t++){
           image = new Image();

           image.src = "assets/images/"+assetsArray[t];
           counter++;
           totalLoaded += increment;           
           loadingPercentage = Math.floor(counter*increment);
           onprogress(loadingPercentage);           
        }
        image.onload = function () {         
          if(loadingPercentage===100){
            oncomplete(loadingPercentage);
          }       
       }
   }
}
/*
* Handling game functionality here.
*/
function Main(){
    'use strict';
    
     var preloadArray = ["table.png","bg.jpg","game.png","cards.png"];     
     var gamePlayArea = '<div id="main-inner-container"><div class="game-preloader-container"><div id="game-preloaderTxt" class="game-preloader-txt">00%</div></div></div>';
     
     /*
     * name : init
     * desc : intiates preloader functionality
    */
    this.init = function(){
        var _preloader = new Preloader();        
        _preloader.loadAssets(preloadArray,onProgress,onComplete);
        _preloader=null;
        
        function onProgress(e){
            $("#game-preloaderTxt").text(e + " %");
        }
        function onComplete(e){           
            document.getElementById("game-main-container").innerHTML = gamePlayArea;
            $("#game-preloaderTxt").hide();
            
            //---create innerlobby class instance---
            _tableScoketHandling = new TableSocketHandling();
            _gameResize = new GameResize();
           
            _tableScoketHandling.onCreateSocketConnection();
        }
    };
    /**
     * Need to reset all static vars when player enter to game at every time
     * @returns {undefined}
     */
    this.onResetStaticKeys = function(){
        IS_GAME_RECONNECTED = false;
        USER_TOTAL_TIMER = 0;
        USER_WARNING_TIME = 0;
        USER_FREEZE_TIME = 0;
        CURRENT_USER_SEAT_INDEX = 0;
        CURRENT_USER_ID = 0;
        ORIGINAL_SEAT_ORDER = [0,1,2,3,4];
        SHUFFLED_SEAT_ORDER = {};
        SEAT_INDEX = {};
        MIN_BET = 0;
        MAX_BET = 0;
        OPPONENTS_SESSION_ID_LIST = {};
        PLAYERS_OBJ = {};
        IS_MY_TURN = false;
        IS_GAME_RUNING = false;
        IS_OPPONENT_PLAYER_SELECTED = false;
        OPPONENT_BET_USER_SESSIONID = null;
        IS_ENABLED_FEATURE_BET = false;
        IS_FUTUREBET_REQUEST_SENT = false;
        IS_PLAYER_WAIT_FOR_NEXT_ROUND = false;
        IS_PLAYER_CLICKED_LEAVE_TABLE = false;
        FEATURE_BET_SELECTED_SEAT_INDEX = -1;
        TABLE_ID = -1;//enable this while game release, set 10001 enable this to run game alone
        BET_TYPE = 1;
        GAME_TABLE_DETAILS = {};
        CURRENT_BET_OPTION_USER_SEATID = 1;
        BALANCE = 0;
        TOTAL_ANDAR_BET = 0;
        TOTAL_BAHAR_BET = 0;
        TOTAL_BET = 0;
        TOTAL_OWN_ANDAR_BET = 0;
        TOTAL_OWN_BAHAR_BET = 0;
        TOTAL_OWN_BET = 0;
        CURRENT_SELECTED_CHIP = 0;
        OPPONENT_BET_BALANCE = 0;
        CURRENT_SELECTED_SEAT_ID = 2;//for current palyer center seat
        BET_REQUEST_OBJ = {};
        BET_REQUEST_OBJ_KEY_ARR = [0,1,3,4];
        SELECTED_OPPONENT_BET_VARIANTTYPE = 1;
    };
}
var _main = null;
var _webSocket = new websocketEngine();
var _webSokcetIO = new SocketIOEngine();
var _tableScoketHandling = null;
var _betHandling = null;
var _gamePage = null;
var _featureBet = null;
var _gameResize = null;
var _seat = null;
var _seatManager = null;
var _opponentBetHandling = null;
var _gameResponseHandling = null;
var _gameTable = null;
var _gameCommonContainer = null;
var _gameSoundPopup = null;
var _gameHelpPopup = null;
var _betsInfo = null;
var _seatAnimation = null;
var _gameEnteringScreen = null;
var _localization = null;
/*
    * name : onInitGame
    * desc : it used to load game
*/ 
function onInitGame(_tabledetails){
    _googleAnalytics.onTrackScreen(_lobbyLocalization.getText['txt_screen_game']+(_tabledetails?("_"+_tabledetails.tableName):""));
    _main = new Main();
    _main.onResetStaticKeys();
    if(_tabledetails !== undefined){
       TABLE_ID = _tabledetails.tableId;
       GAME_TABLE_DETAILS = _tabledetails;
    }
    _main.init();
}

/**
 * dispose all the thing from game when game kill that mean user get lobby 
 */
function onExitGame(){
    if(_tableScoketHandling){
        _tableScoketHandling.dispose();
        _tableScoketHandling = null;
    }
    if(_gamePage){
        _gamePage.dispose();
        _gamePage = null;
    }
    if(_seatManager){
        _seatManager.dispose();
        _seatManager = null;
    }
    _betHandling = null;
    _main = null;
    clearInterval(USER_TIMER);
    clearInterval(CARD_DEAL_TIMER);
    IS_USER_TIMER_RUNNING = false;
    if(TEST_GAME_ALONE==false)
        onUserBackToLobbyFromGame();
}

/**
 * Clear game after lobby loaded successfully
 * @returns {undefined}
 */
function onClearGame(){
    $("#game-main-container").hide();
    $(".main-inner-container").empty();
    $("#game-main-container").empty();
    IS_PLAYER_CLICKED_LEAVE_TABLE = false;
}

if(TEST_GAME_ALONE)
    onInitGame();

//----MUST SET TEST_GAME_ALONE = false IN Statickey.js class WHEN GAME GO TO RELEASE----//